2012-09-16  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/dtree.js (s): when selecting a node,
	also select the parent so the entire row is highlighted.

2012-09-13 Ludovic Marcotte  <lmarcotte@inverse.ca>

	* Fixed bug #1942. We now set the app name to "SOGo"
	for the Samba/OpenChange application so wox are properly
	found by SOPE.

2012-09-12  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* OpenChange/MAPIStoreTasksMessage.m: added a way to get
	the PidTagBody of a task. This could be generalized eventually
	with the code in MAPIStoreAppointmentWrapper.
	* OpenChange/MAPIStoreMessage.m (-saveMessage): added a safety
	check to avoid a crash when first accepting invitations on
	a newly created profile.

2012-09-07  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/SchedulerUI.js (tasksListCallback): list
	the tasks in a table, along the events table.
	(saveTabState): save which of the events or the tasks tab is
	selected.

	* UI/WebServerResources/SOGoTabsController.js
	(attachToTabsContainer): select and show the active tab if it's
	defined.

	* UI/WebServerResources/HTMLTableElement.js (getSelectedRows):
	accept calling this method from a "tbody".

	* UI/Scheduler/UIxCalMainView.m (-saveSelectedListAction): new
	method to save the name of the selected tab (events or tasks).
	(-eventsTabClass): return "active" if the selected tab was "events".
	(-tasksTabClass): idem for "tasks".

	* UI/Scheduler/UIxCalListingActions.m (-tasksListAction): added
	more quick fields, including the calendar name, location, category
	and a formatted version of the due date.

2012-09-07  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreContext.m (CompleteURLFromMapistoreURI):
	mapistore uris are already escaped.
	(-getRootFolder:withFID:): all urls are now escaped, both in NSURL
	and in NSString forms, whether they are used to return a mapitore
	root uri or a indexing record.

	* OpenChange/NSString+MAPIStore.m
	(-stringByReplacingPercentEscapesUsingEncoding:): we now return
	nil for non-ascii strings.

2012-09-06  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/NSString+MAPIStore.m
	(-stringByReplacingPercentEscapesUsingEncoding:): reimplemented
	method properly, to work-around the weird behaviour of the
	original in GNUstep.

	* OpenChange/MAPIStoreMailContext.m
	(+listContextsForUser:withTDBIndexing:inMemCtx:): we escape the
	url string of non-ascii folder names.
	(+createRootSecondaryFolderWithFID:andName:forUser:): same as
	above.
	(+*): reverted all of the above.

	* OpenChange/MAPIStoreMailVolatileMessage.m
	(FillMessageHeadersFromProperties): build a recipient list for the
	"from" field from the list stored in the value for "orig" in the
	recipients dict.
	(FillMessageHeadersFromProperties): now take a "withBcc" parameter
	that defines whether the "bcc" field must be ignored in the header.
	(_generateMailDataWithBcc:): the above code enables use to remove
	the search and replace hack required to remove the "bcc" header in
	the message text.

2012-09-05  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreMailMessage.m (-getMessageData:inMemCtx:):
	property return recipients from all the "from", "to", "cc" and
	"bcc" header fields.

	* OpenChange/MAPIStoreCalendarAttachment.m
	(-getPidTagDisplayName:inMemCtx:): return an allocated value,
	since returned values must be assigned to another parent.

2012-09-04  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/SOGo/WORequest+SOGo.m (-isMacOSXAddressBookApp):
	recognize OS X 10.8 useragent.
	(-isICal4): idem.

2012-08-28  Jean Raby  <jraby@inverse.ca>

	* Scripts/openchange_cleanup.py:
	New script to clean an openchange user profile

2012-08-27  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/Appointments/SOGoAptMailInvitation.m,
	SoObjects/Appointments/SOGoAptMailNotification.m,
	SoObjects/Appointments/SOGoAptMailDeletion.m,
	SoObjects/Appointments/SOGoAptMailUpdate.m,
	SoObjects/Appointments/SOGoAptMailICalReply.m,
	SoObjects/Appointments/SOGoCalendarComponent.m: send HTML messages
	instead of text/plain.

	* UI/WebServerResources/generic.js (openMailTo): mail addresses
	must now be separated by semi-colons and not commas. This allow
	display names to contain commas.

	* UI/WebServerResources/SchedulerUI.js (tasksListCallback): prefix
	tasks with a color box instead of changing the task's background color.

	* UI/Scheduler/UIxCalListingActions.m
	(-_getStatusClassForStatusCode:andEndDateStamp::): set the
	timezone of the due date to the user's timezone to properly
	identify tasks due today.

2012-08-27  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* SoObjects/Appointments/iCalPerson+SOGo.m (mailAddress):
	We now properly add double-quotes if we find a comma and
	the person's name isn't already double-quoted. Fixes #1649

2012-08-24  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/MailPartViewers/UIxMailPartHTMLViewer.m (-_sanitizeContent):
	fix invalid void tags to insure proper HTML decoding. Fixes #1581.

2012-08-23	Ludovic Marcotte  <lmarcotte@inverse.ca>

	* SoObjects/Mailer/SOGoMailFolder.m - added safety
	checks around the ACL code so we don't crash if
	we can't read the ACLs.

2012-08-21  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreFolder.m (-getPidTagAccessLevel)
	(-getPidTagRights, -getPidTagAccessControlListData): fixed
	methods.

	* OpenChange/MAPIStoreMessage.m
	(-getPidTagDeleteAfterSubmit:inMemCtx:): moved from
	MAPIStoreMailMessage.

	* OpenChange/MAPIStoreContactsMessage.m
	(-getPidTagAlternateRecipientAllowed:inMemCtx:)
	(-getPidTagMessageFlags:inMemCtx:)
	(-getPidTagDeleteAfterSubmit:inMemCtx:): new getters.

	* OpenChange/MAPIStoreGCSFolder.m
	(-setChangeKey:forMessageWithKey:): removed useless method.
	(-updateVersionsForMessageWithKey:withChangeKey:): set the change
	key provided by the client as member of the predecessor
	changelist, but never as the actual change key for the object.
	This hopefully fixes the issue where Outlook deletes objects that
	have a different change list than what they expect.

2012-08-17  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreCalendarMessage.m
	(-getPidTagMessageClass:inMemCtx:): return
	"IPM.Schedule.Meeting.Request" when the owner user is an attendee.

	* OpenChange/MAPIStoreAppointmentWrapper.m
	(-getPidLidAppointmentNotAllowPropose:inMemCtx): new getter that
	always return "YES", in order to disallow counter proposals.

	* OpenChange/MAPIStoreContext.m (-getPath:ofFMID:inMemCtx:):
	properly escape urls containing non-ascii chars.
	(-getRootFoldeR:withFID:): idem.

2012-08-16  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreCalendarMessage.m
	(-getMessageData:inMemCtx:): when a "recipients" records is
	available in the properties, we must return that list instead of
	the list of attendees since it will be the most recent one.
	(_fixupAppointmentObjectWithUID::): when an appointment had been
	deleted, we first attempt to resurrect it from the database before
	reinstantiating it, which allows the event synchronisation to
	happen properly in [SOGoAppointmentObject
	updateContentWithCalendar:fromRequest:].

	* OpenChange/MAPIStoreMapping.m (_updateFolderWithURL:withURL:):
	we retain and release "oldURL" to avoid releasing it when it
	is replaced in the list of urls to modify.

	* OpenChange/MAPIStoreAppointmentWrapper.m
	(-getPidTagInternetCodepage:inMemCtx:): new getter for a property
	that is sometimes requested.
	(-getPidTagBody:inMemCtx:): we return an empty string when no
	"description"/"comment" is actually present.

2012-08-15  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreMailFolder.m (-addProperties:): make use of
	the new methods below when a mail folder has been renamed, as this
	operation affects the url of mail objects.

	* OpenChange/SOGoMAPIDBObject.m (-setNameInContainer): update the
	object record in the database to reflect the change of folder
	name.

	* OpenChange/MAPIStoreMailContext.m (-updateURLWithFolderName):
	change the folder name used in the context url to use the new
	folder name after a rename operation, so that further invocations
	of -url will return the right url.

	* OpenChange/MAPIStoreMailFolder.m
	(-moveCopyToFolder:withNewName:isMove:isRecursive:): implemented
	IMAP-based copy operation, for speed.
	(-addProperties): restored the ability to rename IMAP folders by
	properly updating the fid/url mapping with our new methods.

2012-08-14  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreFolder.m (-moveToFolder:withNewName:):
	renamed to "moveCopyToFolder:withNewName:isMove:isRecursive:",
	with the ability to specify whether the operation is a move or
	copy operation and whether it is recursive or not (for copy).

	* OpenChange/MAPIStoreSOGo.m (sogo_folder_move_folder): if
	"target_folder_object", we do not attempt to access the
	corresponding instance member.

	* OpenChange/MAPIStoreMailFolder.m (-
	moveCopyMessagesWithMIDs:andCount:fromFolder:withMIDs:andChangeKeys:wantCopy:):
	do not attempt to access targetChangeKeys when NULL, to avoid a
	SEGFAULT.

2012-08-14  Jean Raby  <jraby@inverse.ca>

	* OpenChange/GNUmakefile: use version_info[{0,1}] instead of
	version_info.{major,minor} when checking for legacy version
	of python since these named attributes where added in python2.7

2012-08-13  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreSOGo.m (sogo_properties_get_uri): removed
	useless backend method.

	* OpenChange/MAPIStoreFolder.m (-createFolder:withRow:andFID:):
	append a "/" to the new folder url when registering with the
	url/id mapper.

	* OpenChange/MAPIStoreDBFolder.m (-moveToFolder:withNewName:):
	implemented method.

	* OpenChange/MAPIStoreMailFolder.m (-moveToFolder:withNewName:):
	invoke changePathTo: on the dbFolder.

	* OpenChange/SOGoMAPIDBFolder.m (-changePathTo:): overriden method
	in order to update children records too.

	* OpenChange/SOGoMAPIDBObject.m (-performBatchSQLQueries:) new
	method to perform void queries under a transaction.
	(-changePathTo:) new method that updates the references for the
	object record in the dbfs table.

	* SoObjects/SOGo/NSString+Utilities.m
	(-stringByReplacingPrefix:withPrefix:): new self-explicit method.

	* OpenChange/SOGoMAPIDBFolder.m
	(-childKeysOfType:includeDeleted:matchingQualifier:andSortOrderings:):
	records now have a c_parent_path column in order to avoid fetch
	the children of children due to the nature of our "LIKE" clause.

	* OpenChange/SOGoMAPIDBObject.m (-save): records now have a
	c_parent_path.

	* OpenChange/MAPIStoreMailFolder.m (-supportsSubFolders):
	overriden method to return YES.

2012-08-12  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreMailFolder.m (-moveToFolder:withName:): if
	the new name is not provided (unlikely), the computed new name
	must not have the "folder" prefix.
	We now also make use of -[MAPIStoreMapping updateID:withURL:] to
	change the references in the mapping database.

	* OpenChange/MAPIStoreFolder.m (-objectId): folder keys always end
	with a "/" by convention.

	* OpenChange/MAPIStoreMapping.m (-updateID:withURL:): new method
	that perform a change of url on container and leaf entries.

2012-08-10  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreSOGo.m (sogo_properties_get_uri): new
	backend method.

2012-08-10  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* Changed OpenChange/SOGoMAPIDBObject.m so we use
	GNUstep's binary encoding - which is an order or
	magnitude faster at encoding data than any other formats.

2012-08-10  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreSOGo.m (sogo_folder_move_folder)
	(sogo_folder_copy_folder): the object on which the backend method
	is invoked is now the folder being moved rather than its parent.

2012-08-09  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreMailFolder.m
	(-moveFolderWithFID:fromFolder:withNewName:): first implementation
	for IMAP folders.

	* OpenChange/MAPIStoreSOGo.m (sogo_folder_move_folder)
	(sogo_folder_copy_folder): new backend methods.
	(sogo_folder_move_folder): do not instantiate an NSString from a
	NULL "new_folder_name" parameter.

2012-08-08  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreCalendarMessage.m (-save): generate a
	"nameInContainer" for the new object iif it is not set yet. If
	set, we generate a new UID from it instead.

	* OpenChange/MAPIStoreMessage.m (-saveMessage): make sure that the
	PidTagChangeKey and PidTagChangeNumber props are no longer set in
	the properties dict after the save occurred.

	* OpenChange/MAPIApplication.m (-shouldSetupSignalHandlers):
	overriden method by returning "NO".

2012-08-07  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/Appointments/SOGoAptMailNotification.m (-setupValues):
	test whether each value is non-nil before adding it to the
	dictionary.

	* OpenChange/MAPIStoreMailVolatileMessage.m (-save): restored
	registration of message url when saved.

2012-08-06  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreRecurrenceUtils.m (-[iCalRecurrenceRule
	fillRecurrencePattern:withEvent:inTimeZone:inMemCtx:]): fixed a
	crash occurring when the exception has no recurrence-id and
	ignore the specific occurrence.

	* OpenChange/MAPIStoreMailVolatileMessage.m (MakeMessageBody):
	take "attachmentParts" parameter, deduced from the ivar with the
	corresponding name.

	* OpenChange/MAPIStoreSOGoObject.m (-objectId): force generation
	of objectId by parent, whether it is a folder or not.

2012-08-07  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/Contacts/UIxListEditor.m (-setReferencesValue:): check for
	duplicates in the new list, not in the previous version.

2012-08-03  Jean Raby  <jraby@inverse.ca>

	* SoObjects/SOGo/LDAPSource.m (changePasswordForLogin):
	if userPasswordAlgorithm was not set or was set to "none",
	use the plaintext password directly instead of using '{none}plaintext'
	which isn't valid.

2012-08-02  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* OpenChange/MAPIStoreUserContext.m (-_readUserPassword:)
	We now read per-user passwords instead of relying on
	a global file.

2012-07-31  Jean Raby  <jraby@inverse.ca>

	* sogo.spec:
	  Treat logrotate file as a config file (noreplace)

2012-07-31  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/SOGo/SOGoSieveManager.m
	(-sieveScriptWithRequirements:): filters must not be conditional
	to each other.

2012-07-26  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/iCalTimeZone+MAPIStore.[hm]: new category module.
	(-asTimeZoneStructInMemCtx:): new method that returns a struct
	TimeZoneStruct as a binary blob from an iCalTimeZone object.

	* OpenChange/MAPIStoreAppointmentWrapper.m
	(-getPidLidTimeZoneStruct:inMemCtx:): new property getter that
	returns the equivalent of the iCalTimeZone of the current event.

2012-07-25  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreDBFolder.m (-createFolder:withFID:andKey:):
	invoke "reloadIfNeeded" on the created folder object in order to
	initialize it.

2012-07-25  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/Mailer/SOGoMailFolder.m
	(-deleteUIDs:useTrashFolder:inContext:): fixed comparison with the
	trash folder name when using subfolders (ex: INBOX/Trash).

	* SoObjects/SOGo/SOGoSieveManager.m
	(-updateFiltersForLogin:authname:password:account:): write the
	filters before the vacation auto-reply.

	* SoObjects/Appointments/SOGoCalendarComponent.m
	(-sendEMailUsingTemplateNamed:forObject:previousObject:toAttendees:withType:):
	fixed the from header when the updated event has no mode organizer.

	* UI/WebServerResources/MailerUI.js (initMailer): define default
	columns widths when not set.

2012-07-24  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreUserContext.m
	(-initWithUsername:andTDBIndexing:): attempt to read the user
	password from a property list.

	* OpenChange/samba-get-config.py: new utility taking a samba
	configuration variable and prints the value on stdout

2012-07-24  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/UIxPreferences.js (savePreferences):
	validate the email address of the sender mail and reply-to fields.

2012-07-23  Jean Raby  <jraby@inverse.ca>
	* debian*/sogo.logrotate:
	  drop distro specific log rotate scripts
	* debian*/sogo.install
	* debian*/rules :
	  Use the logrotate script from Scripts/.

2012-07-20  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* UI/MailPartViewers/UIxMailRenderingContext.m
	(_shouldDisplayAsAttachment:): refactored to consider
	the "bodyId" parameter only for non text/* parts.

2012-07-20  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/MailerUI.js (onEmailTo): append the email
	address from the href attribute if it doesn't appear in the link content.

	* UI/MailPartViewers/UIxMailPartHTMLViewer.m
	(-startElement:namespace:rawName:attributes:): don't skip "mailto:"
	href.

	* SoObjects/Appointments/SOGoAptMailReceipt.m (aptSummary-): new
	method that returns a properly formatted string of the event title
	with respect to the current operation (creation/deletion/update).

2012-07-20  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/NSObject+MAPIStore.m (-getSMTPAddrType:inMemCtx:):
	new helper getter.

	* OpenChange/MAPIStoreSOGo.m
	(sogo_message_attachment_create_embedded_message): new backend method.

	* OpenChange/NSObject+MAPIStore.m
	(+fillAvailableProperties:withExclusions:): new method that fills
	an existing array of properties with properties existing in
	another class, as long as they are not listed in the array of
	exclusions.

	* OpenChange/MAPIStoreObject.m (-init): assigned a mutable array
	to "proxies"
	(-canGetProperty:): test the proxies for the availability of
	properties so that -getAvailableProperties:inMemCtx: can return an
	accurate result.

	* OpenChange/MAPIStoreMessage.m (-getPidTagSubject:inMemCtx:): now
	compute the return value based on PidTagNormalizedSubject and
	PidTagSubjectPrefix as PidTagSubject is never actually set from
	the client.

2012-07-19  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreObject.m (-nameInContainer): moved method
	from MAPIStoreSOGoObject and made mandatory for subclasses.
	(-url): new methed moved from MAPIStoreSOGoObject.

	* OpenChange/MAPIStoreAppointmentWrapper.m: now a subclass of
	MAPIStoreObjectProxy.

	* OpenChange/MAPIStoreCalendarMessage.m
	(-initWithSOGoObject:inContainer:): we now register our
	appointment wrapper as a proxy.

	* OpenChange/MAPIStoreObject.m (-addProxy:): new method that keeps
	proxy objects in the new "proxies" ivar.
	(-getProperty:withTag:inMemCtx:): added code that pass the request
	to the available object proxies, when the property getters have
	not been found in the local class.

	* OpenChange/MAPIStoreObjectProxy.[hm]: new class module that
	provide a facility for providing property getters in the name of
	another class, working around the fact that Objective-C does not
	provide multiple-inheritance.

	* OpenChange/NSObject+MAPIStore.m
	(+getAvailableProperties:inMemCtx:)
	(-getAvailableProperties:inMemCtx:, canGetProperty:): methods
	moved from MAPIStoreObject.m

2012-07-18  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreCalendarFolder.m (-createMessage): attach a
	WOContext to the newEntry in order to enable page templates
	resolution when notifications are sent.

	* OpenChange/MAPIApplication.m (-init): a WEResourceManager is
	setup for the application so that page templates can be properly
	be initialized.

	* OpenChange/MAPIStoreDBMessage.m (-objectVersion): shift the
	version number by 16 bits, instead of doing it in -save.
	(-save): don t swap the bytes of the version number as it would
	return a wrong change number and a wrong change key for DB objects.

2012-07-20  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/NSObject+MAPIStore.m (-getSMTPAddrType:inMemCtx:):
	new helper getter.

	* OpenChange/MAPIStoreSOGo.m
	(sogo_message_attachment_create_embedded_message): new backend method.

	* OpenChange/NSObject+MAPIStore.m
	(+fillAvailableProperties:withExclusions:): new method that fills
	an existing array of properties with properties existing in
	another class, as long as they are not listed in the array of
	exclusions.

	* OpenChange/MAPIStoreObject.m (-init): assigned a mutable array
	to "proxies"
	(-canGetProperty:): test the proxies for the availability of
	properties so that -getAvailableProperties:inMemCtx: can return an
	accurate result.

	* OpenChange/MAPIStoreMessage.m (-getPidTagSubject:inMemCtx:): now
	compute the return value based on PidTagNormalizedSubject and
	PidTagSubjectPrefix as PidTagSubject is never actually set from
	the client.

	* SoObjects/Appointments/SOGoAppointmentFolder.m
	(_appendCycleException:firstInstanceCalendarDateRange:fromRow:forRange:withTimeZone:toArray:):
	return immediately if the occurrence does not have a valid
	recurrence-id.

2012-07-20  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/MailerUI.js (onEmailTo): append the email
	address from the href attribute if it doesn't appear in the link content.

	* UI/MailPartViewers/UIxMailPartHTMLViewer.m
	(-startElement:namespace:rawName:attributes:): don't skip "mailto:"
	href.

	* SoObjects/Appointments/SOGoAptMailReceipt.m (aptSummary-): new
	method that returns a properly formatted string of the event title
	with respect to the current operation (creation/deletion/update).

2012-07-19  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreObject.m (-nameInContainer): moved method
	from MAPIStoreSOGoObject and made mandatory for subclasses.
	(-url): new methed moved from MAPIStoreSOGoObject.

	* OpenChange/MAPIStoreAppointmentWrapper.m: now a subclass of
	MAPIStoreObjectProxy.

	* OpenChange/MAPIStoreCalendarMessage.m
	(-initWithSOGoObject:inContainer:): we now register our
	appointment wrapper as a proxy.

	* OpenChange/MAPIStoreObject.m (-addProxy:): new method that keeps
	proxy objects in the new "proxies" ivar.
	(-getProperty:withTag:inMemCtx:): added code that pass the request
	to the available object proxies, when the property getters have
	not been found in the local class.

	* OpenChange/MAPIStoreObjectProxy.[hm]: new class module that
	provide a facility for providing property getters in the name of
	another class, working around the fact that Objective-C does not
	provide multiple-inheritance.

	* OpenChange/NSObject+MAPIStore.m
	(+getAvailableProperties:inMemCtx:)
	(-getAvailableProperties:inMemCtx:, canGetProperty:): methods
	moved from MAPIStoreObject.m

2012-07-18  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreCalendarFolder.m (-createMessage): attach a
	WOContext to the newEntry in order to enable page templates
	resolution when notifications are sent.

	* OpenChange/MAPIApplication.m (-init): a WEResourceManager is
	setup for the application so that page templates can be properly
	be initialized.

	* OpenChange/MAPIStoreDBMessage.m (-objectVersion): shift the
	version number by 16 bits, instead of doing it in -save.
	(-save): don t swap the bytes of the version number as it would
	return a wrong change number and a wrong change key for DB objects.

2012-07-18  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* SoObjects/Appointments/SOGoAppointmentObject.m
	(_setupResponseInRequestCalendar:): we now return the
	calendar read from the database and not use the one
	from the request anymore, as it can override properties
	other than participation status changes.

2012-07-18  Jean Raby  <jraby@inverse.ca>
	* Tests/Integration/config.py.in: New config parameter: webCalendarURL
	* Tests/Integration/webdavlib.py(HTTPPOST,HTTPGET):
	  Allow cookies in post and get requests.
	* Tests/Integration/test-ui-posts.py: New test class
	  Currently contains only one test case which exercises addWebCalendar

	* SoObjects/Appointments/GNUmakefile:
	  use -Wl,--no-as-needed when linking. Fixes #1863

	* Scripts/sql-update-1.3.16_to_1.3.17-mysql.sh 
	* Scripts/sql-update-1.3.16_to_1.3.17.sh:
	New scripts to expand c_cycleinfo to mediumtext or varchar(1000000)
	The field was expanded around 1.3.3.
	See http://www.sogo.nu/bugs/view.php?id=1848

2012-07-16  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* Tests/Integration/webdavlib.py (WebDAVQuery.set_response): make
	use of xml.etree.cElementTree for speed and avoid using a
	cStringIO altogether by directly passing the content string.

	* Tests/Integration/test-davacl.py (DAVCalendarSuperUserAclTest._getEvent)
	(DAVCalendarAclTest._getEvent): ensure that the resulting event
	does not contain any "\r" char as the XML parser would anyway
	strip them.

2012-07-13  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/Appointments/SOGoAppointmentObject.m
	(-updateContentWithCalendar:fromRequest:): new method spawned from
	the previous incarnation of PUTRequest:, designed to centralize
	all the processed performed on an iCalendar instance, new or
	derived from the original.
	(-changeParticipationStatus:withDelegate:forRecurrenceId:):
	reorganized the method workflow by not testing "calendar" as it is
	guaranteed to be returned. Also, we save the iCalendar object from
	here, as we cannot invoke the method above, which would reinvoke
	this method in loop in the current state of the code.

	* SoObjects/Appointments/SOGoCalendarComponent.m
	(-lookupOccurrence:): now a virtual method forcing the use by
	subclasses of the new methods below.
	(-saveCalendar:): new method that enables the saving of an
	iCalendar object.

	* SoObjects/Appointments/iCalCalendar+SOGo.m: new category module.
	(-eventWithRecurrenceId, -todoWithRecurrenceId): new method that
	return as recurrence based on the id passed as parameter.

	* Tests/Integration/test-caldav-scheduling.py
	(CalDAVSchedulingTest.setUp): use the proper password for
	attendee1_delegate.

2012-07-12  Jean Raby <jraby@inverse.ca>

	* SoObjects/Mailer/SOGoMailForward.m (from, to, cc, reply-to):
	mailHeaders returns an array if there are multiple headers of the same type.
	Handle this case to correctly show multiple from, to, cc and reply-to headers
	in mail replies/forwards instead of crashing.

2012-07-11  Ludovic Marcotte <lmarcotte@inverse.ca>

	* Finished the implementation and testing of the two
	new defaults. Also added documentation in the SOGo Installation
	and Configuration Guide.

	* Updated UI/Templates/SchedulerUI/UIxCalendarProperties.wox to not
	show the notification options if it's a web calendar or if the active
	user isn't the owner of the calendar.

	* Added strings to translate and cleaned up the template to send
	HTML mails instead of text/plain.

2012-07-10  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/Appointments/SOGoAppointmentFolder.m
	(-davNotifyOnPersonalModifications)
	(-setDavNotifyOnPersonalModifications:)
	(-davNotifyOnExternalModifications)
	(-setDavNotifyOnExternalModifications:)
	(-davNotifyUserOnPersonalModifications)
	(-setDavNotifyUserOnPersonalModifications:)
	(-davNotifiedUserOnPersonalModifications)
	(-setDavNotifiedUserOnPersonalModifications:): new dav accessors.


	* SoObjects/SOGo/SOGoObject.m (-davBooleanForResult:): new method
	that returns a valid DAV boolean from a BOOL.
	(-isValidDAVBoolean:): new method that validates the value as a
	DAV boolean.
	(-resultForDAVBoolean:): new method that returns a BOOL from a DAV
	boolean.

2012-07-09  Ludovic Marcotte <lmarcotte@inverse.ca>

	* Dropped old templates (SOGoAptMailDeletionReceipt.wox
	SOGoAptMailInvitationReceipt.wox and SOGoAptMailUpdateReceipt.wox)
	which are in fact replaced by SOGoAptMailReceipt.wox. File added
	to the repository.

	* Dropped SOGoAppointmentSendEMailReceipts

	* Added two new domain defaults: SOGoNotifyOnPersonalModifications
	and SOGoNotifyOnExternalModifications. They allow users to be notified
	when modifying their own calendars or when someone else to it. These
	defaults are over-writable by users from their calendar properties window.

	* Implemented the code related to the two new defaults together with a
	third option - which is to notify a specific person when one modifies
	his/her calendar. This commit is partial as more testing is required
	and some code changes to trigger the right notifications.

2012-07-09  Jean Raby  <jraby@inverse.ca>

	* Tools/SOGoToolUserPreferences.m:
	use printf() instead of NSLog to print out user preferences.
	Makes it easier to grep.

	* UI/WebServerResources/generic.js (onSearchFormSubmit):
	Restore behavior of a single dot (.) in the search field (wildcard search)

	* UI/WebServerResources/SchedulerUI.js (onMenuRawEvent, onMenuRawTask):
	New callback to show the event/task content from the menu

	* UI/Scheduler/UIxComponentEditor.m (rawAction):
	New method that returns the object's raw content in a WOResponse.

	* UI/Templates/SchedulerUI/UIxCal{Day,Month,Main,Week}View.wox:
	New contextual menu item: Show Raw Source

	* UI/WebServerResources/ContactsUI.js (onMenuRawContact):
	Rework to use calendar/ics/raw

	* UI/Contacts/UIxContactFolderActions.m (rawAction):
	Removed / moved to UI/Contacts/UIxContactActions.m

	* UI/Contacts/UIxContactActions.m (rawAction):
	New method that returns the object's raw content in a WOResponse.

	* UI/Templates/ContactsUI/UIxContactFoldersView.wox:
	Show vCard content -> Show Raw Source


2012-07-05  Jean Raby  <jraby@inverse.ca>

	* UI/WebServerResources/generic.js (openGenericWindow):
	New method that opens a simple new window.

	* UI/WebServerResources/ContactsUI.js (onMenuRawContact):
	New callback to show the vCard content from the menu.

	* UI/WebServerResources/ContactsUI.js (onContactMenuPrepareVisibility):
	Enable the export and raw functions only on vcards contacts.

	* UI/Templates/ContactsUI/UIxContactFoldersView.wox:
	New contextual menu item: Show vCard content

	* UI/Contacts/UIxContactFolderActions.m (rawAction):
	New method that returns the raw contact data for all the contact uids provided

	* UI/Contacts/UIxContactView.m (secondaryEmail):
	function renamed to secondaryEmails. It now returns all addresses
	instead of the first one found in the vcard.

	* UI/Templates/ContactsUI/UIxContactView.wox:
	Show all addresses returned from secondaryEmails.
	This still need some css tweaks.

2012-07-01  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreRecurrenceUtils.m
	(-setupRecurrenceWithMasterEntity:fromRecurrencePattern:): add
	exception dates to master entity based on the
	"DeletedInstanceDates" member of the struct.
	(-fillRecurrencePattern:withEvent:inTimeZone:inMemCtx:): new name
	for fillRecurrencePattern:withStartDate:andEndDate:, add exception
	dates to struct.

	* OpenChange/NSDate+MAPIStore.m (NSDateCompare): new comparison
	function for sorting array of NSDate instances.

2012-06-30  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/NSObject+MAPIStore.h: renamed
	MAPIStoreTallocWrapper.MAPIStoreSOGoObject to .instance, to avoid
	confusion in certain versions of GCC with our new class type.

2012-06-29  Jean Raby  <jraby@inverse.ca>

	* SoObjects/SOGo/WORequest+SOGo.[mh]
	(-isAndroid): new method to detect whether the
	request has been performed from an android client

	* SoObjects/Contacts/SOGoContactFolders.m (appendSystemSources):
	Let sogo append system sources if the request comes from an android
	client even if its user agent matches the IPhoneAddressBook

2012-06-29  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreSOGo.m
	(sogo_message_attachment_open_embedded_message): added the "mode"
	parameter.

	* OpenChange/SOGoMAPIDBObject.m: new class module that replaced
	SOGoMAPIFSMessage.

	* OpenChange/SOGoMAPIDBFolder.m: new class module that replaced
	SOGoMAPIFSFolder.

2012-06-28  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/SOGo/SOGoObject.m (-initWithName:inContainer:): make
	sure that "_name" is neither nil nor empty.

2012-06-27  Jean Raby  <jraby@inverse.ca>

	* SoObjects/Appointments/SOGoAppointmentObject.m
	(PUTAction:): detect conflicting event UID and
	deny the request accordingly.

2012-06-21  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* Added the SOGoSearchMinimumWordLength domain
	default which controls the minimal length required
	before trigging server-side search operations for
	attendee completion, contact searches, etc. The
	default value is 2, which means search operations
	are trigged once the 3rd character is typed.

2012-06-20  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* SoObjects/Appointments/SOGoAppointmentObject.m
	(-_handleResourcesConflicts:forEvent:): We now
	handle correctly recurring events overlapping other
	recurring events.

2012-06-19  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* SoObjects/Appointments/SOGoAppointmentFolder.m (-importCalendar:):
	We now handle correctly floating events by forcing the use of
	the user's timezone.

	* SoObjects/Appointments/SOGoCalendarComponent.m (-expandGroupsInEvent:):
	We now remove all attendees that are equal (email-based comparison) to
	the event's organizer instead of only for decomposed groups.

2012-06-12  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/SOGo/SOGoGroup.m
	(+groupWithValue:andSourceSelector:inDomain:): handle the case
	the value of "objectclass" is actually an NSString instance,
	otherwise causing a crash with the NSArray methods.

2012-06-04  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/UIxFilterEditor.js (savePreferences):
	don't validate filters if they are not visible (when matching all
	incoming messages).

	* SoObjects/Appointments/SOGoAppointmentFolder.m
	(-_appendCycleException:firstInstanceCalendarDateRange:fromRow:forRange:withTimeZone:toArray:):
	adjust recurrence id according to timezone when dealing with a
	floating all-day event.

2012-06-01  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/SOGo/NSString+Utilities.m
	(-_handleURLs:textToMatch:prefix:inRanges:): don't reset the
	prefix for the subsequent matching strings. This fixes links in
	messages with multiple email addresses, some of which already
	prefixed by "mailto;".

2012-06-01  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/*: fixed build errors with gcc-4.7

	* UI/MailPartViewers/UIxMailPartAlternativeViewer.m
	(-childPartName): fixed a potential crash by building the NSString
	from the integer itself, with the proper format string.

	* SoObjects/SOGo/NSString+Crypto.m
	(-isEqualToCrypted:withDefaultScheme:): invoke "intValue" rather
	than "integerValue" on the encoding number as the int type is not
	crucial and it breaks the build with old versions of GNUstep.

	* SoObjects/SOGo/NSString+Crypto.[hm]: new module that provides
	category methods for returning encrypted passwords strings and
	their encryption algorithm.

2012-05-31  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* SoObjects/SOGo/SOGoGroup.m - we now handle lowercase
	all attribute names
	* SoObject/SOGo/LDAPSource.m - moved the lowercasing
	of attributes to SOPE.
	* Added patch from bug #1608. This add many more password
	schemes for SQL authentication.
	* SoObject/Mailer/SOGoMailFolder.m (-_readMailboxACL): we
	now create the mailbox if we are trying to read ACL of
	a deleted mailbox.
	* UI/MailerUI/UIxMailEditor.m (-personalContactInfos): we check
	if the folder still exist and if the database isn't down
	before performing any address books search operations.
	* UI/MailerUI/UIxMailMainFrame.m (-unseenCountFolders): we no
	longer fill up the list of mailboxes to with the ones that are
	targets for "fileinto" methods if Sieve scripts aren't enabled
	in SOGo's domain defaults.

2012-05-29  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/UIxMailEditor.js (validateEditorInput):
	merged with onValidate.
	(onValidate): don't force the subject to be defined, but alert
	the user.

	* UI/MailerUI/UIxMailView.m (-messageSubject): don't set the
	subject to "Untitled" if it's not set.

	* UI/MailPartViewers/UIxMailPartMessageViewer.m (-messageSubject): idem.

	* UI/MailerUI/UIxMailEditor.m (-validateForSend): don't force the
	subject to be defined.

	* SoObjects/Mailer/SOGoMailObject+Draft.m (-subjectForReply): make
	sure subject is a defined value to avoid "null" strings in the
	reply message.

2012-05-28  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/SchedulerUI.js (validateUploadForm): hide
	Cancel button when the form is valid and disable the Submit button.

	* UI/WebServerResources/ContactsUI.js (validateUploadForm): idem.

2012-05-24  Jean Raby  <jraby@inverse.ca>

	* debian*/rules: Restart sogod after pkg upgrade (dh_installinit -R)
	* Scripts/sogo-init.d-*: add support for conditional restart.
	  Patch from Romain Le Disez
	* sogo.spec: Restart sogod during post installation if it was already running

	* Apache/SOGo.conf:
	Use mod_expires to allow long term caching of static content. (1 year)
	Note that from now on, a resource's URL _must_ change to let the client
	reload it.  This is now done automatically for 'rsrc' in the wox templates,
	but must be done manually for files referenced from css and js.

2012-05-23  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* UI/WebServerResources/generic.js
	(clickEventWrapper.button_clickEventWrappe): don't invoke
	"preventDefault" on elements that do not have a tagName of "A".

2012-05-18  Jean Raby  <jraby@inverse.ca>

	* SoObjects/Mailer/SOGoDraftObject.m (bodyPartForAttachmentWithName):
	Merge back lost code to handle encoding of binary and rcf822 attachments.

2012-05-15  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/gen-property-selectors.py: the use of the "{}" to
	construct a set is only valid on py2.7 therefore we make use of
	set([]) instead.

2012-05-15  Jean Raby  <jraby@inverse.ca>

	* SoObjects/Appointments/SOGoAppointmentObject.m (_handleResourcesConflicts):
	Deny access to resources if the resource's ACL don't allow the organizer
	to read its freebusy info.
	Without this, sogo would always auto-accept invitations from 'unprivileged'
	users, potentially bypassing the multiplebooking parameter.

2012-05-14  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/gen-property-selectors.py: "bannedProps" is now a
	set, for faster lookups.

	* UI/WebServerResources/UIxContactsUserFolders.js: folder ids are
	in the form "user:module/folder", therefore we must remove the
	first char, which is a slash.

	* UI/WebServerResources/generic.js (subscribeToFolder): prepend a
	"/" to the folder name, as it comes originally in the form
	user:module/folder.

	* UI/WebServerResources/UIxPreferences.js (initMailAccounts)
	(displayMailAccount): getElementsByTagName seems too standard for
	IE, we use $$() now so that we can invoke "each" on the result set
	without triggering an exception.

2012-05-09  Jean Raby  <jraby@inverse.ca>

	* SoObjects/Appointments/SOGoAppointmentObject.m (PUTAction):
	Delete bitrotten code that could end up duplicating attendees.
	Behavior exposed by the new caldav tests

	* Tests/Integration/config.py.in
	* Tests/Integration/test-caldav-scheduling.py
	* Tests/Integration/test-ical.py
	* Tests/Integration/test-davacl.py:
	Use an unprivileged webdavclient where possible.
	This would have uncovered the resources calendar autocreation bug.

	* Tests/Integration/test-caldav-scheduling.py:
	New tests to excercise somewhat fragile code in dav autoscheduling.

2012-05-09  Jean Raby  <jraby@inverse.ca>

	* SoObject/SOGo/SOGoParentFolder.m (_createPersonalFolder):
	Automatically create the folder if its owner is a resource.
	(not if the active user is a resource)

2012-05-09  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* SoObjects/Mailer/SOGoDraftObject.m - don't encode message/rfc822
	parts in base64 - it's not allowed.

2012-05-08  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/ContactsUI.js (configureDraggables)
	(configureDroppables, startDragging, whileDragging, stopDragging)
	(dropAction): drag'n'drop is how handle by jQuery instead of Scriptaculous.

	* UI/WebServerResources/MailerUI.js (configureDraggables)
	(configureDroppables, startDragging, whileDragging, stopDragging)
	(dropAction): idem.

	* UI/WebServerResources/generic.js (onCloseButtonClick)
	(showPromptDialog, showSelectDialog, showAuthenticationDialog)
	(disposeDialog, _disposeDialog): idem.

	* UI/WebServerResources/SOGoRootPage.js (initLogin): idem.

	* UI/Contacts/UIxContactView.m (-primaryEmail): in the mailto
	link, remove double-quotes and escape single-quotes from the fullname.
	(-secondaryEmail): idem.

2012-05-04  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreSOGo.m: register and unregister current
	thread before and after each backend operation, in order to avoid
	issues in multithreaded environment.

2012-05-01  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* UI/WebServerResources/generic.js (accessToSubscribedFolder): use
	the last part of the string as folder identifier. Otherwise we end
	up with the module name.

	* SoObjects/Mailer/SOGoDraftObject.m
	(-bodyPartForAttachmentWithName:): attach rfc822 content as
	with base64 encoding, just as any other non-text data.

2012-04-30  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* SoObjects/SOGo/SOGoDomainDefaults.{h,m} - added
	-hideSystemEMail that honors SOGoHideSystemEMail.
	Right now, this variable is limited only to
	the calendar-user-address-set response but can/will be
	extended later.

	* SoObjects/Appointments/SOGoUserFolder+Appointments.m
	(-davCalendarUserAddressSet): Modified to honor
	SOGoHideSystemEMail domain default.

	* SoObjects/Mailer/SOGoDraftObject.m (-lookupName:...):
	We prioritize the lookup of the "Drafts" folder over the
	"Sent" one if both are matching.

	* SoObjects/Mailer/SOGoMailFolder.m: Same as above.


2012-04-25  Jean Raby  <jraby@inverse.ca>

	* SoObjects/Mailer/SOGoDraftObject.m
	(-updateFromLDIFRecord:): carry the c_info attribute
	in vcards through the x-sogo-contactinfo attribute.
	This functionality was lost a while ago.
	We used to use the NOTE attribute for this. From now on,
	the sogo-connector.autoComplete.commentAttribute have to be set to
	'unprocessed:x-sogo-contactinfo' instead of 'Notes'.


2012-04-25  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* UI/PreferencesUI/UIxPreferences.m (_extractMainIdentity:): save
	the custom full name even when the configured custom email has the
	same value as the system value.

	* SoObjects/SOGo/SOGoUser.m (-appendSystemMailAccount): append
	custom identity even though only the full name has a custom value.

	* SoObjects/Mailer/SOGoDraftObject.m
	(-bodyPartForAttachmentWithName:): force conversion of rfc822
	content to quoted-printable, since it would otherwise risk passing
	8bit data via the "APPEND" command.

2012-04-24  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* UI/WebServerResources/SchedulerUI.js (updateCalendarStatus): if
	"event" is set, we set its returnValue to true, to avoid a bug
	occurring since the use of "clickEventWrapper".
	(resizeCalendarHeaderDIV): new function that resizes the all-day
	event containers progressively.
	(_drawCalendarAllDayEvents, _deleteCalendarEventBlocks): invoke
	the above.

	* UI/WebServerResources/HTMLElement.js: get "HTMLCollection"
	and "NodeList" classes by class rather than by direct reference.

	* UI/WebServerResources/generic.js (clickEventWrapper): pass the
	value of "this" to the invoked callback.

2012-04-24  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* SOPE/GDLContentStore/GCSFolder.m (-writeContent:toName:baseVersion:):
	We now keep track of the saved version for all callers. Also updated
	all callers to reflect that change.

	* SoObjects/Appointments/SOGoAppointmentObject.m (-PUTAction:)
	Took some of the logic from SOGoContentObject's -PUTAction: to
	avoid etag mismatches.

2012-04-23  Ludovic Marcotte  <lmarcotte@inverse.ca>

    * SoObjects/Appointments/SOGoAppointmentObject.m: We now
	automatically add/remove attendees to recurrence exceptions
	when they are being added to the master event. Also
	fixed -PUTAction: so that we fetch the organizer of a recurrence
	exception when the master doesn't have a copy of it.

	* SoObjects/Appointments/SOGoAppointmentOccurence.m: added
	-componentTag to avoid server crash.

2012-04-20  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* UI/WebServerResources/SchedulerUI.js (onCalendarReload): invoke
	changerCalendarDisplay when no web calendars are present...

	* UI/WebServerResources/HTMLElement.js: enhanced both
	HTMLCollection and NodeList with the "Enumerable" interface.

	* UI/WebServerResources/UIxPreferences.js (displayMailAccount):
	disable the "fullName" and "email" input fields of the first
	account only when SOGoMailCustomFromEnabled is NO.

	* UI/PreferencesUI/UIxPreferences.m (_extractMainIdentity:): the
	custom values for "fullName" and "email" are now registered in the
	user defaults, if "email" is different from all the values
	returned by the user directory AND if SOGoMailCustomFromEnabled is
	YES.

	* SoObjects/SOGo/SOGoUserDefaults.m (-setMailCustomFullName:)
	(-mailCustomFullName): new accessors for the new
	"SOGoMailCustomFullName" user default.
	(-setMailCustomEmail:, -mailCustomEmail): new accessors for the
	new "SOGoMailCustomEmail" user default.

	* SoObjects/SOGo/SOGoDomainDefaults.m (-mailCustomFromEnabled):
	new getter for the "SOGoMailCustomFromEnabled" domain default.

	* SoObjects/Mailer/SOGoDraftObject.m
	(-mimeHeaderMapWithHeaders:excluding:) take the new "replyTo"
	header into account.

	* SoObjects/SOGo/SOGoUser.m (-_appendSystemMailAccount): specify
	the value of "SOGoMailReplyTo" in the "replyTo" field of each
	identity, if present.
	When "SOGoMailCustomFromEnabled" is YES and the user has set
	a value for "SOGoMailCustomEmail", a first identity is created and
	set at the first position in the list, based on that value and on
	"SOGoMailCustomFullName".

	* SoObjects/SOGo/SOGoUserDefaults.m (-setMailReplyTo:)
	(-mailReplyTo:): accessors for the "SOGoMailReplyTo" user default.

2012-04-19  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* SoObjects/Appointments/SOGoAppointmentObject.m (-PUTAction:)
	We now handle cases where the last attendee AND the organizer
	is removed from the event during a PUT action (happens when
	you delete the last attendee of an event with iCal). This used
	to crash sogod.
	* SoObjects/Appointments/SOGoAppointmentFolder.m (-importCalendar:)
	Fixed the import process of broken all-day events (#1055)

2012-04-19  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/Appointments/SOGoAppointmentFolder.m
	(-importCalendar:): associate occurrences of a repeating event to
	its master vcalendar to avoid duplicated events when importing a .ics.

2012-04-19  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/SOGo/SOGoParentFolder.m (-appendSubscribedSources):
	ensure the array set as values in the settings dicts are not nil
	prior to setting them.

	* SoObjects/Appointments/SOGoAppointmentFolder.m
	(-fetchFields:from:to:title:component:additionalFilters:includeProtectedInformation:):
	fix the date condition for cycle record, by using c_cycleenddate
	instead of c_enddate.

2012-04-18  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* SoObjects/Appointments/SOGoAppointmentObject.m (-_handleResourcesConflicts: ...):
	We now handle recurring appointments by fetching the freebusy information for one full
	year from the date of the event. Also improved the conflict
	reporting messages.

	* SoObjects/Appointments/SOGoAppointmentObject.m (-PUTAction:):
	update the versit string in the request when updating the event, in
	case a resource auto-accepted the event

	* SoObjects/SOGo/SOGoGCSFolder.m: renamed -subscribeUser:reallydo: to
	subscribeUserOrGroup:reallydo and we now handle group subscriptions.
	Refactored all callers.

	* SoObjects/SOGo/SOGoParentFolder.m (-_appendSubscribedSource:): now returns a
	BOOL if the permission are still valid or not

	* SoObjects/SOGo/SOGoParentFolder.m (-appendSubscribedSources): consumes the
	returned value from -_appendSubscribedSource: and cleans up SubscribedFolders
	and FolderDisplayNames accordingly in the user's settings.

	* SoObjects/SOGo/SOGoUserManager.m (-_fillContactInfosForUser: ...): we now
	set the isGroup attribute as we need this for quick groups
	resolving.

2012-04-18  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* UI/WebServerResources/generic.js (showAuthenticationDialog): new
	dialog providing an interface for requesting a username and a
	password to acallback passed as parameter.
	(accessToSubscribedFolder): fixed method to return the proper url
	for folders owned by the active user.

	* UI/WebServerResources/SchedulerUI.js (reloadWebCalendars): now
	invokes "reloadAction" on every web calendar foldar, in a chain of
	simultaneous requests.
	(reloadWebCalendar): new function invoking "reloadAction" on a
	single cal folder.
	(reloadWebCalendarCallback): callback for the above invocation
	that takes care of refreshing the views at the end of a refresh
	chain, if present, and when useful.

	* UI/Scheduler/UIxCalFolderActions.m (reloadAction): new web
	method that applies only to SOGoWebAppointmentFolder instances and
	which returns a JSON representation of the result returned by
	-[SOGoWebAppointmentFolder loadWebCalendar]. This method replaces
	-[UIxCalMainActions -reloadWebCalendars].
	(setCredentialsAction): new web method acting as a proxy for
	-[SOGoWebAppointmentFolder setUsername:andPassword:].

	* UI/WebServerResources/generic.js (clickEventWrapper): new
	function that returns a wrapper function for click callbacks which
	invokes "preventDefault" on the "event" parameter before it is
	passed to the real callback.

	* UI/Scheduler/UIxCalMainActions.m
	(-reloadWebCalendarsAndRedirectAction): removed obsolete method.
	(-reloadWebCalendars): removed obsolete method.

	* SoObjects/Appointments/SOGoAppointmentFolders.m
	(-newWebCalendarWithName:atURL:): perform sanity checks on the url
	parameter.

	* SoObjects/Appointments/SOGoWebAppointmentFolder.m
	(-setUsername:andPassword:): new method that associate an
	encrypted login pair for authenticating to remove calendars.
	(-loadWebCalendar): rewrote method to make use of curl, thereby
	permitting HTTP authentication. A NSDictionary containing
	different informations about the connection is not returned,
	including the HTTP status and an error tag, when required.

	* SoObjects/Appointments/SOGoAppointmentFolder.m
	(-importCalendar:): journals and freebusys are not
	supported.

2012-04-16  Jean Raby  <jraby@inverse.ca>

	* SOPE/NGCards/iCalMonthlyRecurrenceCalculator.m
	(-recurrenceRangesWithinCalendarDateRange:):
	Fix of by one error. (bug #1772)

2012-04-16  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/SOGo/NSString+Utilities.m (-encryptWithKey:)
	(-decryptWithKey:): new methods providing symmetric encryption of
	strings.

	* Tests/Unit/SOGoTestRunner.m (-run): do not empty the pool after
	each test.

2012-04-13  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/Appointments/SOGoAppointmentFolder.m (-bareFetchFields: ...),
	(-fetchFields:from:to:title:component:additionalFilters:includeProtectedInformation:):
	restored c-style escaping of sql-style escaping of quote characters.
	(-davCalendarShowAlarms, setDavCalendarShowAlarms:): new proxy dav
	accessors for "showCalendarAlarms" and "setShowCalendarAlarms:".

2012-04-12  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/SOGo/SOGoGCSFolder.m (-componentSQLFilter): new
	overridable method that enables passing filters for
	toOneRelationshipKeys from subclasses.

	* SoObjects/Appointments/SOGoAppointmentFolder.m
	(-davCalendarComponentSet): componentSet is now an ivar. Include
	VTODO only with showCalendarTasks returns YES.
	(-davResourceType): return vtodo-collection only when
	showCalendarTasks returns YES.

	* UI/Scheduler/UIxCalListingActions.m
	(_fetchFields:forComponentOfType:): do not check for
	"showCalendarTasks" since it is now handled at the
	SOGoApopintmentFolder level.

	* SoObjects/Appointments/SOGoAppointmentFolder.m
	(-bareFetchFields: ...,
	(-fetchFields:from:to:title:component:additionalFilters:includeProtectedInformation:):
	make use of a mutable array to define the global WHERE clause, by
	joining the elements with " AND ".
	(-additionalWebdavSyncFilters): don't include 'vtodo' components
	when -[self showCalendarTasks] returns NO.

2012-04-11  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/ContactsUI.js (onDocumentKeydown): don't
	trap keyboard input when inside a textarea.

2012-04-05  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/SOGo/NSString+Utilities.m (-objectFromJSONString):
	added a work-around for JSON strings that were escaped one too
	many time, in previous versions of sope-gdl1-xxx.

2012-04-04  Jean Raby  <jraby@inverse.ca>

	* Added a new tool: 'sogo-tool expire-sessions'
		Along with the associated new cronjob, this allows
		user sessions expiration without a custom script.

	* While there, sort tools in sogo-tool output

2012-04-03  Francis Lachapelle  <flachapelle@inverse.ca>

	* Tools/SOGoToolRemoveDoubles.m (-removeDoublesFromFolder)
	(-amountOfFilledQuickFields): lowered the case of the
	telephonenumber table fieldname.

	* OGoContentStore/OCSContactFieldExtractor.m
	(-extractQuickFieldsFromVCard): idem.

2012-03-30  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreCalendarMessage.m (-save): remove comment if
	content is "\n".

	* OpenChange/MAPIStoreTasksMessage.m (-save): do not reset fields
	that have not been passed in the properties array, since only
	RopDeleteProperties should remove them.
	Remove comment if content is "\n".

	* OpenChange/MAPIStoreObject.m (-addPropertiesFromRow:): dates are
	now all converted to the user's timezone, even though it just
	inverts the problem we currently have.

	* OpenChange/MAPIApplication.m (-init): utcTZ is now initialized
	here.

	* OpenChange/MAPIStoreTypes.[hm]: new host module for utcTZ.

	* OpenChange/MAPIStoreUserContext.m (-timeZone): new method that
	returns the timezone of an owner user.

	* OpenChange/MAPIStoreObject.m (-ownerTimeZone): removed method,
	replaced with the one above.

2012-03-29  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/UIxPreferences.js (savePreferences): fixed
	validation of end date of vacation of message when not using ISO
	format (currently limited to French).

	* UI/WebServerResources/ContactsUI.js (startDragging): create an
	overlapping safety block (div) to avoid possible selection of the
	underlying text.

	* UI/WebServerResources/MailerUI.js (startDragging): idem.

2012-03-29  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/UIxPreferences.js (savePreferences): fixed
	validation of end date of vacation of message when not using ISO
	format (currently limited to French).

	* UI/WebServerResources/ContactsUI.js (startDragging): create an
	overlapping safety block (div) to avoid possible selection of the
	underlying text.

	* UI/WebServerResources/MailerUI.js (startDragging): idem.

2012-03-28  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/Contacts/SOGoFolder+CardDAV.m (_isValidFilter:):
	accept "email" as filter name.
	(_appendObject:withBaseURL:toREPORTResponse:): fixed the ordering
	of XML elements as the address*-data props where put outside of
	the <D:prop> tree.

	* SoObjects/SOGo/LDAPSource.m (-allEntryIDs): take the _filter
	ivar into account.

2012-03-28  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/SOGoMAPIFSMessage.m
	(_readFileChangesDataWithDate:andInode:): use the inode number
	rather than the filesize as change indicator since a new file is
	created each time the dictionary is written to disk, thanks to the
	"atomically" flag.
	(-save): write the file atomically.

	* SoObjects/Contacts/SOGoFolder+CardDAV.m (_isValidFilter:):
	accept "email" as filter name.
	(_appendObject:withBaseURL:toREPORTResponse:): fixed the ordering
	of XML elements as the address*-data props where put outside of
	the <D:prop> tree.

	* SoObjects/SOGo/LDAPSource.m (-allEntryIDs): take the _filter
	ivar into account.

2012-03-27  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/Contacts/SOGoContactFolders.m
	(-lookupName:inContext:acquire:): overriden method that enables
	the lookup of hidden public sources with iOS devices.

	* SoObjects/Contacts/SOGoContactLDIFEntry.m (-davAddressData): new
	getter similar to davCalendarData.

	* SoObjects/Contacts/SOGoContactSourceFolder.m
	(-davAddressbookMultiget): new REPORT handler based on
	-[SOGoAppointmentFolder davCalendarMultiget].

	* SoObjects/Contacts/SOGoUserFolder+Contacts.m
	(-davDirectoryGateway): new getter that returns the url to the
	first available directory source.
	(-davResourceType): declare resource as "directory" (carddav).

2012-03-27  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/Contacts/SOGoContactFolders.m
	(-lookupName:inContext:acquire:): overriden method that enables
	the lookup of hidden public sources with iOS devices.

	* SoObjects/Contacts/SOGoContactLDIFEntry.m (-davAddressData): new
	getter similar to davCalendarData.

	* SoObjects/Contacts/SOGoContactSourceFolder.m
	(-davAddressbookMultiget): new REPORT handler based on
	-[SOGoAppointmentFolder davCalendarMultiget].

	* SoObjects/Contacts/SOGoUserFolder+Contacts.m
	(-davDirectoryGateway): new getter that returns the url to the
	first available directory source.
	(-davResourceType): declare resource as "directory" (carddav).

2012-03-26  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreTasksMessage.m (-save): take PR_HTML as
	possible value for the COMMENT field, as as with
	MAPIStoreCalendarMessages.

	* OpenChange/MAPIApplication.m (-init): removed hack pertaining to
	UnixSignalHandler since the class no longer exists.

2012-03-23  Francis Lachapelle  <flachapelle@inverse.ca>

	* Tools/SOGoToolUserPreferences.m (-run): we now take the proper
	argument when setting the user defaults from the command-line.

2012-03-22  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/MailerUI/UIxMailFolderActions.m (-emptyTrashAction:): we now
	unsubscribe from the folders found in the trash.

2012-03-22  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreTasksMessage.m (-save):
	PidLidPercentComplete is a double, that we need to convert in
	order to obtain the proper value.

2012-03-21  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/SOGo/SOGoUserManager.m (_compactAndCompleteContacts:):
	if "mail" is an array, all values are added to "c_emails".

	* SoObjects/Contacts/SOGoContactSourceFolder.m
	(_flattenedRecord:): if "mail" is an array, we only take the first
	value of it.

	* SoObjects/Contacts/SOGoContactLDIFEntry.m (-simplifiedRecord):
	new record guaranteeing that all array values have been stripped
	and converted to strings.

2012-03-20  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/Mailer/SOGoMailObject+Draft.m
	(_contentForEditingFromKeys:): prefer the HTML part over the text
	part when composing HTML messages.

2012-03-20  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/SOGo/SOGoUserFolder.m (-davLastName, -davFirstName):
	quick and dirty implementation of those getters.

	* OpenChange/MAPIStoreAppointmentWrapper.m (-_setupITIPContext):
	ensure method is uppercase.

	* OpenChange/MAPIStoreCalendarMessage.m
	(-getPidLidAppointmentSequence:inMemCtx:): new getter.
	(-save): properly initialize CREATED, LAST-MODIFIED, DTSTAMP and
	SEQUENCE from MAPI properties.

	* OpenChange/MAPIStoreAppointmentWrapper.m
	(-getPidLidAppointmentSequence:inMemCtx:): new getter.

	* OpenChange/NSDate+MAPIStore.m (-isNever): new accessor for dates
	occurring in 4500.

	* OpenChange/MAPIStoreTypes.m (MAPIChangeKeyGUIDCompare): NSData
	arguments passed as "id" due to the pickiness of some versions of
	gcc.

2012-03-19  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* Main/SOGo+DAV.m (_fillCollections:where:matches:inContext:):
	added bogosupport for
	"{http://calendarserver.org/ns/}email-address-set".
	(_principalCollectionsMatching:inContext:): relationship between
	search criteria is now and "OR" rathern than an "AND".

	* SoObjects/Appointments/SOGoUserFolder+Appointments.m
	(-davCalendarUserType, -davEmailAddressSet): new DAV accessors.

	* OpenChange/MAPIStoreCalendarMessage.m (-save): check recipients
	even if PidLidAppointmentStateFlags is nil or 0, since all that
	matters is that the "recipients" dict be present in the properties
	dictionary.

	* OpenChange/SOGoMAPIFSMessage.m (-init): init 2 new ivars:
	fileSize and lastModificationTime.
	(-properties): check the current file size and last modification
	time against cached values and reload the props file if anything
	changed.
	(-creationTime, -lastModificationTime): new return type: NSDate
	instead of NSCalendarDate.

2012-03-16  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreGCSFolder.m
	(-predecessorChangeListForMessageWithKey:): same as below.
	(-setChangeKey:forMessageWithKey:): synchronise the version cache
	if the message entry is not found.
	(-updateVersionsForMessageWithKey:withChangeKey:): new method,
	common to all GCS messages, that updates the folder cache and
	insert the PidTagChangeKey provided by the client during the save
	operations.

	* OpenChange/MAPIStoreMailFolder.m
	(-predecessorChangeListForMessageWithKey:): the returned list must
	be binary ordered by GUID (as specified in the SPEC). We now do so
	using the new function below.
	(-getPidTagMessageClass:inMemCtx:): removed method, as folders are
	not supposed to return a PidTagMessageClass attribute.

	* OpenChange/MAPIStoreTypes.m (MAPICNCompare): added as void *
	parameter so that the function can be used as a comparator
	function in NSArray sort methods.
	(MAPIChangeKeyGUIDCompare): new comparator function to compare the
	GUID of two change key streams.

	* OpenChange/MAPIStoreGCSMessage.m (-updateVersions): new proxy
	method for -[MAPIStoreGCSFolder
	updateVersionsForMessageWithKey:withChangeKey:].

	* OpenChange/MAPIStoreGCSBaseContext.m
	(+createRootSecondaryFolderWithFID:andName:forUser:): setup the
	userContext in the MAPIApp object.

	* OpenChange/MAPIStoreMailContext.m
	(+createRootSecondaryFolderWithFID:andName:forUser:): setup the
	userContext in the MAPIApp object.

	* OpenChange/MAPIStoreContactsFolder.m
	(-getPidTagDefaultPostMessageClass:inMemCtx:): new getter.

	* OpenChange/MAPIStoreCalendarFolder.m
	(-getPidTagDefaultPostMessageClass:inMemCtx:): new getter.

	* OpenChange/MAPIStoreTasksFolder.m
	(-getPidTagDefaultPostMessageClass:inMemCtx:): new getter.

	* OpenChange/MAPIStoreFolder.m
	(-getPidTagDefaultPostMessageClass:inMemCtx:): new getter.

	* OpenChange/MAPIStoreMessage.m
	(-getPidTagMessageStatus:inMemCtx:): removed useless getter.

	* OpenChange/MAPIStoreSOGo.m (sogo_backend_init): check for
	"SOGoDebugLeaks" in the user defaults and activate GSDebug
	allocation utilities.

	* OpenChange/NSData+MAPIStore.m (+dataWithChangeKeyGUID:andCnt:):
	new method replacing _dataFromChangeKeyGUID:andCnt: from
	MAPIStore{GCS,Mail}Folder.

2012-03-16  Jean Raby  <jraby@inverse.ca>

	* sogo.spec debian/sogo.postint: upon installation, update timestamp
	on WebServerResources/* to let the webserver know the files changed.
	Should fix issues where browsers would use a locally cached version
	of a resource when the sogo package have just been upgraded.

2012-03-15  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/generic.js (onPreferencesClick): don't
	allow the user to open the preferences window multiple times.

	* UI/WebServerResources/SOGoDragHandles.js (enableRightSafety):
	new method to display a "safety" block on top of the right block
	when dragging the handle. This fixes a problem when the right
	block contains an instance of CKEditor.

2012-03-14  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/MailerUI/UIxMailFolderActions.m (-deleteAction): we now
	unconditionaly unsubscribe from the folder and subscribe to the
	folder moved to the trash.

	* SoObjects/Mailer/SOGoMailFolder.m (-renameTo): idem.

	* UI/WebServerResources/UIxPreferences.js (focusCKEditor)
	(hideSignature): new functions to wait until the CKEditor is ready
	before performing certain actions. Fixes a problem with IE.

	* UI/WebServerResources/SOGoTimePicker.js (position): new method
	to be able to recompute the position of the widget.

	* UI/WebServerResources/UIxAppointmentEditor.js
	(refreshAttendees): when changing the attendees, we recompute the
	position of the time pickers because the attendees link could
	shift up or down the time fields.

2012-03-13  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/UIxFilterEditor.js (savePreferences):
	only save the filters if there's at least one rule and one action defined.

	* UI/WebServerResources/ContactsUI.js (configureDraggables):
	increased the delay before starting drag and drop.

	* UI/WebServerResources/MailerUI.js (configureDraggables): idem.

	* UI/WebServerResources/UIxAclEditor.js (addUser): fixed
	positioning of new user.

2012-03-13  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreCalendarFolder.m
	(-getPidTagDefaultPostMessageClass:inMemCtx:): new getter.

	* OpenChange/MAPIStoreFolder.m
	(_modifyPermissionEntryForUser:withRoles:isAddition:withACLFolder:):
	skip any modification when user is nil.
	(_usernameFromEntryId:): when the bytes array is nil or is empty,
	we return a nil username.
	(-modifyPermissions:withCount:andFlags:): ignore the presence of
	certain fields but not others depending on the requested
	modification.

2012-03-12  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/SOGo/WORequest+SOGo.m (-isIPhoneAddressBookApp): catch
	the user agent of iOS 5.0.1 on iPad.

2012-03-12  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreGCSFolder.m (-lastMessageModificationTime):
	force a synchronisation from here to ensure that the cache is
	up-to-date.

	* OpenChange/MAPIStoreTypes.m (_reverseCN): fixed used of ull
	constants on 32 bit platforms.

	* OpenChange/MAPIStoreGCSFolder.m (-componentQualifier): now
	provided by the parent class itself.
	(-contentComponentQualifier): new method that returns a qualifier
	that translated to "c_content like '%BEGIN:XXX%'". This is a hack
	to work-around the fact that calendar folders may content both
	vevent and vtodo and that c_component, being part of the quick
	table, is no longer available when a record is deleted.
	(-synchroniseCache): update version values for deleted records
	too, by taking into account the fact that their c_version value
	might still be 0. Make use of contentComponentQualifier above.
	Remove the modified records from the SOGoGCSFolder cache.
	(-getDeletedKeysFromChangeNumber:andCN:inTableType:): wander the
	list of deleted records and no longer increase the change number,
	as this is now done from "synchroniseCache". Also, handle the case
	were deleted records might already have been reported by comparing
	their change number to the one provided as parameter. The
	resulting change number is now guaranteed to be the highest one.
	(-component): new subclassable method that returns a string
	matching the folder's handled component.

	* OpenChange/MAPIStoreFolder.m
	(-getPidTagLocalCommitTimeMax:inMemCtx:): returns
	MAPISTORE_ERR_NOT_FOUND if the resulting date is nil.

	* OpenChange/MAPIStoreGCSMessage.m
	(-getPidTagPredecessorChangeList:inMemCtx:): when the list is
	missing, request a synchronisation from the container as the
	message might now have been synchronised yet...

	* OpenChange/MAPIStoreTypes.m (MAPICNCompare): new function that
	returns an NSComparisonResult for two change numbers (reverse
	format).

2012-03-11  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreCalendarMessage.m
	(-getPidLidAppointmentMessageClass:inMemCtx:): returns "IPM.Appointment".
	(-getPidLidSideEffects:inMemCtx:): returns the value specified in
	OXOCAL, section 2.2.2.2.
	(_fixupAppointmentObjectWithUID:): renamed method and made more
	generic, in order to handle the case where the response record has
	already been deleted.
	(-save): handle organizer and attendees more in compliance with
	the spec, in order to avoid ending up with an empty event when an
	invitation is being replied to. Of course, the documentation
	happened to be inexact with regardes to the value of
	"PidTagRecipientTrackStatus", which can be 5 even though the user
	replied with another value... Also, lowered the priority of
	SOGo-specific hacks for setting the organizer.

2012-03-09  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreMailVolatileMessage.m (-submitWithFlags:):
	skip any message that is not of class "IPM.Note", in order to
	avoid sending invitations or responses.

	* SoObjects/Mailer/SOGoMailFolder.m (-renameTo:): reset the
	imap4URL to nil and change the nameInContainer after a successful
	operation.

	* OpenChange/MAPIStoreFolder.m
	(-getTable:andRowCount:tableType:andHandleId:): if the current
	user is not the owner of the folder, the permissions table cannot
	be open and MAPISTORE_ERR_DENIED is now returned.

	* SoObjects/Contacts/NGVCard+SOGo.m
	(_setupEmailFieldsInLDIFRecord:): the value of card elements were
	not properly extracted when no email field were of type "home" or
	"work".

2012-03-08  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/generic.js (getTopWindow): extend the
	attributes of document.body before calling "hasClassName" to fix
	an error with IE9.

2012-03-08  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreFolder.m: commented out key cache ivars
	(temporarily).

	* OpenChange/MAPIStoreContext.m (-getRootFolder:inMemCtx:): do not
	store the looked up folders when they are not descendants of
	SOGoObject. Return MAPISTORE_ERR_NOT_FOUND when the looked up
	folder is owner by the current user and MAPISTORE_ERR_DENIED
	otherwise.

	* OpenChange/MAPIStoreGCSFolder.m (-synchroniseCache): ensure that
	any record that are marked as updated are removed from the record
	cache of the corresponding SOGoGCSFolder instance.

	* OpenChange/MAPIStoreFolder.m (-getPidTagSubFolders:inMemCtx:):
	invoke [self folderKeys] rather than the corresponding ivar.

	* OpenChange/MAPIStoreTypes.m (NSObjectFromMAPISPropValue)
	(NSObjectFromSPropValue): treat PT_ERROR just as PT_LONG.

2012-03-06  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/Mailer/SOGoMailFolder.m
	(-archiveUIDs:inArchiveNamed:inContext:): output filename is now
	escaped without its extension.

	* SoObjects/Contacts/NGVCard+SOGo.m
	(-_setupEmailFieldsInLDIFRecord:): simplified code and fixed a bug
	where the home mail would be taken for both first and second email
	fields when no work mail was present.

2012-03-02  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreAppointmentWrapper.m,,
	OpenChange/MAPIStoreAttachment.m,
	OpenChange/MAPIStoreCalendarAttachment.m,
	OpenChange/MAPIStoreCalendarMessage.m,
	OpenChange/MAPIStoreContactsAttachment.m,
	OpenChange/MAPIStoreContactsMessage.m,
	OpenChange/MAPIStoreFAIMessage.m,
	OpenChange/MAPIStoreFSMessageTable.m,
	OpenChange/MAPIStoreFolder.m, OpenChange/MAPIStoreFolderTable.m,
	OpenChange/MAPIStoreGCSFolder.m, OpenChange/MAPIStoreGCSMessage.m,
	OpenChange/MAPIStoreGCSMessageTable.m,
	OpenChange/MAPIStoreMailAttachment.m,
	OpenChange/MAPIStoreMailFolder.m,
	OpenChange/MAPIStoreMailMessage.m,
	OpenChange/MAPIStoreMailMessageTable.m,
	OpenChange/MAPIStoreMessage.m, OpenChange/MAPIStoreNotesMessage.m,
	OpenChange/MAPIStoreObject.m,
	OpenChange/MAPIStorePermissionsTable.m,
	OpenChange/MAPIStoreTasksMessage.m,
	OpenChange/MAPIStoreVolatileMessage.m: updated name of getters to
	reflect the new nomenclature.

	* OpenChange/NSArray+MAPIStore.[hm]: updated to new name of
	handled structs.

	* OpenChange/gen-property-selectors.py: adapted for new getters
	name, based on new property names. Added all new clashing
	properties to bannedProps.

2012-03-02  Jean Raby  <jraby@inverse.ca>

	* Scripts/sogo-backup.sh: new script to automate backups.
	Updated sogo.cron to include a commented out entry for sogo-backup.sh
	Include updates.php in the packages

2012-03-01  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/SOGo/LDAPSource.m (_convertRecordToLDAPAttributes):
	make sure no field get listed twice in the list of valid field
	names by using "removeDoubles".
	(_makeLDAPChanges): don't bother checking whether the removed
	attributes are strings.

	* SoObjects/SOGo/NSArray+Utilities.m (-[NSMutableArray
	removeDoubles]): new method removing doublons.

2012-03-01  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/ContactsUI.js (appendAddressBook): assume
	that lists can be created in the new addressbook.

2012-02-28  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreMailFolder.m
	(-moveCopyMessagesWithMIDs:andCount:fromFolder:withMIDs:andChangeKeys:wantCopy:):
	we sync the version cache with the folder in order to update the
	target message change keys, which was causing versioning issues
	with Outlook 2010.

	* OpenChange/gen-property-selectors.py: bannedProps is now an
	array instead of a dict of "True" values.
	Added "PrOabContainerGuid" to bannedProps.

2012-02-27  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreUserContext.m (-rootFolders:):
	-[NGImap4Connection enableExtensions:] now takes an array of
	strings rather than a single string argument.

2012-02-24  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/Mailer/SOGoMailFolder.m: ensure the imap connection is
	available before performing certain operations, otherwise return
	an exception. This only applies on methods that return an
	exception, others were left untouched.

2012-02-23  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreMailContext.m
	(+listContextsForUser:withTDBIndexing:inMemCtx:): added back
	"trashName".

	* SoObjects/Appointments/SOGoCalendarComponent.m
	(-sendEMailUsingTemplateNamed:forObject:previousObject:toAttendees:withType:):
	added a "msgType" parameter that is added as value to the new
	"x-sogo-message-type" header.
	(-sendIMIPReplyForEvent:from:to:): added a "x-sogo-message-type"
	to the headers.

	* OpenChange/MAPIStoreMailContext.m
	(+listContextForUser:withTDBIndexing:inMemCtx:): make sure special
	folders have all the "folder" prefixes appended to their list of
	names (for nested folders).

	* OpenChange/MAPIStoreContext.m
	(+createRootFolder:withFID:andName:forUser:withRole:): when the
	creation of a folder fails in the proper contact, fallback on the
	fallback context.

	* SoObjects/Mailer/SOGoMailAccount.m
	(-toManyRelationshipKeysWithNamespaces:): for some reason, we were
	explicitly returning the drafts folder name in the batch whether
	the corresponding folder exists or not, which is useless and
	wrong since the folder in question might actually be a child of
	another folder.

	* OpenChange/MAPIStoreContext.m (-init): restored "containersBag"
	mechanism where root context folders that are deeper than the
	first level of their hierarchy needs to have their parent folders
	retained.

2012-02-23  Jean Raby   <jraby@inverse.ca>

	* debian/rules: add a symlink to let gdb find debugging symbols
  for libSOGo on debian/ubuntu. (gdb bug #9538)

2012-02-22  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/SOGo/SOGoUserManager.m
	(-authenticationSourceIDsInDomain:): when looking for a specific
	domain, also return sources that are not associated to a domain.

	* SoObjects/SOGo/SOGoSource.h
	(-lookupContactEntryWithUIDorEmail:inDomain:): changed this method
	of the protocol to specify a domain.
	(-fetchContactsMatching:inDomain:): idem.

	* SoObjects/Contacts/SOGoContactFolder.h
	(-lookupContactsWithFilter:onCriteria:sortBy:ordering:inDomain:):
	changed this method of the protocol to specify a domain.

	* UI/WebServerResources/UIxAclEditor.js (addUser): fixed case when
	both canSubscribeUsers and isPublicAccessEnabled are disabled.

	* SoObjects/SOGo/SQLSource.m
	(-_lookupContactEntry:considerEmail:inDomain:): if the configuration
	parameter DomainFieldName is defined for the source, set the user
	domain to the value of this field.
	(-fetchContactsMatching:inDomain:): when the configuration parameter
	DomainField is defined, limit the results to the entries matching
	the specified domain.

	* SoObjects/SOGo/SOGoUserManager.m (-sourceIDsInDomain): if the
	source is not associated to a domain, set it to the requested
	domain. It will be used by sources with dynamic domain assignation.

2012-02-22  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/SOGo/SQLSource.m (_lookupContactEntry:considerEmail:):
	make sure the value of column pointer to by _kindField is not nil,
	nor an NSNull instance before treating it like a string.
	Use the value of "_imapHostField", when available, to map the
	"c_imaphostname" value of the contact/user record.
	(-init): new "_imapHostField" ivar, holder of the value of
	IMAPHostFieldName of the source configuration dictionary.

2012-02-21  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/SOGo/SOGoSQLUserProfile.m (-fetchJSONProfileFromDB):
	removed an escaping hack for Oracle that should no longer be
	required after the recent fixes in the Oracle adaptor, and which
	was causing bad unescaping of double-escaped backslashes.

	* Tests/Unit/TestSBJsonParser.m (-test_parseJSONString): added a
	line for escaped characters.

	* SoObjects/Appointments/SOGoAppointmentFolders.m
	(-davEventsDefaultClassification,)
	(setDavEventsDefaultClassification:)
	(-davTasksDefaultClassification)
	(-setDavTasksDefaultClassification:): new DAV accessors for the
	default classification preferences.

	* Tests/Integration/test-default-classification.py: new test
	module for setting/getting defaults classification preferences.

2012-02-20  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* UI/Scheduler/UIxComponentEditor.m (-setComponent:): fetch
	default classification from user defauts.

	* UI/PreferencesUI/UIxPreferences.m
	(-calendarClassificationsList): new getter for the list of
	classifications.
	(-itemClassificationText): new i81n getter.
	(-setEventsDefaultClassification:, -eventsDefaultClassification)
	(-setTasksDefaultClassification:, -tasksDefaultClassification):
	new accessors.

	* SoObjects/SOGo/SOGoUserDefaults.m
	(-setCalendarEventsDefaultClassification:)
	(-calendarEventsDefaultClassification)
	(-setCalendarTasksDefaultClassification:)
	(-calendarTasksDefaultClassification): new accessors related to
	the user-configured default classification of calendar components.

	* UI/Scheduler/UIxComponentEditor.m: s/privacy/classification/g,
	which is a better description for the "CLASS" attribute.

2012-02-20  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/UIxMailEditor.js (onWindowResize): we now
	make use of the ckeditor javascript api to reszie the container.

2012-02-20  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreGCSFolder.m (-setDisplayName:): new method
	that intercept the setting of PR_DISPLAY_NAME_UNICODE following
	the mechanism described below.
	(-getPrDisplayName:inMemCtx): overriden method.

	* OpenChange/MAPIStoreGCSBaseContext.m (+folderNameSuffix): new
	method that returns an optional suffix to differentiate between
	SOGo folders that are common to multiple Outlook folders, in
	particular for Calendar and Tasks folder.
	(+getFolderDisplayName:): new utility method that returns a
	display name with the above suffix added properly.

	* OpenChange/MAPIStoreObject.m (-setMAPIRetainCount)
	(-retainCount): removed accessors as well as the corresponding
	"mapiRetainCount" ivar as this was part of an unused feature.

2012-02-16  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/UIxAttendeesEditor.js (checkAttendee):
	stop observing events on input field before removing the row,
	otherwise the blur event is triggered and generates an error.

2012-02-14  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/ContactsUI.js (contactsListCallback): when
	restoring selection after the folder refresh, call "selectElement"
	on each row. This fixes the contacts selection retrieval when using the
	contextual menu.

2012-02-14  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/SOGo/SOGoUserManager.m (_compactAndCompleteContacts:):
	we make sure that "source" is not nil before assigning it to the
	compact record.

	* SoObjects/SOGo/SQLSource.m (_lookupContactEntry:considerEmail:):
	assign self as value for "source" in the returned record.
	(-fetchContactsMatching): same as above.

	* SoObjects/SOGo/SOGoSQLUserProfile.m (_sqlJsonRepresentation:):
	removed obsolete method.
	(-storeJSONProfileInDB:): we now properly escape the stored value
	via the adaptor methods and by using a hacking EOAttribute
	instance (FIXME).

	* OpenChange/MAPIStoreMailFolder.m (-ensureFolderExists): new
	method that attempts to create a folder when it does not exists
	and returns NO if that creation failed or YES in any other case.
	(-createFolder:withFID:andKey:): rc was never initialized when in
	success code.
	(-messageKeysMatchingQualifier:andSortOrderings:)
	(-folderKeysMatchingQualifier:andSortOrderings:)
	(-permissionEntries): invoke "ensureFolderExists" prior to any
	operation.

	* OpenChange/MAPIStoreContext.m
	(+createRootFolder:withFID:andName:forUser:withRole:): removed the
	"andTDBIndexing:" argument.
	(+createRootSecondaryFolderWithFID:andName:forUser:): same as
	above.

	* OpenChange/MAPIStoreCalendarMessage.m
	(-subscriberCanReadMessage): returns YES when the current role is
	ComponentDAndTViewer too.

2012-02-13  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* UI/WebServerResources/JavascriptAPIExtensions.js
	(String.asCSSIdentifier): escape the "+" character as its going to
	be used in a regexp.

2012-02-13  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* UI/Contacts/UIxContactView.m (-photoURL, -hasPhoto): copied code
	from UIxContactEditor, thereby replacing "photosURL".

2012-02-10  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* UI/MailPartViewers/UIxMailPartHTMLViewer.m (+initialize): added
	all simple tag to "VoidTags", based on list from
	http://www.w3.org/TR/html4/index/elements.html.

	* UI/WebServerResources/JavascriptAPIExtensions.js
	(String.asCSSIdentifier): same as below.

	* SoObjects/SOGo/NSString+Utilities.m (-setupCSSEscaping): add
	"_P_" as escaping sequence for "+".

	* UI/MailPartViewers/UIxMailPartHTMLViewer.m (+initialize): added
	all simple tag to "VoidTags", based on list from
	http://www.w3.org/TR/html4/index/elements.html.

2012-02-10  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/generic.js (openMailTo): recipients are
	now a JSON string (see commit of February 2nd).

	* UI/MailPartViewers/UIxMailPartHTMLViewer.m
	(-startElement:namespace:rawName:attributes:): we should not add
	end tags to void tags (ex: <br>).

2012-02-08  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/SOGo/SOGoGCSFolder.m (+webdavAclManager): must include
	"write" in the "current-user-privilege-set" so the latest version
	of AddressBook.app (bundled with 10.7.3) knows the personal
	addressbook is writable by the owner.

	* UI/WebServerResources/UIxAttendeesEditor.js
	(performSearchCallback): set the uid parameter to null instead of
	an empty string when the returned contact has no uid (ie, it comes
	from a personal addressbook).

2012-02-06  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/SOGo/LDAPSource.m: escape built DNs using the new
	-[NSString escapedForLDAPDN] method.

2012-02-03  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/UIxMailEditor.js (onRemoveAttachments):
	instead of extracting the filename from the text nodes under the
	list element, we now use the title attribute. This fixes an issue
	with IE that would append an extra space to the filename.

2012-02-03  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreFolderTable.m
	(-evaluatePropertyRestriction:intoQualifier:): overriden method to
	always return true for restrictions on PR_CHANGE_NUM, in order to
	help the fxics mechanism.

	* OpenChange/MAPIStoreFolder.m (-deleteFolder): cleanup the caches
	in order to let the folder disappear.

	* OpenChange/MAPIStoreSOGo.m (sogo_backend_create_root_folder):
	new backend method.

	* OpenChange/MAPIStoreFolder.m (-createFolder:withFID:andKey:):
	modified method to return a enum mapistore_error, in order to
	better determine of the failures that occur.

	* OpenChange/MAPIStoreMailFolder.m (-deleteFolder): overriden method.

	* SoObjects/Mailer/SOGoMailFolder.m (-exists): new method that
	returns whether an IMAP folder exists or not yet.

2012-02-02  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/MailerUI/UIxMailMainFrame.m (-composeAction): recipient
	addresses are now passed as a JSON-formatted string.

	* UI/MailerUI/UIxMailAccountActions.m (-composeAction): the
	received "mailto" parameter is now a JSON-formatted string; we
	parse it accordingly.

2012-02-01  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreUserContext.m (-destroy): dont't release
	"username" as it is not initially retained.
	(+userContextWithUsername:andTDBIndexing:): the resulting instance
	is cached in the table from here instead.

	* OpenChange/MAPIStoreTable.m (-destroyHandle:): skih operation if
	the handle parameter is 0.

	* OpenChange/SOGoMAPIFSMessage.m (-delete): returns the exception
	rather than raising it.

	* OpenChange/SOGoMAPIFSFolder.m (-delete): new method that removes
	the directory from the filesystem.

	* OpenChange/MAPIStoreGCSFolder.m (-deleteFolder): overriden method.

	* OpenChange/MAPIStoreFolder.m (-deleteFolder): implemented method.

	* SoObjects/SOGo/SOGoParentFolder.m (-removeSubFolder): new method
	that removes a subfolder entry from the folder cache.

	* OpenChange/MAPIApplication.m (-setUserContext:): do not retain
	the user context.

2012-02-01  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/UIxCalUserRightsEditor.js (onUpdateACL):
	added some serious warnings when giving access rights to any
	authenticated users or public access.

	* UI/WebServerResources/UIxMailUserRightsEditor.js (onUpdateACL): idem.

	* UI/WebServerResources/UIxContactsUserRightsEditor.js (onUpdateACL): idem.

	* UI/Common/UIxUserRightsEditor.m (-folderName): new method that
	returns the folder display name.
	(-userDisplayName): now also return the names of anonymous and
	authenticated users.

2012-01-31  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/SOGo/WOResourceManager+SOGo.m
	(-pathToLocaleForLanguageNamed:): if the language has a CamelCase
	form, add the first part to the lookup languages.

2012-01-31  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreMailContext.m
	(+listContextsForUser:withTDBIndexing:inMemCtx:): now returns
	secondary folders.
	(+[MAPIStoreOutboxContext
	listContextsForUser:withTDBIndexing:inMemCtx:]): overridden method
	in outbox-specific class.

2012-01-30  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreMailFolder.m (-addProperties): overriden
	method in order to intercept rename operations.
	(-initWithSOGoObject:inContainer:): removed obsolete method.

	* OpenChange/MAPIStoreGCSFolder.m (-addProperties): overriden
	method in order to intercept rename operations.

	* SoObjects/Mailer/SOGoMailFolder.m (-renameTo:): new method,
	implementing most of the code from [UIxMailFolderActions
	renameFolderAction].

	* OpenChange/MAPIStoreFallbackContext.m
	(+listContextsForUser:withTDBIndexing:inMemCtx:): now returns the
	fallback subfolders as secondary contexts (tmp hack).

	* OpenChange/MAPIStoreUserContext.m (-rootFolders): new method
	replacing the "...root" methods in way that can match the
	MAPIModuleName.

	* OpenChange/MAPIStoreGCSBaseContext.m
	(+listContextsForUser:inMemCtx:): centralized code for all GCS
	classes.

2012-01-30  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/UIxCalUserRightsEditor.js (onUpdateACL):
	ask confirmation when giving access to all authenticated users or
	when giving public access.

	* UI/WebServerResources/UIxMailUserRightsEditor.js (onUpdateACL): idem.

	* UI/WebServerResources/UIxContactsUserRightsEditor.js (onUpdateACL): idem.

	* UI/WebServerResources/SchedulerUI.js (onViewEventCallback):
	moved start/end time just under the event name.

	* UI/WebServerResources/generic.js (showConfirmDialog): this
	function now accepts two additional arguments to change the
	default "yes" and "no" buttons.

2012-01-29  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreMailContext.[hm]: removed
	"MAPIStoreInboxContext", "MAPIStoreSentItemsContext",
	and child folders."MAPIStoreDraftsContext" and
	"MAPIStoreOutboxContext" which have made obsolete by the new
	provisioning and instantiation mechanisms.

	* OpenChange/MAPIStoreContext.m (-woContext:, -mapping)
	(-authenticator): those methods are now part of
	MAPIStoreUserContext.
	(-setupBaseFolder:): removed method, obsoleted by those below.
	(-getRootFolder:withFID:): the "root folder" is now instantiated
	by lookups from the root folder provided by the user context and
	the chain of folders listed in the context url path.
	(-MAPIStoreFolderClass): new method returning the Class object
	representing the context's class of objects.
	(-rootSOGoFolder): new method that returns the proper root folder
	depending on the context's class of objects.

	* OpenChange/MAPIStoreFolder.m (-initWithURL:inContext:): all
	folders are now instantiated the same way since root objects are
	now stored in the MAPIStoreUserContext instancesB.
	(-setContext:): new setter to provide a reference to the folder's
	mapistore context instance from the topmost parent.
	(-setupVersionsMessage:): new helper method invoked during the
	folder instantiations, from the moment its parent context has been
	made available, which does not occur at the same moment for parent
	and child folders...

	* OpenChange/MAPIApplication.m (-init): removed the "mapiContext"
	but added the "userContext" ivars.

	* SoObjects/SOGo/SOGoFolder.m (-outlookFolderClass): removed
	useless method.

	* OpenChange/MAPIStoreUserContext.[hm]: new class for accessing
	user data common to all "mapistore contexts" as a singleton: the
	same instance is used across all requests until all related
	objects have been freed.

2012-01-27 Ludovic Marcotte  <lmarcotte@inverse.ca>

	* SoObjects/Appointments/SOGoAppointmentFolder.m
	(bareFetchFields: ...) - we now cache the returned
	results - just like for fetchFields:...

	* SoObjects/Appointments/SOGoAppointmentFolderObject.m
	(_folderCalenars) - we now ask for the c_content and use
	a local autorelease pool to avoid consuming too much memory

2012-01-26  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreCommonViewsContext.[hm],
	OpenChange/MAPIStoreDeferredActionsContext.[hm],
	OpenChange/MAPIStoreFreebusyContext.[hm],
	OpenChange/MAPIStoreJournalContext.[hm],
	OpenChange/MAPIStoreRemindersContext.[hm],
	OpenChange/MAPIStoreScheduleContext.[hm],
	OpenChange/MAPIStoreSearchContext.[hm],
	OpenChange/MAPIStoreShortcutsContext.[hm],
	OpenChange/MAPIStoreSpoolerContext.[hm],
	OpenChange/MAPIStoreViewsContext.[hm]: deleted obsolete classes.

	* OpenChange/MAPIStoreFolder.m (supportsSubFolders): new
	overridable method that returns whether the current folder can
	contain subfolders, nowithstanding the right of the current user
	to create or access them.

	* OpenChange/MAPIStoreSOGo.m (sogo_backend_list_contexts): new
	backend method.

	* OpenChange/MAPIStoreContext.m
	(+listAllContextsForUser:inMemCtx:): centralized method for
	returning all contexts available from all context classes for one
	user.
	(+listContextsForUser:inMemCtx:): new individual method invoked by
	the above. Overridden by concrete subclasses.

2012-01-26 Ludovic Marcotte  <lmarcotte@inverse.ca>

    * SoObjects/SOGo/LDAPSource.{h,m} - now honor
	userPasswordAlgorithm when changing the password with
	no password-policy. It'll now be encrypted per your
	preference. This fixes #755

2012-01-25  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* SOPE/GDLContentStore/GCSFolder.m - we now use the proper
	method to determine column types, avoiding the generation
	of broken UPDATE statements on MySQL when snoozing alarms.

2012-01-24  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/Scheduler/UIxCalFolderActions.m (-importAction): failback to
	latin-1 when utf-8 decoding doesn't work.

2012-01-19  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/UIxMailToSelection.js
	(addressFieldChanged): remove commas before testing email regexp.

2012-01-17  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* UI/WebServerResources/UIxFilterEditor.js (setupNewFilterData):
	mark new filter as active by default.

2012-01-17  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/UIxPreferences.js (initPreferences): When
	the mail composer is set to use HTML, the reply position popup
	menu is disabled. When switching to text-based message,
	the popup menu is now correctly re-enabled.

2012-01-16  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/SOGo/SQLSource.m (_lookupContactEntry:considerEmail:)
	(fetchContactsMatching:): assigned self to the "source" key of the
	returned dictionaries.

2012-01-13  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/Appointments/SOGoAppointmentFolder.m
	(-caldavFreeBusyRequestOnRecipient:withUID:andOrganizer:from:to:):
	if the recipient is not associated to a user (from an
	authentication source), verify if it is a contact (from an
	addressbook source). If it is, SOGoFreeBusyObject will take care
	of fetching the freebusy information if the contact is associated
	to a MS Exchange server.

	* SoObjects/Appointments/SOGoFreeBusyObject.m
	(-iCalPersonWithUID:): if no user is found from an authentication
	source, verify if it matches a contact from an addressbook
	source.
	(-contentAsStringWithMethod:andUID:andOrganizer:andContact:from:to:):
	added new parameter "contactID".

	* SoObjects/Appointments/iCalPerson+SOGo.m (-contactIDInContext:):
	new method that tries to associated the person's email address to
	a contact ID.

2012-01-12  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/SOGo/SOGoSource.h (-bindDN, -bindPassword)
	(-MSExchangeHostname): new accessors to the SOGoDNSource protocol.

	* SoObjects/SOGo/LDAPSource.m (-_convertLDAPEntryToContact:):
	added a reference to the instance source in the returned dictionary.

	* SoObjects/SOGo/SOGoUserManager.m
	(-_compactAndCompleteContacts:): keep the source instance in the
	returned dictionary.

	* UI/MainUI/SOGoUserHomePage.m (-readFreeBusyAction): the http
	post can now include an optional "uid" parameter to perform the
	freebusy lookup on the user corresponding to the specified
	uid. This covers the special case where we want to query a user
	from a contact source (not an authentication source) and for which
	external freebusy information is available (currently limited to a
	Microsoft Exchange server with Web Services enabled).

	* SoObjects/Appointments/SOGoFreeBusyObject.m
	(-fetchFreeBusyInfosFrom:to:forUser:): new method currently
	limited perform a SOAP request to a MS Exhange server to retrieve
	the freebusy information of a user.

	* UI/Scheduler/UIxComponentEditor.m (-_loadAttendees): when the
	attendee's email address doesn't match a user from the
	authentication source(s), perform a lookup in the addressbook
	source(s). If the email matches a user from a source with a
	MSExchangeHostname, return a concatenation of the active user uid
	and this contact uid.

	* UI/WebServerResources/UIxAttendeesEditor.js
	(performSearchCallback): if a matching contact has the
	"isMSExchange" attribute, prefix the uid with the login uid.
	(_performAjaxRequest): query the freebusy information from the
	login user (/SOGo/so/<loginuser>/freebusy.ifb/ajaxRead?uid=<contact>)
	when a contact uid is specified. Otherwise, perform the query on
	the user instance as usual (/SOGo/so/<contactuser>/freebusy.ifb/ajaxRead).

2012-01-12  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreCalendarMessage.m (-save): same as below +
	ensure that nil fields are removed from non-new instances.

	* OpenChange/MAPIStoreAppointmentWrapper.m
	(-getPrStartDate:inMemCtx:, -getPrEndDate:inMemCtx:): remove the
	tz offset from dates in all-day events.

	* OpenChange/MAPIStoreTasksMessage.m (-save): the dates provided
	by Outlook for start, due and completed are all-day dates, we thus
	need to remove the timezone offset from those dates.

2012-01-11  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreGCSMessageTable.m
	(_fixedDatePropertyRestriction:inMemCtx:): attached the result to
	the memCtx passed as parameter to avoid a leak.

2012-01-10  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/Appointments/SOGoAppointmentObject.m
	(_requireResponseFromAttendees:): initialize listHasChanged to NO.

	* OpenChange/MAPIStoreMailFolder.m (_parseCOPYUID): the uniString
	buffer was allocated one byte too short.

2012-01-09  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/NSObject+MAPIStore.m (-getValue:forTag:inMemCtx:):
	handle PT_SVREID just as PT_BINARY.

	* OpenChange/MAPIStoreCalendarFolder.m (-exchangeRightsForRoles):
	add the freebusy read rights when the user has read permission on
	calendar objects.

2012-01-05  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/SOGo/SOGoUserManager.m (-_registerSource:inDomain::):
	log error when duplicated IDs are found.

2012-01-04  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* UI/WebServerResources/ContactsUI.js
	(onAddressBooksMenuPrepareVisibility): the "new list", "sharing" and "import"
	options are now greyed out properly, depending on the object type
	and the new attributes below.

	* UI/Contacts/UIxContactFoldersView.m
	(-currentContactFolderAclEditing)
	(-currentContactFolderListEditing): new attribute accessors.

	* SoObjects/SOGo/SOGoFolder.m (-sendFolderAdvisoryTemplate:):
	moved method from SOGoGCSFolder in order to make it available to
	other folder classes.

	* SoObjects/SOGo/LDAPSource.m (-initFromUDSource:inDomain:): use
	the new setters for certain ivars + take the new "abOU" key into
	account.
	(-setListRequiresDot:, -listRequiresDot:, -setSourceID:)
	(-setDisplayName, -displayName, -setModifiers:): new accessors.
	(-_convertRecordToLDAPAttributes): we now strip object classes that
	are not supported by the server prior to remove the related fields.
	(-hasUserAddressBooks): new method that returns whether user
	addressbooks are supported, i.e. when "abOU" is set.
	(-addressBookSourcesForUser:): when "abOU" is set, returns an
	array of LDAPSource instances representing the personal
	addressbooks of the specified user.
	(-addAddressBookSource:withDisplayName:forUser:)
	(-renameAddressBookSource:withDisplayName:forUser:)
	(-removeAddressBookSource:forUser:): new methods with a
	self-explicit name.

	* SoObjects/Contacts/SOGoContactSourceFolder.m
	(-setIsPersonalSource, -isPersonalSource): new accessors for the
	"isPersonalSource ivar".
	(-lookupName:inContext:acquire:): setup the object classes of the
	new entries to "inetorgperson" and "mozillaabpersonalpha".
	(-lookupContactsWithFilter:onCriteria:sortBy:ordering:): check
	whether "listRequiresDot" is set on the current source and return
	the full listing if not required.
	(-compare:): enhanced to treat personal sources as if they were
	regular GCS folders, in order to sort them properly.
	(-delete, -renameTo:): implemented method, required for the
	corresponding web methods.
	(-ownerInContext:) adapted method to personal sources.

	* SoObjects/Contacts/SOGoContactFolders.m (-appendPersonalSource):
	overriden method for returning LDAP-based user addresbook sources.
	(-newFolderWithName:andNameInContainer:): idem
	(-renameLDAPAddressBook:withDisplayName:): new method that enables
	the renaming of LDAP-based user addresbook sources.
	(-removeLDAPAddressBook:): new method that enables
	the removal of LDAP-based user addresbook sources.

2012-01-03  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/SOGo/SOGoParentFolder.m (-appendPersonalSources): made
	method public so that it can be easily overriden in subclasses.

	* SoObjects/SOGo/SOGoUser.m (-authenticationSource): new method
	that returned the SOGoSource instance that successfully recognized
	the user represented by the current instance.

	* SoObjects/SOGo/SOGoUserManager.m
	(_fillContactInfosForUser:withUIDorEmail:inDomain:): we now set
	the identifier of the source that authenticated the specified user
	as the "SOGoSource" entry of the returned dictionary.

2012-01-03  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/Appointments/SOGoAptMailNotification.m (-setupValues):
	don't set the start/end times when dealing with an all-day event.

	* SoObjects/Appointments/SOGoAptMailInvitation.m (-getBody): don't
	display the start/end times when dealing with an all-day event.

	* SoObjects/Appointments/SOGoAptMailReceipt.m (-_formattedUserDate:): idem.

	* SoObjects/Appointments/SOGoAptMailUpdate.m (-getSubject): idem.

	* SoObjects/Appointments/SOGoAptMailDeletion.m (-getBody): idem.

2012-01-02  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/UIxPreferences.js (getFilterFromEditor):
	return a string (JSON) so the data is properly passed to the
	opened window with IE7.

	* UI/WebServerResources/UIxFilterEditor.js (ensureFieldValidity):
	a field value is always considered invalid when empty.

2011-12-30  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/SOGo/LDAPSourceSchema.[hm]: new class module enabling
	schema auto-discovery.

	* UI/WebServerResources/UIxContactEditor.js
	(validateContactEditor): the birth date is validated slightly
	differently, by enabling empty and 2-digit years as well as single
	digits months and days.

	* UI/Contacts/UIxContactView.m (-defaultAction, -dealloc): retain
	and release the "card" ivar.
	(_formattedURL:): the url should be displayed only if it is
	non-nil AND non-empty.
	(-vcardAction): removed useless method.

	* UI/Contacts/UIxContactEditor.m (init): removed the "snapshot",
	"preferredEmail", "card", "photosURL" and "contactCategories" ivars.
	(-ldifRecord): new getter that proxy the invocation to the client
	object, but by taking the contactEmail and contactFN url
	parameters. Replaces the "-snapshot" getter, since the LDIF record
	is now directly edited.
	(-addressBooksList): the client object container class is no
	longer taken into account when fetching the current user's permissions.
	(-supportCategories, -supportPhotos): new getters that enables the
	categories and photo tabs.
	(-setJsonContactCategories:, -jsonContactCategories): now make
	use of the special "vcardcategories" parameter found in the
	contact LDIF record.

	* SoObjects/SOGo/SQLSource.m (_lookupContactEntry:considerEmail:):
	enhanced to copy the "c_XX" fields to unprefixed equivalents.

	* SoObjects/Contacts/NSString+LDIF.m (mustEncodeLDIFValue): new
	method, replacing "_isLDIFSafe" in a clearly public manner.

	* SoObjects/SOGo/LDAPSource.m (-[NGLdapEntry _asDictionary]): new
	utility method to convert an entry into a "SOGo LDIF record".
	(-[NGLdapAttribute _asArrayOrString]): new utility method to
	convert an LDAP attribute into a string or an array of strings
	when the attribute has one or more values.
	(-initFromUDSource:inDomain:): handle the new "modifiers",
	"mapping" and "objectClasses" configuration keys, used when the
	source instance is used as an addressbook. All LDAP fields are now
	converted to lowercase.
	(_searchAttributes): removed method as the special "*" attribute
	is not costly enough to justify its existence, thereby reducing
	code complexity.
	(-lookupContactEntry:, -lookupContactEntryWithUIDorEmail:)
	(-lookupLoginByDN:): merged common code in the new
	-_lookupLDAPEntry: method, that accepts an EOQualifier as argument.
	(--addContactEntry:withID:, -updateContactEntry: and
	removeContactEntryWithID:): new methods for editing addressbook
	sources.

	* SoObjects/Contacts/SOGoContactSourceFolder.m (-source): new
	getter for the "source" ivar.
	(-lookupName:inContext:acquire:): accept the creation of new LDIF
	entries via web methods ending with "AsContact".
	(-saveLDIFEntry:, -deleteLDIFEntry:): new proxy methods for the
	new SOGoSource -addContactEntry:withID:, -updateContactEntry: and
	removeContactEntryWithID: methods, enabling the creation,
	modification and deletion of LDAP contacts.
	(-aclsForUser:): implemented method based on the array returned by
	-[<SOGoSource> modifiers].

	* SoObjects/Contacts/SOGoContactLDIFEntry.m (-vCard): the vcard is
	now generated automatically from the LDIF record of the entry,
	using the new method provided by NGVCard+SOGo.
	(-aclsForUser:): new overriden method similar to the
	implementation from SOGoContentObject.

	* SoObjects/Contacts/SOGoContactGCSEntry.m (-setLDIFRecord)
	(-ldifRecord, -hasPhoto): new accessors required by the
	SOGoContactObject protocol.
	(-lookupName:inContext:acquire:): return the only photo element
	when the "photo" key is requested, if present in the card.
	(-save): now returns an NSException, instead of void.

	* SoObjects/Contacts/SOGoContactEntryPhoto.m
	(+entryPhotoWithID:inContainer:, -setPhotoID:): removed methods,
	since there can only be one PHOTO element per contact.
	(-photo): simplified thanks to the constraint mentionned above.

	* SoObjects/Contacts/NSDictionary+LDIF.m (-ldifRecordAsString):
	new method implementing the code previously found in
	SOGo/NSDictionary+Utilities.m, in order to produce a textual
	representation of an LDIF record.

	* SoObjects/Contacts/NSDictionary+LDIF.[hm]: new category module.

	* SoObjects/Contacts/NGVCard+SOGo.m (-asLDIFRecord): new method
	implementing the conversion code previously found in
	UIxContactEditor, in order to produce an "LDIF record" in the form
	of an NSDictionary matching the inetOrgPerson and
	mozillaAbPersonAlpha object classes.
	(-updateFromLDIFRecord:) reciprocal method to "-asLDIFRecord",
	with conversion code moved from UIxContactEditor.

	* SoObjects/Contacts/SOGoFolder+CardDAV.m (_isValidFilter:): make
	use of the lowercase instance of the string, which was erroneously
	ignored previously.

2011-12-29  Ludovic Marcotte  <lmarcotte@inverse.ca.>

	* SoObjects/SOGo/SOGoSQLUserProfile.m (_sqlJsonRepresentation:):
	don't escape the / character as it's generating invalid JSON
	output on newer versions of PostgreSQL.

	* Dropped all references to "SOGoMailCheckAllUnseenCounts". We
	now check all folders for which filters are defined with a
	"fileinto" action - even if they are disable.

	* UI/MailerUI/UIxMailAccountActions.m (_jsonFolders:) - we
	use a local autorelease pool in the tight loop to avoid consuming
	too many LDAP connections during its execution.

2011-12-23  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/Scheduler/UIxAppointmentEditor.m (-viewAction): the end
	date/time is now also returned.

	* UI/PreferencesUI/UIxPreferences.m (-vacationEndDate): return
	current date when no end date is defined.

	* Tools/SOGoToolUserPreferences.m (-run): fixed possible out of
	bound exception when parsing arguments.

2011-12-22  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/Scheduler/UIxTaskEditor.m (-takeValuesFromRequest:inContext:): remove alarms
	when no start date is defined.

	* UI/WebServerResources/UIxTaskEditor.js (onTimeControlCheck):
	disable the reminder popup menu when no start date is defined.

2011-12-15  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* SoObjects/SOGo/SOGoSieveManager.m - slightly reworked
	the code to use NSURL in order to instanciate the SOPE
	Sieve code - that permits using TLS.

2011-12-14  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/ContactsUI.js (getMenus): register the
	function onWindowResize only if it's not already defined.

2011-12-12  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/Appointments/iCalEvent+SOGo.m (-quickRecord): set
	"c_category" to NULL when empty.

	* OGoContentStore/OCSContactFieldExtractor.m
	(-extractQuickFieldsFromVCard:): same as above.

2011-12-12  Francis Lachapelle  <flachapelle@inverse.ca>

	* Tools/SOGoEAlarmsNotifier.m
	(-_sendMessageWithHeaders:content:toAttendee:from:withMailer:):
	encode sender and recipient addresses in quoted printatble.

	* SoObjects/Contacts/SOGoContactGCSFolder.m
	(-fixupContactRecord:): fallback on organization name when the
	contact has no display name, no firstname, and no lastname.

	* UI/Contacts/UIxContactView.m (-fullName): idem.

2011-12-09  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/MainUI/SOGoRootPage.m (_cookieWithUsername:): the SOGoLogin
	cookie now expires in one month.

2011-12-09  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* UI/SOGoUI/UIxComponent.m (-userHasCalendarAccess)
	(-userHasMailAccess): moved from UIxPageFrame.

	* UI/Common/UIxToolbar.m (-cssClasses): new accessor that
	generates the CSS classes dynamically depending on the button
	state and it descriptor's cssClass.

	* UI/WebServerResources/generic.js (parent$): handle the case
	where window.opener is null.

2011-12-08  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreFSMessageTable.m
	(-evaluatePropertyRestriction:intoQualifier:): interpret filtering
	on PR_SUBJECT_UNICODE in order to include
	PR_NORMALIZED_SUBJECT_UNICODE and PR_SUBJECT_PREFIX_UNICODE in the
	search, as PR_SUBJECT_UNICODE might not actually exist on the FS
	messages.

	* OpenChange/MAPIStoreObject.m (-addPropertiesFromRow:): perform
	test on PT_STRING8 alone after "masking" the ulPropTag with 0xfff,
	since PT_XX values are not bitmasks.

2011-12-06  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/ContactsUI.js (contactsListCallback):
	Force deselection of all rows when changing addressbook.

2011-12-06  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/Appointments/iCalEvent+SOGo.m (-firstOccurrenceRange):
	same as below.

	* SoObjects/Appointments/SOGoAppointmentFolder.m
	(_flattenCycleRecord:forRange:intoArray:): reverted to retrieving
	the event start date using the old and buggy method, adapted to
	the new NGCards API.

2011-12-05  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/MailerUI.js (deleteSelectedMessages)
	(onMailboxTreeItemClick, onMessageSelecitionChange)
	(configureMessageListEvents): update the message content div only
	if it exists (will be hidden in single-window mode).

	* UI/WebServerResources/UIxContactsUserFolders.js
	(initUserFoldersWindow): registered "click" event on new Done button.

	* UI/WebServerResources/UIxMailEditor.js (onContactAdd): show
	contacts in a pane instead of a new window.
	(onContactFolderChange): new method to update the contacts list
	when changing contacts folder from the new popup menu.
	(configureDragHandle): new method to allow the new contacts pane
	to be resizable.
	(onMailEditorResize): was onWindowResize. Now computes the space
	used by the search contacts pane.

	* UI/WebServerResources/ContactsUI.js (getMenus): the function now
	overloads the returning array with the menus defined by the
	previously defined function with the same name. Used in
	UIxMailEditor.wox that loads both MailerUI.js and ContactsUI.js.
	(contactsListCallback): added support for 2-column view. Also
	used in mail editor to refresh the new contacts pane.
	(initContacts, onContactSelectionChange): don't update contactView when the div
	doesn't exist.
	(configureDraggables): don't allow drag'n'drop when the folders
	list doesn't exist.

	* UI/MainUI/UIxLoading.m: new class for empty template used when
	loading the iframe in single-window mode.

2011-12-05  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* UI/Scheduler/UIxComponentEditor.m (-setCategory): ensure that
	the new category is reported in the "categories" ivar.

	* SoObjects/Appointments/iCalEvent+SOGo.m (-quickRecord):
	-[iCalEntityObject categories] returns an NSArray that we need to
	convert to a string for the database content.

	* SoObjects/Appointments/iCalToDo+SOGo.m (-quickRecord):
	-[iCalEntityObject categories] returns an NSArray that we need to
	convert to a string for the database content.

2011-12-02  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreNotesMessage.m
	(-getPrMessageClass:inMemCtx:): explicit method.
	(-getPrSubject:inMemCtx:): explicit method.

	* OpenChange/MAPIStoreMessage.m (-getPrAccess:inMemCtx:)
	(-getPrAccessLevel:inMemCtx:): reimplemented methods in a generic
	way just like the MAPIStoreFolder versions.

	* OpenChange/MAPIStoreFSMessage.m (-subscriberCanModifyMessage):
	handle the case where the message is being created.

	* OpenChange/MAPIStoreFSFolder.m
	(-messageKeysMatchingQualifier:andSortOrderings:): ensure the
	active user can read the folder messages before returning them.

2011-12-01  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreFAIMessage.m (-subscriberCanReadMessage)
	(-subscriberCanModifyMessage): always return "NO" for subscribers.

	* OpenChange/MAPIStoreFSFolder.m: mapped role strings into
	variables.

	* OpenChange/MAPIStoreGCSMessage.m (-getPrAccess:inMemCtx:)
	(-getPrAccessLevel:inMemCtx:): return a value based on the ACL
	getters below.

	* OpenChange/MAPIStoreFSMessage.m (-subscriberCanReadMessage):
	returns YES when the message is of class
	"IPM.Microsoft.ScheduleData.FreeBusy", as a hack until freebusy
	messages are handled by the backend.

	* OpenChange/MAPIStoreContext.m (_prepareContextClass): now return
	the context via a pointer parameter. Return a proper "enum
	mapistore_error" value.

	* OpenChange/MAPIStoreCalendarMessage.m (-appointmentWrapper):
	pass the owner user as parameter to the appointment wrapper
	contructor rather than the active user.
	(-save): make use of the owner user coordinates instead of the
	ones of the active user. Handle the "sent-by" parameter for the
	organizer element.

	* OpenChange/MAPIStoreFolder.m
	(-openMessage:withMID:forWriting:inMemCtx:): takes a new
	"forWriting:" parameter and make use of subscriberCanModifyMessage
	and subscriberCanReadMessage to return a proper error code, if
	needed.

	* OpenChange/MAPIStoreSOGo.m (sogo_folder_open_message): added the
	"write_access" parameter.

	* OpenChange/MAPIStoreTasksMessage.m:
	invoke component:secure: with the secure parameter set to "YES" in
	all accessors that requires the iCalTask object.

	* OpenChange/MAPIStoreCalendarMessage.m (-appointmentWrapper):
	invoke component:secure: with the secure parameter set to "YES".

	* OpenChange/MAPIStoreTasksMessageTable.m
	(-evaluatePropertyRestriction:intoQualifier:): return
	MAPIRestrictionStateAlwaysTrue for PR_SENSITIVITY since privacy
	filtering is performed internally.

	* OpenChange/MAPIStoreGCSMessageTable.m (-componentQualifier):
	removed useless accessor, left over by a previous commit.

	* OpenChange/MAPIStoreGCSFolder.m (-aclQualifier): new accessor
	providing an additional qualifier when listing elements of a
	table, based on the current user rights.
	(-messageKeysMatchingQualifier:andSortOrderings:): make use of the
	new -aclQualifier method when the active user is not the owner of
	the sogo object. Slightly simplified code by storing all
	qualifiers in an array passed as parameter to the EOAndQualifier
	constructor.

	* OpenChange/MAPIStoreMessage.m (-subscriberCanReadMessage)
	(-subscriberCanModifyMessage): new getters for ACL operations at
	the message level.

	* OpenChange/MAPIStoreFolder.m (-subscriberCanCreateMessages)
	(-subscriberCanModifyMessages, -subscriberCanReadMessages)
	(-subscriberCanDeleteMessages, -subscriberCanCreateSubFolders):
	new getters for ACL operations at the folder level.

2011-11-30  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/SOGo/SOGoFolder.m
	(_expandPropertyResponse:forObject:): set the element in the 404
	bag only if the value is nil to avoid iCal complaining about lack
	of support for sharing.

	* SoObjects/Appointments/SOGoCalendarProxy.m (+webdavAclManager):
	overriden method.
	(-davGroupMemberSet, -setDavGroupMemberSet:): instantiate the
	"Calendar" object from the result of -[self lookupUserFolder]
	instead of "container", since we might attach proxy objects to
	other containers.

	* Main/SOGo+DAV.m (-davPrincipalURL): new DAV getter.
	(-davPrincipalSearchPropertySet): added "calendar-user-type", even
	though it's a lie.
	(-davComplianceClassesInContext:): declare
	"calendar-query-extended", "extended-mkcol",
	"calendarserver-principal-property-search" as additional classes,
	even though it's a lie.

	* SoObjects/Appointments/SOGoUserFolder+Appointments.m
	(-davCalendarUserAddressSet): make sure each email address is
	reported only once, we also return the user principal in the list
	(for iCal).

	* SoObjects/SOGo/SOGoObject.m (-davComplianceClassesInContext:):
	declare "calendar-query-extended", "extended-mkcol",
	"calendarserver-principal-property-search" as additional calendar
	classes, even though it's a lie.
	(-davCurrentUserPrincipal): new method.

	* SoObjects/Appointments/SOGoAppointmentFolder.m (-davResourceId):
	new DAV getter.

	* SoObjects/SOGo/SOGoUserFolder.m (-davResourceId): new DAV getter.

	* SoObjects/SOGo/SOGoFolder.m (-davPrincipalURL): moved from
	SOGoUserFolder.

	* SoObjects/SOGo/WORequest+SOGo.m (-isICal, -isICal4): updated for
	iCal 5.

	* SoObjects/Appointments/SOGoAppointmentInboxFolder.m
	(-davScheduleDefaultCalendarURL): fixed method to return a
	properly formatted XML chunk.
	(-displayName): returns nameInContainer.

	* SoObjects/Appointments/SOGoAppointmentFolder.m
	(-davCalendarTimeZone): fixed by embedding the VTIMEZONE element
	in a VCALENDAR.

2011-11-29  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreTypes.m (NSObjectFromSPropValue): set the
	resulting string to @"" when the unicode or string pointers are
	NULL.

2011-11-28  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/SOGoUI/UIxComponent.m (-singleWindowModeEnabled): new method
	that returns true if the single-window mode is enabled. This mode
	can be forced by setting the cookie "SOGoWindowMode" to "single".

	* UI/MailerUI/UIxMailEditor.m (-contactFolders)
	(-personalContactInfos, -setCurrentFolder:, -currentContactFolderId)
	(-currentContactFolderName, -currentContactFolderOwner)
	(-currentContactFolderClass): getters/setters for new contacts
	pane in the mail editor.

2011-11-28  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreContext.m
	(-initFromURL:withConnectionInfo:andTDBIndexing:): assign a
	SOGoUser corresponding to the object owner and to the active user
	to the "ownerUser" and "activeUser" ivars.

	* SoObjects/Appointments/SOGoAppointmentFolder.m
	(-bareFetchFields:from:to:title:component:additionalFilters:):
	we must not attempt to instantiate an EOQualifier with a "nil"
	format, otherwise it causes an exception. Settings the qualifier
	as nil instead.

2011-11-24  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/ContactsUI.js (resetCategoriesMenu): the
	event listener must be on mousedown since click is already
	observed by document.body.

2011-11-23  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreContactsMessageTable.m
	(-evaluatePropertyRestriction:intoQualifier:): returns
	"MAPIRestrictionStateAlwaysTrue" for PR_SENSITIVITY.

	* OpenChange/MAPIStoreContactsMessage.m
	(-getPrSensitivity:inMemCtx:): new getter that always returns 0.

2011-11-22  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/NSArray+MAPIStore.m (-asMVUnicodeInMemCtx:) renamed
	from "asArrayOfUnicodeStringsInCtx".
	(-asMVUnicodeInMemCtx:, -asMVLongInMemCtx:): new conversion
	methods.

	* OpenChange/MAPIStoreTypes.m (NSObjectFromValuePointer):
	simplified method by using set_SPropValue_proptag and
	NSObjectFromSPropValue.

	* OpenChange/NSObject+MAPIStore.m (-getValue:forTag:inMemCtx:):
	renamed from "getMAPIValue:...".
	(-arrayFromMAPIMVLong:, +arrayFromMAPIMVUnicode:)
	(+arrayFromMAPIMVString:, +arrayFromMAPIMVBinary:)
	(+arrayFromMAPIMVGuid:, +arrayFromMVShort:, +arrayFromMVLong:)
	(+arrayFromMVI8:, +arrayFromMVUnicode:, +arrayFromMVString:)
	(+arrayFromMVBinary:, +arrayFromMVGuid:, +arrayFromMVFileTime:)
	new constructors for multivalue types.

2011-11-21  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* SoObjects/SOGo/WORequest+SOGo.m - for now, we consider iCal 4
	and iCal 5 to be the same and added new strings to recognize
	Apple Address Book on Mac OS X 10.7 (Lion)

	* SoObjects/Contacts/SOGoContactGCSFolder.m - we now skip list
	if we deal with Apple Address Book. If we don't do this and
	a "vlist" is present, no card will be displayed at all.

2011-11-21  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/UIxPreferences.js (initPreferences):
	initialize calendar for the new vacation end date optional parameter.

	* UI/PreferencesUI/UIxPreferences.m (-enableVacationEndDate)
	(-disableVacationEndDate, -setEnableVacationEndDate:)
	(-vacationEndDate, -setVacationEndDate:): getters/setters for the
	new optional vacation end date.

2011-11-20  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreFolder.m (-lookupFolder:): explicitly set
	the MAPIStoreContext's woContext as context to the looked up
	folder, although one could expect it to have been set during the
	lookup at the SOGo level...

	* OpenChange/MAPIStoreFSFolder.m (-lookupFolder:): removed useless
	overriding of method.

	* OpenChange/MAPIStoreMailFolder.m (-[MAPIStoreMailFolder
	lookupFolder:]): removed useless overriding of method.
	(-[MAPIStoreInboxFolder lookupFolder:]): in altnamespace mode,
	perform the same association of the woContext to the looked up
	folder as in MAPIStoreFolder.

	* OpenChange/MAPIStoreContext.m
	(-initFromURL:withConnectionInfo:andTDBIndexing:): instantiate a
	SOGoUser corresponding to the username of the new context and
	associated it to the woContext ivar.

2011-11-18  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreFolder.m (-permissionEntries): new public
	method.
	(-modifyPermissions:withCount:andFlags:): new backend op public
	method.
	(-aclFolder, -rolesForExchangeRights:, -exchangeRightsForRoles:):
	new mandatory methods.

	* OpenChange/SOGoMAPIFSFolder.m (-defaultUserID, -addUserInAcls:)
	(-removeAclsForUsers:, -aclUsers, -aclsForUser:)
	(-setRoles:forUser:): implemented standard ACL methods.

	* OpenChange/MAPIStorePermissionsTable.m
	(+[MAPIStorePermissionEntry
	entryWithUserId:andMemberId:forFolder:]): constructor now takes a
	memberId and the container folder as parameters.
	(-[MAPIStorePermissionEntry getPrMemberId:inMemCtx:]): now based
	on the new memberId ivar.
	(-[MAPIStorePermissionEntry getPrEntryId:inMemCtx:]): now make use
	of MAPIStoreInternalEntryId for regular member ids and return an
	empty blob for special ones, as specified in oxcperm.
	(-[MAPIStorePermissionEntry getPrMemberName:inMemCtx:]): now
	returns the real CN of the user for regular member ids and return
	@"" or @"Anonymous" for special ones, as specified in oxcperm.
	(-[MAPIStorePermissionEntry getPrMemberName:inMemCtx:]): now
	returns the real member rights, based on the aclFolder of the
	container, using standard SOGo methods.

	* OpenChange/MAPIStorePermissionsTable.h
	(MAPIStorePermissionsEntry): made class public.

	* OpenChange/MAPIStoreSOGo.m (sogo_folder_modify_permissions): new
	backend op.
	(sogo_backend_init): invoke "disableLocalCache" to avoid the
	caching of ACL.

	* SoObjects/SOGo/SOGoCache.m (-disableLocalCache): new method to
	disable the local cache altogether (helper for non-WO access).

2011-11-17  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreSamDBUtils.m: new module containing helpers
	pertaining to the SamDB.
	(MAPIStoreSamDBUserAttribute): new function that returns the value
	of a specified key from a user record matching one simple criteria.
	(MAPIStoreInternalEntrydId, MAPIStoreExternalEntryId): moved
	functions from MAPIStoreMessage.m.

	* OpenChange/MAPIStoreMessage.m (MAPIStoreInternalEntryId): now
	takes a ldb_context * parameter pointing to the samdb, which
	enables us: 1) to return the real legacyExchangeDN 2) to make use
	of sAMAccountName as search parameter for the username.

2011-11-16  Ludovic Marcotte  <lmarcotte@inverse.ca>

	*  SoObjects/SOGo/SOGoSieveManager.m (-updateFiltersForLogin:...)
	We now handle connection exceptions to avoid crashing sogod.

2011-11-13  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreContactsMessage.m (-getPrBody:inMemCtx:):
	same as below.

	* OpenChange/MAPIStoreAppointmentWrapper.m (-getPrBody:inMemCtx:):
	removed parsing hack since things are now done properly from
	NGCards.

	* Tests/Unit/TestVersit.m (-test_rendering, -test_parsing):
	adapted to new NGCards data structure and improved to test further
	important use cases.

2011-11-10  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* Tests/Unit/TestVersit.m: new test module for versit parsing and
	outputting.

2011-11-09  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreCalendarMessage.m (-save): set the DESCRIPTION
	field to the value of PR_BODY_UNICODE or, a textual version of
	PR_HTML. COMMENT would be nice later.

	* OpenChange/MAPIStoreAppointmentWrapper.m (-getPrBody:inMemCtx:):
	make use of -[NSString asCardAttributeValues].

	* OpenChange/MAPIStoreContactsMessage.m (-save): set the NOTE
	field to the value of PR_BODY_UNICODE or, a textual version of
	PR_HTML.

	* OpenChange/MAPIStoreMessage.m (-addProperties): intercept
	PR_RTF_COMPRESSED attributes and convert them automatically to a
	PR_HTML attribute.

	* OpenChange/MAPIStoreVolatileMessage.m (-addProperties:):
	transfer the content of the "properties" ivar instead of the
	"newProperties" parameter, so as to benefit from treatment that
	could have happened in parent classes.

	* OpenChange/MAPIStoreMailVolatileMessage.m
	(_generateMailDataWithBcc:): don't write the resulting mail body
	to /tmp/mimegen.eml.

2011-11-09  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/SOGoRootPage.js (onLoginClick): don't
	assume that the checkbox rememberLogin is always part of the template.

2011-11-08  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreRecurrenceUtils.m
	(-fillRecurrencePattern:withStartDate:andEndDate:): fixed a crash
	occurring when no byday mask was specified. We also force a value
	for the monthday in the case of a yearly event without a proper
	one.

2011-11-07  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreFolder.m (-addProperties:): we now override
	this method instead of -addPropertiesFromRow:. Also, invoking
	resetCache is no longer required since the "properties" ivar is
	no longer used in this class.

	* OpenChange/MAPIStoreObject.m (-addPropertiesFromRow:): now
	invokes [self addProperties:] to modify the "properties" ivar,
	instead of doing it directly. This enables subclasses to only need
	overriding -addProperties:.
	(-resetProperties): removed useless method.

	* OpenChange/MAPIStoreVolatileMessage.m (-addPropertiesFromRow:):
	removed obsolete overloading of method.

2011-11-02  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreMessage.m (-setReadFlag:): make overrides
	optional.

	* OpenChange/MAPIStoreCalendarMessage.m (-save): handle all day
	events based on the value of PidLidAppointmentSubType.
	Don't add the timezone component to the vCalendar in that case.
	Take PidLidAppointmentStateFlags into account before building the
	list of attendees. Take the organizer passed in the recipients
	into account when specified.

2011-11-01  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/UIxAclEditor.js (addUser): fixed CSS class
	"normal-person" that was replaced by "normal-user".

2011-11-01  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreCalendarMessage.m (-save): added work-around
	for setting of organizer as an attendee record.

	* OpenChange/MAPIStoreMailMessage.m (-setReadFlag:): implemented
	basic method, only dealing with actual setting or unsetting of
	"\Seen".

	* OpenChange/MAPIStoreCalendarMessage.m (-setReadFlag:): overriden
	with dumb implementation, since it seems to be invoked on this
	kind of object.

2011-10-31  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreContactsAttachment.m
	(-getPrAttachEncoding:inMemCtx:, -getPrAttachFlags:inMemCtx:)
	(-getPrAttachmentFlags:inMemCtx:)
	(-getPrAttachmentHidden:inMemCtx:)
	(-getPrAttachmentLinkid:inMemCtx:, -getPrAttachSize:inMemCtx:):
	new getters.

	* OpenChange/MAPIStoreSOGo.m (sogo_message_set_read_flag): new
	backend op.

	* OpenChange/MAPIStoreMailMessage.m (-_fetchBodyData): fetch body
	keys with BODY.PEEK rather than just BODY, to disabled the
	automatic setting of the "\Seen" flag.

	* SoObjects/Mailer/SOGoMailBodyPart.m (-fetchBLOBWithPeek:): new
	method that enables the fetching of body parts either via "BODY"
	or "BODY.PEEK".

	* SoObjects/Mailer/SOGoMailObject.m
	(-addRequiredKeysOfStructure:path:toArray:acceptedTypes:withPeek:):
	added a "withPeek" parameter that enables the fetching of body
	parts either via "BODY" or "BODY.PEEK".

2011-10-28  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreMailVolatileMessage.m (_generateMailData):
	don't consider "orig" type recipients.
	Added "withBCC" parameter. Reorganized code to produce better
	mime-compliant messages, in particular with regards to the
	handling of multipart/* body parts. Split method in many
	specialized submethods for code clarity.
	(-getMessageData:inMemCtx:): overriden method for this class.

	* OpenChange/MAPIStoreSOGo.m (sogo_message_modify_recipients):
	adapted backend function to the new prototype, where the message
	recipients are preparsed and now passed an array of "struct
	mapistore_message_recipient", rather than a struct
	ModifyRecipientRow.

	* OpenChange/MAPIStoreTypes.m (NSObjectFromValuePointer): new
	function returning an instance of an appropriate class based on a
	property tag and a corresponding value passed as void *.

	* OpenChange/MAPIStoreFSMessage.m (-canGetProperty:): method moved
	up in MAPIStoreVolatileMessage.

2011-10-27  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/UIxAttendeesEditor.js
	(performSearchCallback): show a list email address (usually an
	LDAP group) unless the list has no email address (usually a
	personal contacts list).

	* UI/WebServerResources/SOGoRootPage.js (initLogin): added sliding
	effect to about box.

2011-10-27  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreObject.m (-canGetProperty:): new method that
	determines whether a property can be requested on a
	MAPIStoreObject instance or descendant thereof, in order to take
	different ways of fetching properties into account, whether
	through a dynamic getter or some dictionary...
	(-getAvailableProperties:inMemCtx:): now compute the returned
	array based on the result of invocations of -[self
	canGetProperty:].

	* OpenChange/MAPIStoreFSMessage.m
	(+getAvailableProperties:inMemCtx:): fixed a leak by attaching the
	array of enum MAPITAGS to "properties".
	(-canGetProperty:): overriden method.

	* OpenChange/MAPIStoreVolatileMessage.m: MAPIStoreMemMessage renamed
	to MAPIStoreVolatileMessage.
	(-getAvailableProperties:inMemCtx:) removed obsolete method.
	(-init): creationTime and lastModificationTime are now ivars.
	(-lookupAttachment:): implemented manadatory method.

	* OpenChange/SOGoMAPIVolatileMessage.m: SOGoMAPIMemMessage renamed
	to SOGoMAPIVolatileMessage.

2011-10-26  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/SOGo/SQLSource.m
	(-checkLogin:password:perr:expire:grace:): authentication can be
	performed against any database column defined in the new
	LoginFieldNames defaults parameter.
	(-_lookupContactEntry:considerEmail:): idem.

2011-10-26  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreFSMessage.m,
	OpenChange/MAPIStoreMailVolatileMessage.m: new descendants of
	MAPIStoreMemMessage.

	* OpenChange/MAPIStoreDraftsMessage: replaced class with
	MAPIStoreMemMessage, enabling the creation of mails from any mail
	folder.

	* OpenChange/MAPIStoreMessage.m
	(-modifyRecipientsWithRows:andCount:andColumns:): take BCC
	recipients into account.

	* OpenChange/MAPIStoreMessage.m
	(_convertRecipientFromRow:andColumns:): temp hack: make use of
	set_mapi_SPropValue_sogo instead of set_mapi_SPropValue, which was
	reversed in openchange to the old behaviour.

	* OpenChange/MAPIStoreObject.m (-init): renamed "newProperties"
	ivar to "properties".
	(-addNewProperties:): renamed to "-addProperties:"
	(-resetNewProperties:): renamed to "-resetProperties:"
	(-setProperties:): renamed to "-addPropertiesFromRow:"

	* OpenChange/MAPIStoreSOGo.m (sogo_message_create_attachment):
	implemented new backend method.

2011-10-25  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/MainUI/SOGoRootPage.m (-cookieUsername)
	(-cookieWithUsername:): getter/setter for the new SOGoLogin
	cookie. This is used for the new "Remember username" checkbox that
	appears on the login page.

2011-10-25  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/EOQualifier+MAPIFS.[hm]: now evaluates
	SOGoMAPIMemMessage.

	* OpenChange/SOGoMAPIFSMessage.[hm]: now a subclass of
	SOGoMAPIMemMessage.

	* OpenChange/MAPIStoreDraftsMessage.m (_saveAttachment:): make use
	of MAPIStoreMIME.

	* OpenChange/MAPIStoreMIME.[hm]: new class module implementing a
	singleton helper that deduces mime types from file extensions,
	based on the content of /etc/mime.types.

	* OpenChange/MAPIStoreAttachment.m,
	OpenChange/MAPIStoreCalendarAttachment.m,
	OpenChange/MAPIStoreMailAttachment.m: replaced the
	getProperty:withTag:inMemCtx: method with its switch case to make
	use of the more recent dynamic property getters API.

	* OpenChange/gen-property-selectors.py: added a few exclusions,
	which are either undocumented or unused.

2011-10-24  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreAttachment.m
	(-getProperty:withTag:inMemCtx:): fallback on super's
	implementation to benefit from the property getters methods.

	* OpenChange/MAPIStoreContactsMessage.m (-getPrBody:inMemCtx:): if
	the attribute length is 0, return MAPISTORE_ERR_NOT_FOUND.
	(-_fetchAttachmentParts, -getPidLidHasPicture:inMemCtx:)
	(-attachmentKeysMatchingQualifier:andSortOrderings:)
	(-lookupAttachment:): new methods for retrieving contact pictures
	in the VCARD.
	(_updatePhotoInVCard:fromProperties:): new method that inserts a
	"PHOTO" element in the VCARD depending on the PR_ATTACH_*
	properties.

	* OpenChange/MAPIStoreContactsAttachment.[hm]: new class module
	for handling contact "attachments", that is, contact pictures.

	* OpenChange/plreader.m (PLReaderDumpPListFile): ignore "error" if
	the returned property list object is not nil, since "error" might
	still be set with GNUstep.

2011-10-21  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/SOGo/SOGoUserManager.m
	(-_compactAndCompleteContacts:): add the key "isGroup" when defined.

	* UI/MainUI/SOGoUserHomePage.m (:_usersForResults:inDomain:):
	add a boolean value in the returning array that identifies if the
	user is actually a group.

	* UI/Common/UIxAclEditor.m (-currentUserClass): return the CSS
	class that identifies the user as a single contact or list of contacts.

	* UI/WebServerResources/UIxContactsUserFolders.js
	(addUserLineToTree): extract the new field that is set to 1 when
	the user is actually a group.

	* UI/WebServerResources/UIxAclEditor.js (addUser): new argument to
	to identify the type of user (person or group).

	* UI/WebServerResources/UIxMailToSelection.js
	(expandContactListCallback): don't expand contacts without an
	email address.

2011-10-19  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreDraftsMessage.m (-getPrDisplayTo:inMemCtx:)
	(-getPrDisplayBcc:inMemCtx:): new getters.

2011-10-18  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/generic.js (log): fixed an issue with
	Firefox and IE when SOGo was opened using a targeted link.

	* SoObjects/Mailer/SOGoMailFolder.m
	(-copyUIDs:toFolder:inContext:): now returns the raw IMAP response
	when the copy operation failed (most probably something like "Over quota").

2011-10-17  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreSOGo.m (sogo_backend_init): invoke
	-[NSProcessInfo initializeWithArguments:count:environment:] in
	order to avoid an infinite loop with GNUstep occurring under
	strange circumstances. Make use of "samba" as process name.

	* OpenChange/MAPIStoreMapping.m (-initForUsername:withIndexing:):
	attach the struct tdb_wrap *indexing to a new memCtx ivar, in
	order to make sure its value is retained until the release of the
	mapping instance.

2011-10-14  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreGCSMessageTable.m
	(-evaluatePropertyRestriction:intoQualifier:): removed useless
	condition to avoid warnings with certain versions of gcc.

2011-10-14  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/UIxMailToSelection.js
	(addressFieldChanged): we now split on commas only if no email
	address is detected.

	* UI/WebServerResources/SOGoMailDataSource.js (load): associated a
	unique id to the source using the url and its parameters.

	* UI/WebServerResources/SOGoDataTable.js (render): add the new
	source id to the current render id. This should solve incorrect
	messages appearing when fast-switching between folders or sort order.

	* SoObjects/SOGo/NSString+Utilities.m (-_rangeOfURLInRange:):
	fixed handling of brackets (inequality signs <>).

2011-10-14  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* SoObjects/SOGo/SOGoGCSFolder.m (setRoles:forUser:..)
	We now even cache "None" roles.
	* SoObjects/Mailer/SOGoMailObject.m (fetchCoreInfos)
	We now handle correctly untagged responses.

2011-10-13  Francis Lachapelle  <flachapelle@inverse.ca>

	* Tools/SOGoToolUserPreferences.m (-run): added possibility to
	specify a file (-f filename) when setting a user
	default/setting. Removed the constraint of specifying
	administrative credentials of the SIeve server when not setting a
	parameter related to Sieve.

2011-10-12  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreSOGo.m (sogo_manager_generate_uri): new
	backend op. Code from j.kerihuel@openchange.org.

	* OpenChange/MAPIStoreAppointmentWrapper.m
	(-initWithICalEvent:andUser:andSenderEmail:inTimeZone:): take a
	new "senderEmail" parameter in order to help the process of
	deducting the attendee in an invitation message not including a
	"METHOD".
	(-_setupITIPContextFromAttendees): fixed method to set the method
	as "REPLY" when the user is organizer rather than the other way
	around.

2011-10-11  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreAppointmentWrapper.m (-_setupITIPContext):
	new method that contains the common code for determining the ITIP
	status of the event and of the attendees.

	* OpenChange/MAPIStoreMailMessage.m (-init): "headerMethod" has
	become obsolete.
	(-getPrIconIndex:inMemCtx:, -getPrMessageClass:inMemCtx:): when
	mail is event, forward the invocation to the
	MAPIStoreAppointmentWrapper equivalent.

	* OpenChange/MAPIStoreAppointmentWrapper.m
	(-getPidLidReminderSet:inMemCtx:)
	(-getPidLidReminderDelta:inMemCtx:)
	(-getPidLidReminderTime:inMemCtx:)
	(-getPidLidReminderSignalTime:inMemCtx:)
	(-getPidLidReminderOverride:inMemCtx:)
	(-getPidLidReminderType:inMemCtx:)
	(-getPidLidReminderPlaySound:inMemCtx:)
	(-getPidLidReminderFileParameter:inMemCtx:): implemented those
	alarm-related getters (see OXORMDR).
	(-getPrIconIndex:inMemCtx:, -getPrMessageClass:inMemCtx:): updated
	code to handle REQUEST, REPLY (positive, negative and tentative)
	as well as "COUNTER" and "CANCEL".

	* OpenChange/MAPIStoreCalendarMessage.m (_setupAlarmDataInEvent:):
	new method invoked from -save that sets VALARM elements on the
	current event based on the PidLidReminder* properties.
	(-getPidLidReminderSet:inMemCtx:)
	(-getPidLidReminderDelta:inMemCtx:)
	(-getPidLidReminderTime:inMemCtx:)
	(-getPidLidReminderSignalTime:inMemCtx:)
	(-getPidLidReminderOverride:inMemCtx:)
	(-getPidLidReminderType:inMemCtx:)
	(-getPidLidReminderPlaySound:inMemCtx:)
	(-getPidLidReminderFileParameter:inMemCtx:): new alarm-related
	forwarders to homonymous methods in MAPIStoreAppointmentWrapper.

2011-10-09  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreMailFolder.m (-synchroniseCache): improved
	method to only fetch non-deleted messages in part 1, and to
	automatically remove message records in part 2, so that we know
	when a delete message has already been taken into account with
	regards to version numbers. The version number generation having
	been moved from getDeletedKeysFromChangeNumber:andCN:inTableType:.
	This also fixes the case where the last modification date was
	increased when any deleted message was found, because "known
	deleted messages" are now ignored.
	(-getDeletedKeysFromChangeNumber:andCN:inTableType:) Simplified
	method by moving most of it into -synchroniseCache and by
	returning the highest deleted modseq reported by the latter.

2011-10-07  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/UIxPreferences.js
	(displayAccountSignature): fixed the link to edit the signature
	when no signature was defined.

2011-10-06  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/generic.js (getListIndexForFolder): the
	personal folder now stays on top, as returned by the server.

2011-10-04  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/SOGo/SOGoObject.m (-davComplianceClassesInContext:):
	take all the supported DAV object classes in charge, in order to
	simplify the handling of those on topmost folders.

	* OpenChange/MAPIStoreFolder.m (-deleteMessageWithMID:andFlags:):
	invoke "prepareDelete" on the message object when available.

2011-10-03  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/generic.js (snoozeAlarm): new function to
	snooze an alarm for a specific number of minutes.
	(showAlarmCallback): offer the user to snooze the alarm right
	after triggering the browser-native alert.
	(showSelectDialog): new function that construct a dialog box with
	a popup menu.

	* UI/Scheduler/UIxAppointmentEditor.m (-viewAction): accepts the
	new form parameter snoozeAlarm, which delays the alarm to the
	specified number of minutes.

	* SoObjects/Appointments/SOGoCalendarComponent.m (-snoozeAlarm:):
	new method to set the next alarm of the event in a specified
	number of minutes. Only affect the quick table, not the original vCalendar.

2011-10-03  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* SoObjects/Appointments/SOGoAppointmentObject.m (-PUTAction:)
	We compare sequence numbers to make sure we correctly accept
	invitation replies for the "right" objects

2011-10-03  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreDraftsMessage.m (-submit): unregister id
	from mapping after operation.

	* OpenChange/MAPIStoreSOGo.m (sogo_message_modify_recipients):
	this backend op now has a "columns" arguments for the user data
	row.

2011-09-30  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreMailMessage.m (-getMessageData:inMemCtx:):
	same as below.

	* OpenChange/MAPIStoreCalendarMessage.m
	(-getMessageData:inMemCtx:): delegated code to
	MAPIStoreAppointmentWrapper so that organizers and invitees are
	properly reported both in invitation emails and events.

	* OpenChange/MAPIStoreMessage.m (MAPIStoreInternalEntryId)
	(MAPIStoreExternalEntryId): new helper functions that return an
	NSData with the entry id for the requested user or contact.
	(-getMessageData:inMemCtx:): adapted to the new mapistore_message
	struct and column handling.

	* OpenChange/NSData+MAPIStore.m (-appendUInt16): new method.

	* OpenChange/EOQualifier+MAPIFS.m (-[EOKeyValueQUalifier
	_evaluateMAPIFSMessageProperties:): ensure finalKey is never nil
	nor undefined.

2011-09-27  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreFSMessage.m (-getPrChangeKey:inMemCtx:):
	first return the value stored in the plist, if present. Otherwise
	fallback to the method making use of objectVersion.

	* OpenChange/MAPIStoreSOGo.m (sogo_folder_move_copy_messages):
	added the "target_change_keys" parameter.

	* OpenChange/MAPIStoreFolder.m
	(-moveCopyMessagesWithMID:fromFolder:withMID:wantCopy:): ensure
	the message URL exists in the MAPIStoreMapping, otherwise fail
	with MAPISTORE_ERR_NOT_FOUND, to avoid a crash. Passe the target
	changeKey as property to the new message.

	* OpenChange/MAPIStoreFSMessage.m (-objectVersion): return
	0xff...fff when "version" does not exist in the object properties.

2011-09-27  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/Common/UIxPageFrame.m (-userHasVacationEnabled): new method
	that returns whether the user has an automatic vacation message enabled.

	* SoObjects/SOGo/SOGoUserDefaults.m (-setBusyOffHours): new setter
	for the new defaults SOGoBusyOffHours, which defines if periods
	outside business hours should be opaque (busy).
	(-busyOffHours): getter corollary to the new method above.

	* UI/PreferencesUI/UIxPreferences.m (-setBusyOffHours:): new
	setter for the new defaults SOGoBusyOffHours.
	(-busyOffHours): getter corollary to the new method above.

	* SoObjects/Appointments/SOGoFreeBusyObject.m
	(-fetchFreeBusyInfosFrom:to:): add off-hours if defaults
	SOGoBusyOffHours is true.

2011-09-26  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreFolder.m
	(-moveCopyMessagesWithMID:fromFolder:withMID:wantCopy:): ensure
	that "data" is not NULL before passing it to
	set_SPropValue_proptag as it might be converted to a PT_ERROR
	value.
	(-moveCopyMessageWithMID:fromFolder:withMID:wantCopy:): fixed
	method name. Added PR_CHANGE_KEY and PR_PREDECESSOR_CHANGE_LIST to
	list of excluded properties.

	* SoObjects/Mailer/SOGoDraftObject.m (-sendMailAndCopyToSent:):
	renamed "sendMail" and made copying the messsage to the sent
	folder opetional.
	(-sendMail): new method that invokes the above one with "yes".

	* OpenChange/MAPIStoreMemMailMessage.m (-save): fixed "subject"
	header, "to" and other recipients. Fixed "content-type", that was
	deduced after "message" was generated. Take the client-provided
	PR_CHANGE_KEY into account to avoid synchronisation errors.

	* OpenChange/MAPIStoreDraftsMessage.m (-_commitProperties): make
	use of "PR_SUBJECT_PREFIX_UNICODE" and
	"PR_NORMALIZED_SUBJECT_UNICODE" to construct the "subject" header.
	(-submit): invoke the new "-sendMailAndCopyToSent:" method with
	"NO".

	* OpenChange/MAPIStoreMailMessage.m (-getPrChangeKey:inMemCtx)
	(-getPrPredecessorChangeList:inMemCtx): when a record is not
	returned, invoke the container's synchroniseCache method, as was
	done in -objectVersion.

	* OpenChange/MAPIStoreMailFolder.m (-synchroniseCache): renamed
	local var "folderWasModified" to "foundChange", as in
	MAPIStoreGCSFolder's version. Fixed a bug where "foundChange"
	would be reset to NO when deletes were not found, even if new
	elements were detected.

2011-09-23  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/PreferencesUI/UIxPreferences.m (-defaultCalendarList, -itemCalendarText,
	-userDefaultCalendar, -setUserDefaultCalendar:): new methods to
	show a popup menu for the new defaults SOGoDefaultCalendar. This
	option sets which calendar is used when creating an event or a
	task (selected, personal, first enabled).

	* UI/WebServerResources/SchedulerUI.js (eventsListCallback):
	events are always editable and erasable for superusers.
	(newEvent): added supported for the new defaults SOGoDefaultCalendar.

2011-09-23  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreGCSMessage.m (-getPrChangeKey:inMemCtx:):
	first force a synchronisation of the parent cache if the change key
	cannot be retrieved and invoke abort if the change key is still
	not available afterwards.

	* OpenChange/MAPIStoreMailMessage.m (-getPrChangeKey:inMemCtx:):
	same as above.

	* OpenChange/MAPIStoreMailFolder.m (-lastMessageModificationTime):
	invoke "synchroniseCache" in order to make sure we return the real
	last modification time.
	(-synchroniseCache): improved to increment the last modification
	time when messages have been deleted.

	* OpenChange/SOGoMAPIFSMessage.m (-mapistoreMessageClass): method
	implemented poorly (but work for now) and that differentiates
	between the MAPIStoreMessage classes based on certain elements in
	their folder path.

	* OpenChange/MAPIStoreFolder.m (-messageClass): removed method,
	replaced with the new mechanism below.

	* OpenChange/NSObject+MAPIStore.h (-mapistoreMessageClass): new
	category method that returns the proper MAPIStoreMessage wrapper
	class from instances of SOGoObject and children classes.

2011-09-22  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* OpenChange/MAPIStoreContactsMessage.m
	Added more field mappings (surname, given name,
	middle name, etc.)

2011-09-22  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreMailFolder.m (-createMessage): return a MAPIStoreMemMailMessage.

	* OpenChange/SOGoMemMessage.m: new class that only provides a
	temporary (memory-based) dictionary of Exchange attributes.
	Similar to SOGoMAPIFSMessage except for the ability to save the
	dictionary in question.

	* OpenChange/MAPIStoreMemMailMessage.m: new class that enables the
	saving of composed mail messages, during the different copy
	operations.

	* OpenChange/MAPIStoreDraftsMessage.m (-getPrChangeKey)
	(-getPrPredecessorChangeList:inMemCtx:): return
	MAPISTORE_ERR_NOT_FOUND.
	(-getPidLidImapDeleted:inMemCtx:, -getPrInternetMessageId:inMemCtx:): same
	as above.

	* OpenChange/MAPIStoreMailFolder.m (-[MAPIStoreDraftsFolder
	messageClass, createMessage]): restore methods.

	* OpenChange/MAPIStoreFolder.m
	(-moveCopyMessagesWithMIDs:andCount:fromFolder:withMIDs:wantCopy:):
	adapted to be invoked from the target folder.
	Implemented generic version for specialized folders lacking an
	implementation and for copying/moving items across folders of
	different types.
	(-postNotificationsForMoveCopyMessagesWithMIDs:andMessageURLs:andCount:fromFolder:withMIDs:wantCopy:):
	new helper method that performs the whole notification magic for
	message moves.

	* OpenChange/MAPIStoreSOGo.m (sogo_folder_move_copy_messages):
	adapted to last backend changes.

2011-09-21  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreMailFolder.m
	(-moveCopyMessagesWithMIDs:andCount:toFolder:withMIDs:wantCopy:):
	improved by acting directly on source and dest MIDs, by handling
	multiple messages at once and by accepting proper UID ranges in
	the COPYUID response.

	* OpenChange/MAPIStoreSOGo.m (sogo_folder_move_copy_messages):
	adapted to new backend prototype.

	* OpenChange/MAPIStoreFolder.m (-createMessage): reverse the
	specification of the "mid" parameter as the copy/move hack in
	MAPIStoreMailFolder is no longer needed.

2011-09-20  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreObject.m (-getReplicaKeyFromGlobCnt:): new
	method that returns the same result as
	getReplicaKey:fromGlobCnt:inMemCtx: in the form of an NSData
	instance.

	* OpenChange/MAPIStoreContactsMessage.m (-save): same as below.

	* OpenChange/MAPIStoreTasksMessage.m (-save): same as below.

	* OpenChange/MAPIStoreCalendarMessage.m (-save): set the
	PR_CHANGE_KEY to the value passed by the client after the version
	cache has been updated a first time.

	* OpenChange/MAPIStoreMailMessage.m (-getPrChangeKey:inMemCtx:,
	(-getPrPredecessorChangeList:inMemCtx:): same as below.

	* OpenChange/MAPIStoreGCSMessage.m (-getPrChangeKey:inMemCtx:,
	(-getPrPredecessorChangeList:inMemCtx:): wrapper accessors around
	the getters defined in MAPIStoreGCSFolder below.

	* OpenChange/MAPIStoreMailFolder.m
	(-setChangeKey:forMessageWithKey:, -changeKeyForMessageWithKey:)
	(-predecessorChangeListForMessageWithKey:): same as below.

	* OpenChange/MAPIStoreGCSFolder.m (-changeKeyForMessageWithKey:)
	(-predecessorChangeListForMessageWithKey:)
	(-setChangeKey:forMessageWithKey: (NSString *) messageKey): new
	methods for retrieving or setting the PR_CHANGE_KEY for the
	specified record. The PR_PREDECESSOR_CHANGE_LIST is also handled,
	albeit set automatically.

	* OpenChange/NSString+MAPIStore.m (+stringWithGUID:)
	(-extractGUID:): new wrapper methods around the GUID utility
	functions in libndr.

	* OpenChange/NSData+MAPIStore.m (+dataWithXID: asXIDInMemCtx:):
	new method to handle XID structs.
	(-appendUInt8, -appendUInt32): new methods to easily append
	integer values.

2011-09-19  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* OpenChange/MAPIStoreDraftsMessage.m: (_commitProperties)
	We now correctly handle the "importance" property

	* Added handling of PR_IMPORTANCE and PidLidBusyStatus
	for event objects

2011-09-14  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* SoObjects/Mailer/SOGoMailBaseObject.m: (imap4Connection):
	Cache "corruption" bug fix that could lead us to using the
	wrong IMAP connection for OpenChange users

	* OpenChange/MAPIStoreMapping.m: (unregisterURLWithID:)
	We also remove the keys/values from the indexing database

	*  OpenChange/MAPIStoreSOGo.m
	RopMoveCopyMessages, RopCopyTo and messages move/copy
	notifications support for messages

	* OpenChange/MAPIStoreContactsMessage.m: massive improvements
	to support many new properties

	* OpenChange/MAPIStoreTasksMessage.m: massive improvements
	to support many new properties

	* OpenChange/MAPIStoreFolder.m: (getPrAccess:inMemCtx:) fixed
	permissions issue - we were returning a wrong value leading to
	IMAP subfolders not being "writable"

	* SoObject/Mailer/SOGoMailFolder.m (prefetchCoreInfosForMessageKeys:)
	Fixed a MAJOR issue regarding keys handling. We should NEVER assume
	the untagged IMAP response's order will be the same as the FETCH's one!

	* SoObjects/Mailer/SOGoMailBaseObject.m: (imap4Connection) We now
	ensure the context is valid to properly get the user's login by
	using the container's context if the current one is nil

	* OpenChange/MAPIStoreMailFolder.m: (moveCopy...) Cleaned up some
	code and we now also correctly send notification updates for the
	destination folder

2011-09-04  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* OpenChange/MAPIStoreMapping.m: (MAPIStoreMappingTDBTraverse())
	Fixed a major issue regarding the use of strtoll. It was overflowing
	keys as they are unsigned long long int. We now make use of strtoull
	which fixes the problem and avoids major cache corruption of the
	indexing.tdb database (per user).

	* OpenChange/MAPIStoreSOGo.m: Some cleanups to ease current and
	future debugging

2011-08-18  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/UIxContactEditor.js
	(regenerateCategoriesMenu): register the onMenuClickHandler
	function on the mouse down event instead of the click event, since
	the contextual menu is hidden on the mouse down event. This fixes
	the bug where a predefined category could never be selected from
	the combo box.

2011-08-15  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreMailFolder.m
	(-[MAPIStoreMailFolder createFolder:withFID:inContainer:): new method
	that enables the specification of a SOGo object container.
	(-[MAPIStoreMailFolder createFolder:withFID:): rewritten method to make
	use of the above.
	(-[MAPIStoreInboxFolder createFolder:withFID:): rewritten method to make
	use of the above, with the choice container depending on the
	"usesAltNamespace" ivar.
	(-[MAPIStoreInboxFolder initWithURL:inContext:): overriden method
	to initialize the "usesAltNamespace" ivar based on the flags set
	on the "INBOX" folder.
	(-[MAPIStoreInboxFolder
	folderKeysMatchingQualifier:andSortOrderings:])
	(-[MAPIStoreInboxFolder lookupFolder:]):
	overriden methods to make use of "usesAltNamespace".
	(-[MAPIStoreMailFolder _imapFolderNameRepresentation:): new
	private method that combines the SOGo representation of an IMAP
	folder leaf, without the "folder" prefix, with the current folder
	as parent.
	(-[MAPIStoreMailFolder _cleanupSubfolderKeys:): new private method
	that tests the list of children keys passed as parameter and
	compare each one of them with the special folders: trash, sent and
	drafts and those that are found.
	(-[MAPIStoreInboxFolder _imapFolderNameRepresentation:): overriden
	method by taking the "altnamespace" ivar into account.

	* SoObjects/Mailer/SOGoMailAccount.m
	(-toManyRelationshipKeysWithNamespaces:): new method, superseding
	"toManyRelationshipKeys" that enables the returning of namespaces
	"folders" or not.

	* OpenChange/MAPIStoreMailMessage.m (-objectVersion): updated code
	as in MAPIStoreGCSMessage's version.

	* OpenChange/MAPIStoreMailFolder.m (-messageTable): we no longer
	cache the table object as we don't want to assign different
	handles to the same memory object, causing inconsistencies with
	tables instantiated twice with different parameters.

2011-08-13  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/Mailer/SOGoMailFolder.m
	(-lookupName:inContext:acquire:): fixed a crash occurring when the
	key didn't end with ".eml".

2011-08-12  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreMailMessageTable.m
	(-getRow:withRowID:andQueryType:inMemCtx:): overriden method to
	prefetch the "core infos" of messages that are going to be
	fetched.

2011-08-12  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/HTMLElement.js (refreshSelectionByIds):
	replaced the call to the Prototype method "down" in favor to a
	global access with the element ID. This fixes a multiple-message
	selection issue with IE.

2011-08-12  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/Mailer/SOGoMailFolder.m
	(-prefetchCoreInfosForMessageKeys:): new method that enables the
	prefetching and caching of "core infos" for messages.
	(-lookupName:inContext:acquire:): looked up messages are now fed
	with their cached core infos, if present.

	* SoObjects/Mailer/SOGoMailObject.m: (addFlags:, removeFlags:)
	release "coreInfos" rather than flagsCache, which has been
	obsoleted.
	(_hasFlag:): make use of "coreInfos" to fetch the flags since most
	of the time the other infos will be fetch for the same object,
	bringing a 30ms speedup per message.
	(-setCoreInfos): new accessor that enables setting coreInfos from
	an external object.
	(+initialize): coreInfoKeys was renamed to SOGoMailCoreInfoKeys
	and has now been published.

	* OpenChange/MAPIStoreTable.m (-setHandleId:): only register the
	table in the notification cache if the provided handle id is not
	null.

	* OpenChange/MAPIStoreCalendarMessage.m (-save): resynchronise the
	container cache after the operation.

	* OpenChange/MAPIStoreTasksMessage.m (-save): resynchronise the
	container cache after the operation.

	* OpenChange/MAPIStoreContactsMessage.m (-save): resynchronise the
	container cache after the operation.

	* OpenChange/MAPIStoreGCSMessage.m (-objectVersion): ensure that a
	change number is available when the message is "not new", but
	resynchronise the cache in doing so.

	* OpenChange/MAPIStoreSOGo.m (sogo_table_handle_destructor): added
	new backend operation.

	* OpenChange/NSAutoreleasePool+MAPIStore: removed module since it
	was a lot of code to handle one specific case.

	* OpenChange/MAPIStoreGCSMessageTable.m
	(-evaluatePropertyRestriction:intoQualifier:): create a local
	talloc context and free it at the end when generating a new date
	restriction.

	* OpenChange/plreader.m (-displayKey:withIndentation:): display
	alternative hex representation of the keys.

2011-08-11  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreFSFolderTable.[hm]: new module.

	* OpenChange/MAPIStoreFSFolder.m (-folderTable): overriden method
	to return a "MAPIStoreFSFolderTable" instance.
	(-folderKeysMatchingQualifier:andSortOrderings:): overriden method
	in order to evaluate folders by applying the received qualifer to
	the properties message.

	* OpenChange/MAPIStoreFolder.m (-objectVersion): implemented
	method based on the value provided in the folder props dictionary.
	(-propertiesMessage): new getter.

	* OpenChange/MAPIStoreObject.m (-objectVersion): now a mandatory
	method for subclasses.

2011-08-10  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreMapping.m
	(+mappingForUsername:withIndexing:): modified contrusctor to make
	use of a "username" parameter that enable per-user "singletons".
	(-increateUseCount, -decreaseUseCount): new accessors that enable
	the registration/unregistration of the mapping object from the
	singleton registry.

2011-08-08  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreFolder.m (-lookupMessage:): set the WOContext
	of the resulting SOGoObject to the value attached to the current
	MAPIStoreContext.

	* OpenChange/MAPIStoreCalendarMessageTable.m
	(-evaluatePropertyRestriction:intoQualifier:): implemented
	searches on PR_OWNER_APPT_ID in order to enable the retrieval of
	the requested invitation.

	* OpenChange/MAPIStoreCalendarMessage.m (-save): fixed attendees
	handling (only change the attendee partstat) and avoid saving the
	event when the newpartstat is "undefined".

	* OpenChange/MAPIStoreAppointmentWrapper.m
	(-getPrOwnerApptId:inMemCtx:): properly reimplemented the method
	following the spec.
	(-getPidLidServerProcessed:inMemCtx:): now returns yes in order to
	prevent the client from uselessly updating the event.

	* OpenChange/MAPIStoreMailMessage.m
	(-getPrReplyRequested:inMemCtx:): commented out method.
	(-getPrResponseRequested:inMemCtx:): returns NO when the message
	is an invitation, as the mail handling is performed internally by
	SOGo.
	(-getPrOwnerApptId:inMemCtx:): properly forwards the call to
	MAPIStoreAppointmentWrapper when required.
	(-getPidLidMeetingType:inMemCtx:): new method.

	* OpenChange/MAPIStoreContext.m (-activeUser): new helper method.

	* OpenChange/MAPIStoreSOGo.m (sogo_backend_init): invoke
	-activateApplication on the new app in order to make it accessible
	via [WOApplication application].

	* SoObjects/Appointments/SOGoAppointmentFolder.m
	(-lookupCalendarFoldersForUID:): make use of -[SOGoUser
	lookupCalendarFoldersForUID:].

	* SoObjects/Appointments/SOGoAppointmentObject.m
	(_handleAttendee:withDelegate:ownerUser:statusChange:inEvent:):
	enable updating the attendee's calendar when a WORequest is not
	available at all, for example from OpenChange.

2011-08-05  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/Contacts/UIxContactView.m (-contactCardTitle): removed this
	method since we no longer prefix the contact name by a label
	("Card For").
	(-_cardStringWithLabel:value:url:): new method that wraps the
	value with an <A> link with the specified URL type. Used for
	telephone numbers.

2011-08-05  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreAppointmentWrapper.m
	(-getPidLidGlobalObjectId:inMemCtx:)
	(-getPidLidCleanGlobalObjectId:inMemCtx:): reimplemented methods
	by following the spec carefully (MS-OXICAL: 2.1.3.1.1.20.26).

	* OpenChange/NSString+MAPIStore.m (-convertHexStringToBytes): new
	method that returns an NSData from a string of hex values
	represented as text.

2011-08-04  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreDraftsMessage.m (-getMessageData:inMemCtx:):
	overriden method.
	Made module able to handle SOGoMailObject as well, since we can
	possibly have such objects as value for sogoObject.
	(-getPrImportance:inMemCtx:): overriden method.
	(-getPrReceivedByEmailAddress:inMemCtx:): overriden method.
	(-getPrSenderEmailAddress:inMemCtx:): overriden method.
	(-getPrDisplayCc:inMemCtx:): overriden method.

	* OpenChange/MAPIApplication.m (+isCachingEnabled): new overriden
	method that returns "NO" in order to avoid leaking dictionaries
	that we don't use since we are not WO-based.

	* OpenChange/MAPIStoreMapping.m (-initWithIndexing:)
	(-registerURL:withID:): removed noisy warnings.

	* OpenChange/MAPIStoreSOGo.m (sogo_backend_create_context):
	adaoted to new prototype.

2011-08-02  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreFolder.m (-permissionsTable): new method
	that returns a permissions table for the current folder.

	* OpenChange/MAPIStorePermissionsTable.[hm]: new class module for
	handling permission objects. Currently only provide stub entries
	for the "anonymous" and "default" users.

	* OpenChange/MAPIStoreContactsMessageTable.m
	(-evaluateContentRestriction:intoQualifier:): overriden method in
	order to evaluate PR_MESSAGE_CLASS_UNICODE.
	(-evaluatePropertyRestriction:intoQualifier:): added stub support for
	PidLidAddressBookProviderArrayType,
	PidLidAddressBookProviderEmailList and real support for
	PidLidEmail[123]OriginalDisplayName.

	* OpenChange/MAPIStoreTable.m (-operatorFromRestrictionOperator):
	code split from -evaluatePropertyRestriction:intoQualifier: and
	exposed for external use.

2011-08-02  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/MailerUI.js (_onMenuLabelFlagX): fixed a
	bug when changing the flag of multiple messages.

	* UI/WebServerResources/SOGoRootPage.js (onLoginClick): reset
	error message (if any) when login in.

2011-08-01  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreFSMessage.m
	(-getAvailableProperties:inMemCtx:): take only NSNumber keys into
	account.

2011-07-29  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreTable.m (-dealloc): free the list of
	columns, otherwise the last list set is leaked.

2011-07-28  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreSOGo.m (sogo_folder_get_deleted_fmids):
	implemented new backend method.

	* OpenChange/MAPIStoreTable.m (-loggingPrefix): removed method as
	it was causing crashes when the parent object was deallocated.

	* SoObjects/Mailer/SOGoMailFolder.m (-statusForFlags:): new method
	that returns the values of flags passed as parameters.
	(-fetchUIDsOfVanishedItems:): new method that returns the list of
	UID that are reported to have vanished since the specified modseq.

2011-07-27  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreGCSMessageTable.m
	(-evaluatePropertyRestriction:intoQualifier:): now handles
	PR_CHANGE_NUM using the new methods below.

	* OpenChange/MAPIStoreGCSMessage.m (-objectVersion): overriden
	method to make use of -[MAPIStoreGCSFolder
	changeNumberForMessageWithKey:].

	* OpenChange/MAPIStoreGCSFolder.m (-initWithURL:inContext:)
	(initWithSOGoObject:inContainer:): initialise the new
	"versionsMessage" ivar, pointing to a SOGoMAPIFSMessage object
	that includes versioning information.
	(-lastMessageModificationTime): return the date value stored in
	"versionsMessage".
	(-synchroniseCache): new method that updates "versionsMessage"
	differentually with versioning data from the server.
	(-lastModifiedFromMessageChangeNumber:): new helper method that returns
	the corresponding c_lastmodified from a MAPI change number.
	(-changeNumberForMessageWithKey:): new helper method that returns the
	version number associated with a message.

	* OpenChange/MAPIStoreMailMessageTable.m
	(-evaluatePropertyRestriction:intoQualifier:): now handles
	PR_CHANGE_NUM using the new methods below.

	* OpenChange/MAPIStoreMailMessage.m (-objectVersion): overriden
	method to make use of -[MAPIStoreMailFolder
	changeNumberForMessageUID:].

	* OpenChange/MAPIStoreMailFolder.m (-initWithURL:inContext:)
	(initWithSOGoObject:inContainer:): initialise the new
	"versionsMessage" ivar, pointing to a SOGoMAPIFSMessage object
	that includes versioning information.
	(-lastMessageModificationTime): return the date value stored in
	"versionsMessage".
	(-synchroniseCache): new method that updates "versionsMessage"
	differentually with versioning data from the server.
	(-modseqFromMessageChangeNumber:): new helper method that returns
	the corresponding IMAP "modseq" from a MAPI change number.
	(-messageUIDFromMessageKey:): new helper method.
	(-changeNumberForMessageUID:): new helper method that returns the
	version number associated with a message.

	* OpenChange/MAPIStoreTable.m (-loggingPrefix): overriden method
	in order to get more useful informations.

	* OpenChange/MAPIStoreObject.m (-loggingPrefix): overriden method
	in order to get more useful informations.

	* OpenChange/MAPIStoreFSMessageTable.m
	(-evaluatePropertyRestriction:intoQualifier:): overriden method to
	handle PR_CHANGE_NUM, based on the messages version number.

	* OpenChange/MAPIStoreFSMessage.m (-objectVersion): overriden
	method to retrieve the object version from the "version" attribute
	in the properties list.
	(-save): update the "version" attribute in the saved property list
	from openchangedb.

	* OpenChange/MAPIStoreAppointmentWrapper.m
	(-getPidLidGlobalObjectId:inMemCtx:): work-around certain buggy
	events which might now have a "CREATED" element.

	* OpenChange/MAPIStoreContactsMessage.m: commented out
	"-getPrOabName:inMemCtx:" and "-getPrOabLangid:inMemCtx:" as they
	seem to be useful only for contact lists.

	* OpenChange/MAPIStoreFolder.m
	(-faiMessageKeysMatchingQualifier:andSortOrderings:):
	reimplemented method to make use of the new method below.

	* OpenChange/SOGoMAPIFSFolder.m
	(-toOneRelationshipKeysMatchingQualifier:andSortOrderings:): moved
	method from -[MAPIStoreFSFolder
	messageKeysMatchingQualifier:andSortOrderings:] in order to make
	it available to all the SOGoMAPIFSFolder clients.

	* OpenChange/MAPIStoreContext.m (-getNewChangeNumber): new
	utility method that returns a change number from the mapistore db
	via the openchangedb API.

	* OpenChange/SOGoMAPIFSMessage.m (-save): serialize the properties
	dictionary in binary plist format to avoid GNUstep bugs where
	high unsigned long long values are not parsed properly.
	(-properties): corrolary to the above change.

	* OpenChange/NSArray+MAPIStore.m (-asArrayOfUnicodeStringsInCtx:):
	the return type is now "struct WStringArray_r *".

	* OpenChange/NSString+MAPIStore.m (-asUnicodeInMemCtx): return an
	empty string when length == 0, otherwise the resulting pointer
	will be NULL.

	* OpenChange/plreader.m: new test tool to dump property lists
	independently from their serialization format.

2011-07-27  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/SOGo/SOGoUserFolder.m (-ownerInContext:): in case the
	user domain is specified in the URL but not in the user login
	name, we remove it (user@domain => user).

	* SoObjects/SOGo/SOGoUser.m (-initWithLogin:roles:trust:): drop
	the domain from the login name when loginDomains are enabled but
	domain-based UID is disabled.

2011-07-26  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreMailFolderTable.[hm]: removed useless class.

	* OpenChange/MAPIStoreTable.m (-lookupChild:)): new method that
	subclasses must override and that a child object matching the
	table type.

	* OpenChange/MAPIStoreObject.m (-lookupChild:): removed method as
	it was too generic. Each subclass has now its own set of
	specialized methods.
	(-childKeysMatchingQualiflier:andSortOrderings:) same as above.

	* OpenChange/MAPIStoreMessage.m (-lookupAttachment:): new method,
	replacing -[MAPIStoreObject lookupChild:].
	(-attachmentKeysMatchingQualiflier:andSortOrderings:) same as
	above, replacing (-[MAPIStoreObject
	childKeysMatchingQualiflier:andSortOrderings:]).

	* OpenChange/MAPIStoreFolder.m (-lookupFolder:, -lookupMessage:)
	(-lookupFAIMessage:): new methods, replacing -[MAPIStoreObject
	lookupChild:].
	(-messageKeysMatchingQualiflier:andSortOrderings:) same as
	above, replacing (-[MAPIStoreObject
	childKeysMatchingQualiflier:andSortOrderings:]).
	(-faiMessageKeysMatchingQualiflier:andSortOrderings:) same as
	above, replacing (-[MAPIStoreObject
	childKeysMatchingQualiflier:andSortOrderings:]).
	(-folderKeysMatchingQualiflier:andSortOrderings:) same as
	above, replacing (-[MAPIStoreObject
	childKeysMatchingQualiflier:andSortOrderings:]).

2011-07-26  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/MailerUI/UIxMailListActions.m
	(-getUIDsInFolder:withHeaders:): we check if the array of messages
	UIDs is nil prior adding it to the returned dictionary.

2011-07-25  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/Mailer/SOGoMailAccount.m (-hasCapability): new proxy
	method that determines whether an IMAP capability is present on
	the server.
	(-supportsQResync): new method that returns whether the server
	supports the "QRESYNC" capability.

2011-07-25  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/MainUI/SOGoRootPage.m (-connectAction): don't add the domain
	if domain-based UIDs are not enabled.
	(-changePasswordAction): idem.

	* SoObjects/SOGo/SOGoUser.m (-initWithLogin:roles:trust:): added
	test for the ivar "realUID" since it can be undefined if the
	corresponding source is down.

2011-07-22  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreSOGo.m (sogo_table_get_row_count): added new
	backend operation.

	* Tests/Unit/SaxXMLReaderFactory+SOGoTests.m: new module offering
	a category on SaxXMLReaderFactory that enables finding our NGCards
	SAX driver in our source directories.

2011-07-21  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreMailMessage.m: make use of the new class
	below for calendar contents.

	* OpenChange/MAPIStoreCalendarMessage.m: make use of the new class
	below.
	(-save): handle invitation replies.

	* OpenChange/MAPIStoreAppointmentWrapper.m: new wrapper class
	module that implements the getters for iCalEvent objects.

2011-07-20  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreMailMessage.m (-subject): new overridable
	accessor common to certain properties.

	* OpenChange/MAPIStoreObject.m: moved "-getEmptyString:inMemCtx:",
	"-getLongZero:inMemCtx:", "-getYes:inMemCtx:", "-getNo:inMemCtx:"
	into NSObject+MAPIStore.m

	* OpenChange/MAPIStoreFolder.m (-lookupFolder:, -createMessage:):
	assign the parent context woContext to the newly created
	SOGoObject to enable access to "activeUser".

	* SoObjects/SOGo/SOGoObject.m (-setContext, -context): new
	accessors for the "context" ivar.

2011-07-20  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/UIxMailToSelection.js
	(addressFieldLostFocus): call addressFieldChanged to validate the
	entry and split recipients in multiple fields.

2011-07-19  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreCalendarMessage.m: reordered certain private
	methods.
	(-ownerTimeZone): moved into MAPIStoreObject.

	* OpenChange/MAPIStoreMailMessage.m (-_setupBodyData): new
	centralized method that performs the common operations required to
	fetch the message body.
	(-getPrHtml:inMemCtx,-getPrBody:inMemCtx:): make use of the above
	method.

	* SoObjects/SOGo/NSString+Utilities.m
	(-countOccurrencesOfString:): new self-explicit method.

2011-07-19  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/SOGo/SOGoUserFolder.m (-_davFetchUsersMatching:):
	append the domain to the username when SOGoEnableDomainBasedUID is
	set to YES. When using domains, fetch matching users from visible
	domains.

2011-07-18  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/NSString+MAPIStore.m (-asUnicodeInMemCtx:): use an
	alternative method to convert the string to a utf8 array of bytes
	to avoid an undefined conditional bug in GNUstep.

2011-07-18  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/SOGo/SOGoSystemDefaults.m (-enableDomainBasedUID): new
	method that returns the boolean value of the new system defaults
	SOGoEnableDomainBasedUID if at least one domain is defined.

	* SoObjects/SOGo/SOGoUser.m (-initWithLogin:roles:trust:): try to
	extract the domain part of the login name only if the new system
	defaults SOGoEnableDomainBasedUID is set to YES. If the domain is not
	specified but SOGoEnableDomainBasedUID is enabled, add the domain to the
	login name.

	* SoObjects/SOGo/SOGoUserManager.m
	(-contactInfosForUserWithUIDorEmail): try to extract the domain
	part of the login name only if the new system defaults
	SOGoEnableDomainBasedUID is set to YES..

	* SoObjects/SOGo/SOGoSession.m
	(+decodeValue:usingKey:login:domain:password:): idem.

	* SoObjects/SOGo/SOGoUserManager.m
	(-_sourceCheckLogin:andPassword:domain:perr:expire:grace:): the
	domain argument is now a pointer so it will be set according to
	the matching authentication source.

	* UI/MainUI/SOGoUserHomePage.m (-usersSearchAction): only append
	the domain to the user's login if the new system defaults
	SOGoEnableDomainBasedUID is set to YES.

2011-07-15  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreSOGo.m (sogo_backend_init): disable the use
	of the requests cache as objects are retained by the mapistore as
	needed.

	* SoObjects/SOGo/SOGoCache.m (-disableRequestsCache): new method
	that adds the ability to not put requests object in the cache.

	* OpenChange/MAPIStoreDraftsAttachment.m: removed useless class.

	* OpenChange/MAPIStoreMessage.m (-createAttachment): moved method
	from MAPIStoreDraftsMessage
	(-childKeysMatchingQualifier:andSortOrderings:): same as above.

	* OpenChange/*.m: make use of mapistore error code rather than
	MAPI ones.

	* OpenChange/MAPIStoreMailMessage.m (-getPrHtml:inMemCtx:): fixed
	leak.

	* OpenChange/MAPIStoreFolder.m (-createFolder:withRow:andFID:):
	fixed referencing of resulting folder.
	(+initialize): fixed initialization of MAPIStoreFAIMessageK.
	(-getTable:andRowCount:tableType:andHandleId:): properly return
	MAPISTORE_ERR_NOT_FOUND for tables that are not handled by the
	folder.

2011-07-14  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreSOGo.m: finalized the new API.

	* OpenChange/MAPIStoreTable.m: added memory debugging output.

	* OpenChange/NSArray+MAPIStore.m (-asFoldersListInCtx:) removed
	useless method.
	(-asArrayOfUnicodeStringsInCtx:) properly connect the talloc
	hierarchy nodes.

	* OpenChange/MAPIStoreSOGo.m: adapted to latest mapistore_backend
	nomenclature.

2011-07-14  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/MailerUI/UIxMailListActions.m
	(-getUIDsInFolder:withHeaders:): don't add the quota if there's no
	quota for the mail account.

	* UI/WebServerResources/UIxAttendeesEditor.js (onContactKeydown):
	fixed glitch when pressing the tab key from an empty input field.
	(onFreeBusyLoadHandler): removed redundant calls that were causing
	errors when retrieving the attendees freebusy information.

	* UI/WebServerResources/SOGoTimePicker.js (onChange): specified
	the radix when calling parseInt since a string starting with 0
	would be parsed as an octal number.

	* UI/WebServerResources/UIxAppointmentEditor.js (validateAptEditor): idem.

2011-07-14  Ludovic Marcotte <lmarcotte@inverse.ca>

	* SoObjects/SOGo/SOGoGCSFolder.m (davCollectionTag)
	We now correctly cast the sync tag value.

2011-07-13  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/UIxAppointmentEditor.js (handleAllDay)
	(_setDate): fixed errors when event lasts all-day.

	* SoObjects/Mailer/SOGoMailFolder.m
	(-deleteUIDs:useTrashFolder:inContext:): the withTrash argument is
	now a pointer since the method can modify it when the current
	folder is the trash folder.

	* SoObjects/Contacts/SOGoContactSourceFolder.m
	(-_flattenedRecord:): added c_component key so the proper icon
	appears beside entries in the Web interface.

	* UI/WebServerResources/generic.js (_showAlertDialog): added fade
	effect when showing or hiding a dialog box.

2011-07-13  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreContext.m (-init): removed the messages
	cache dictionary, as its purpose has been superseeded by the
	features of the "POC api".

	* OpenChange/MAPIStoreSOGo.m (sogo_op_openmessage)
	(sogo_op_createmessage): now return a "poc api"-compatible
	object.
	(sogo_op_savechangesmessage, sogo_op_submitmessage)
	(sogo_op_modifyrecipients): replaced methods with pocop
	implementations.
	(sogo_op_*attach*): methods to their final form'
	(sogo_op_get_fid_by_name): removed obsolete method.
	(sogo_op_release_record): removed obsolete method.

	* OpenChange/NSObject+MAPIStore.m (MAPIStoreTallocWrapperDestroy):
	the object release now occurs within an NSAutoreleasePool.

	* Tools/sogo-tool.m (main): instantiate SOGoSystemDefaults in
	order to properly inject the entries from SOGoDefaults.plist.

2011-07-12  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/MailerUI/UIxMailFolderActions.m (-batchDeleteAction): we
	only return the quota when not using the trash folder.

	* SoObjects/SOGo/SOGoFolder.m (-compare:): handle the case when
	the display name is not defined.

	* UI/Scheduler/UIxCalListingActions.m
	(-_fetchFields:forComponentOfType:): test the calendar name and
	set it to an empty string if it's not defined.

	* UI/Scheduler/UIxCalendarSelector.m (-calendars): idem.

	* UI/WebServerResources/UIxCalendarProperties.js (onOKClick):
	refuses to save the properties if the calendar name is empty.

	* UI/WebServerResources/SchedulerUI.js (updateCalendarProperties):
	Create a new text node in case the calendar has no name.

2011-07-12  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreFSMessage.m
	(+getAvailableProperties:inMemCtx:): added memCtx parameter.

	* OpenChange/MAPIStoreSOGo.m: (sogo_op_get_table_property)
	(sogo_op_get_available_table_properties)
	(sogo_op_set_restrictions,sogo_op_set_sort_order): removed
	obsolete methods.

	* OpenChange/MAPIStoreCalendarMessageTable.m,
	OpenChange/MAPIStoreContactsMessageTable.m,
	OpenChange/MAPIStoreFAIMessageTable.m,
	OpenChange/MAPIStoreFSMessageTable.m,
	OpenChange/MAPIStoreMailMessageTable.m,
	OpenChange/MAPIStoreTasksMessageTable.m: overriden
	"+childObjectClass" to enable "getAvailableProperties:inMemCtx:"
	to work properly.

	* OpenChange/MAPIStoreTable.m
	(-getRow:withRowID:andQueryType:inMemCtx:): slight change of
	prototype in order to leave the structure initialization to the
	backend.

2011-07-11  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/Scheduler/UIxAppointmentEditor.m
	(-takeValuesFromRequest:inContext:): when switching from an
	all-day event to a non-all-day event, we must add the vTimeZone
	definition. The opposite is also fixed.

	* SoObjects/Appointments/SOGoComponentOccurence.m
	(-prepareDelete): when deleting an occurrence of a floating
	all-day event, we must adjust the exception date to the user's timezone.

	* SoObjects/Appointments/SOGoAppointmentFolder.m
	(-_flattenCycleRecord:forRange:intoArray:): when computing
	occurrences of a floating all-day event, we must also ajdust the
	exception dates to the user's timezone.

2011-07-11  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/*: made backend ops consistent with the talloc API,
	where resources are allocated in a tree of "talloc contexts".

	* OpenChange/NSObject+MAPIStore.m (-tallocWrapper:): new method
	enabling the wrapping of obj-c objects into talloc structures, in
	order to ease memory management.

2011-07-08  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/MailerUI/UIxMailListActions.m (-getUIDsAndHeadersInFolder)
	(-getSortedUIDsAction): both methods now return the inbox quota
	along with the other data.

	* UI/MailerUI/UIxMailFolderActions.m (-batchDeleteAction): return
	the inbox quota when the messages were successfully deleted.

	* SoObjects/Mailer/SOGoMailFolder.m
	(-deleteUIDs:useTrashFolder:inContext:): when not using the trash folder
	or when deleting a message within the trash folder, we now expunge the
	folder immediately.

	* UI/WebServerResources/SOGoMailDataSource.js (init): quotas
	information can now be passed as argument. It will be passed back
	to the method "updateQuotas" from MailerUI.js.

2011-07-08  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreContext.m (-openDir:): implemented.
	(-closeDir): added useful comments.
	(-_tableForFID:andTableType:, -openMessage:withMID:inFID:)
	(-createMessageWithMID:inFID:isAssociated:):
	(-getProperties:ofTableType:inRow:withMID:):
	(-setPropertiesWithFMID:ofTableType:inRow:):
	(-deleteMessageWithMID:inFID:withFlags:): make use of the new
	folder cache instead of using lookupFolderWithFID:, especially
	since the last ones now instantiates, caches and keep a usage
	count of the folders.

	* OpenChange/MAPIStoreMailFolder.m (-lastMessageModificationTime):
	implemented method by making use of the new -[SOGoMailFolder
	mostRecentMessageDate] message, which is currently a more or less
	precise way to obtain the mailbox's last modification date.
	(-lastModificationTime): removed method.

	* OpenChange/MAPIStoreObject.m (-setMAPIRetainCount:)
	(-mapiRetainCount:): moved methods from MAPIStoreMessage.

	* OpenChange/MAPIStoreTable.m
	(-evaluateContentRestriction:intoQualifier:): temporarily
	commented out code initializing "operator" as this local var is
	never used.

	* OpenChange/MAPIStoreFolder.m (-initWithSOstringByAddingPercentEscapesUsingEncodinGoObject:inContainer:):
	make use of -[NSString stringByAddingPercentEscapesUsingEncoding:]
	to properly escape folder names with non-ascii characters.

	* OpenChange/MAPIStoreFSFolder.m (-createFolder:withFID:): same as
	above.

	* OpenChange/MAPIStoreContext.m
	(+contextFromURI:withConnectionInfo:andFID:inMemCtx:): same as
	above.

	* OpenChange/SOGoMAPIFSFolder.m (-initWithName:inContainer:):
	added method to properly initialize the "directory" ivar when
	initialized as a subfolder.

	* OpenChange/MAPIStoreMailContext.m: MAPIStoreDeletedItemsContext
	is now temporarily a fs-based context.

	* SoObjects/Mailer/SOGoMailFolder.m
	(_fetchMessageProperties:matchingQualifier:andSortOrderings::):
	properly implement this method, as properties should be an array
	instead of a dictionary.
	(-mostRecentMessageDate): new method that returns the date of the
	last available message.

2011-07-07  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/UIxListEditor.js (endEditable): when a
	string doesn't match an existing card, keep the entry but
	highlight it in red.
	(serializeReferences): when an entry is not associated to a card,
	extract the email and fullname from the string to create a new card.

	* UI/Contacts/UIxListEditor.m (-setReferencesValue:): if a card
	reference doesn't match a known vCard UID, create a new vCard
	like Thunderbird does.

	* UI/MainUI/SOGoUserHomePage.m (-_usersForResults:inDomain:):
	fixed bug when the domain was empty.
	(-usersSearchAction): idem.

2011-07-06  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* SoObjects/Mailer/NSData+Mail.m (bodyDataFromEncoding:)
	Consider "binary" just like 7 or 8bit.

2011-07-06  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/SchedulerUI.js (onShowCompletedTasks)
	(updateCalendarStatus): removed exception for Safari version prior
	to 3.

2011-07-05  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* UI/MailPartViewers/UIxMailPartICalActions.m
	(-_setupChosenEventAndEventObject:) we now correctly
	update the right event in the database in order to
	update major properties coming from external invitations
	during updates.
	* SoObjects/Appointments/SOGoAppointmentObject.m (-PUTAction:)
	We check if uid is not nil prior comparing it to the
	owner. This fixes bug #1323
	* Added patches included in bug #1348 - which now allows
	group-based ACLs for IMAP.
	* SoObjects/SOGo/SOGoSieveManager.m: Added patch from
	bug #1344 - which fixes Sieve script generation errors
	for reject filters.
	* SOPE/GDLContentStore/GCSFolderManager.m (
	-_reallyCreateFolderWithName:andFolderType:...): Fix
	path handling for recent GNUstep base versions. This
	fixes bug #1327.
	* SoObjects/SOGo/LDAPSource.m (-checkLogin:password:...)
	We now make sure to use the original source's bindDN/password
	when looking up the user's DN for indirect binds. This should
	fix bug #1342.

2011-07-02  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* SoObjects/Appointments/SOGoAppointmentObject.m (-PUTAction:)
	We now update the request's content in case we got participants
	with status change (for resources, for example)

2011-06-30  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreSOGo.m (sogo_op_get_folders_list): method
	removed from struct mapistore_backend.

	* OpenChange/MAPIStoreContext.m: the ldb connection handle to
	openchange.ldb is now passed via struct mapistore_connection_info.

2011-06-29  Ludovic Marcotte  <lmarcotte@inverse.ca>

        * Added get/set/unset capabilities to sogo-tool to set
	user's defaults/settings. Refactored some code to be
	more cleanly structured.

2011-06-24  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/SOGo/SOGoSystemDefaults.m (-loginDomains): new method
	that returns the content of the defaults key SOGoLoginDomains, which
	is a list of domains that should be selectable from the Web login page.
	(-visibleDomainsForDomain:): new method that returns a list of
	domains visible from the specified domain and defined by the
	defaults key SOGoDomainsVisibility, which is a list of lists of domains.

	* SoObjects/SOGo/SQLSource.m
	(-_lookupContactEntry:considerEmail:): when an IMAP login field is
	defined, only consider the value from the table if it's not null.

	* SoObjects/SOGo/SOGoSession.m
	(+decodeValue:usingKey:login:domain:password:): now accepts the
	form login@domain. The domain must be part of the SOGoLoginDomains.

	* SoObjects/SOGo/SOGoUserManager.m
	(-getImapLoginForUID:inDomain:): the method now accepts the
	user's domain.
	(_sourceCheckLogin:andPassword:domain:perr:expire:grace:): idem.
	(checkLogin:password:domain:perr:expire:grace:): idem.
	(_fillContactInfosForUser:withUIDorEmail:inDomain:): idem.
	(-contactInfosForUserWithUIDorEmail:inDomain:): idem.
	(-contactInfosForUserWithUIDorEmail:): now accepts the form login@domain.

	* SoObjects/SOGo/SOGoWebAuthenticator.m (-checkCredentials:):
	perform the authentication in a domain when specified in the
	web session.

	* SoObjects/Contacts/SOGoContactFolders.m (-appendSystemSources):
	when using domains, append addressbooks from visible domains.

	* SoObjects/SOGo/SOGoUser.m (-initWithLogin:roles:trust:): now
	accepts the form login@domain.
	(-loginInDomain): new method. When bound to a domain, it returns
	the username part of the login.

	* UI/MainUI/SOGoUserHomePage.m (-_usersForResults:inDomain:): was
	_usersResponseForResults:. Now returns only an array
	containing the matching users.
	(-usersSearchAction): added the results from the visible domains,
	if the defaults key SOGoDomainsVisibility is defined.

	* UI/MainUI/SOGoRootPage.m (-connectAction): a domain from the
	defaults key SOGoLoginDomains can now be received.

2011-06-23  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreTypes.h: removed PRIx64 definitions, that
	can be found in the libc inttypes.h.

2011-06-20  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/UIxAppointmentEditor.js (_getDate):
	retrieve the time using a regexp to insure a valid entry.

	* UI/WebServerResources/MailerUI.js (onMenuEmptyTrashCallback):
	when emptying the trash folder, reset the unseen count and reset
	the reference to the last selected message.

2011-06-17  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/SOGoTimePicker.js (onChange): the
	semi-colon is no longer necessary. Also fixed the update the
	widget when manually entering a time.

	* UI/WebServerResources/MailerUI.js (configureDraggables): added
	delay of 100ms before dragging starts.

2011-06-17  Ludovic Marcotte  <lmarcotte@inverse.ca>

        * SOPE/NGCards/iCalEvent.m (setAllDayWithStartDate:duration:):
	We now correctly remove the duration value in case we're
	"converting" the event to an all-day one. This fixes
	bug #1312.

2011-06-16  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* UI/Contacts/UIxContactFolderActions.m (importLdifData:):
	Fixed folded lines import and base64 encoded values. Patch
	from bug #1251

2011-06-16  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreSOGo.m (mapistore_init_backend): accept
	double registration seamlessly.

	* SoObjects/Mailer/SOGoMailObject.m (-displayName): make use of
	the decoded subject.

	* Tools/SOGoToolRenameUser.m: new sogo-tool module that updates
	the references after a change of user id for a specific user.

	* SoObjects/SOGo/NSString+Utilities.m (-asSafeSQLString): new
	method that properly escape strings passed as values in SQL
	queries.

2011-06-15  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreSpoolerContext.[hm]: new backend context.

2011-06-14  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/UIxAttendeesEditor.js: adjustments for the
	new SOGoTimePicker.

2011-06-13  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/SOGoTimePicker.js: new interface to add a
	time picker widget to an input field.

	* UI/Scheduler/UIxTimeDateControl.m: replaced hours and minutes
	popup menu by one input field.

	* UI/WebServerResources/UIxAppointmentEditor.js: idem.

	* UI/WebServerResources/UIxTaskEditor.js: idem.

	* UI/Scheduler/UIxAppointmentEditor.m (-newStartDate): round
	minutes to the nearest 15-minute.

	* UI/Scheduler/UIxTaskEditor.m (-newStartDate): idem.

2011-06-08  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/MailerUI.js (initMailer): added the Thread
	column if missing from the columnsOrder user's defaults.

2011-06-06  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/*:
	- (context) cached last requested folder and table
	- (context) open folders are now cached in an nsdictionary
	- getPrLastModificationTime and getPrCreationTime are now
	centralized in MAPIStoreObject and rely on mandator lastModificationTime
	and creationTime methods on individual subclasses.
	- openMessage now takes a "struct mapistore_message **" argument.
	- MAPIStoreFSFolder can now create subfolders
	- converted MAPIStoreFolder to the new property API, by
	implementing one method per property.

	* OpenChange/MAPIStoreMailMessage.m: (-getPrExpiryTime:) removed
	method as we don't want the message to appear as "expired".
	(-getPrOriginalSensitivity:): uppercased the "o" in "getPrOriginal..."

	* OpenChange/MAPIStoreSOGo.m
	(sogo_pocop_get_available_table_properties): now takes a
	SPropTagArray ** argument.
	(sogo_pocop_get_available_properties): same as above.
	(sogo_op_get_available_table_properties): new, non-poc operation,
	to retrieve the list of available properties from a table.

	* OpenChange/MAPIStoreTable.m (-notifyChangesForChild:): same as below.

	* OpenChange/MAPIStoreContext.m
	(_saveOrSubmitChangesInMessageWithMID:andFlags:save:):
	mapistore_push_notification now takes a struct mapistore_context *
	as parameter.
	(-deleteMessageWithMID:inFID:withFlags:): same as above.

2011-06-06  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/MailerUI.js (configureLinksInMessage):
	when a link has the attribute moz-do-not-send set to true, remove
	it and force a new mailto href.

2011-06-03  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/SOGoMAPIFSFolder.m (-creationTime)
	(-lastModificationTime): new self-explicit accessors.
	(-initWithURL:andTableType:): accept the "MAPISTORE_FOLDER_TABLE",
	for storing folder properties.

	* OpenChange/SOGoMAPIFSMessage.m (-completeFilename): new method
	that returns the full filename for the property list file.
	(-appendProperties:) simplified method.
	(-save) removed obsolete hack.
	(-creationTime, -lastModificationTime): new self-explicit
	accessors.

	* OpenChange/MAPIStoreSOGo.m (sogo_op_opendir): op_opendir no
	longer takes the parent fid as parameter.

	* OpenChange/MAPIStoreCalendarMessageTable.m
	(-sortIdentifierForProperty:): c_isallday and c_creationdate as
	mappings for PidLidAppointmentSubType and PR_CREATION_TIME.

	* OpenChange/MAPIStoreContext.m: MAPIStoreMapping instances are
	now per-user instances rather than class singletons.

	* OpenChange/MAPIStoreMapping.m: now makes use of the records
	already present in indexing.tdb for building the initial mapping
	dictionary.

	* OpenChange/MAPIStoreSpoolerContext.[hm]: new context module,
	which subclasses MAPIStoreSpoolerContext from
	MAPIStoreFSBaseContext rather than MAPIStoreOutboxContext.

2011-06-03  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/generic.js (initMenu): the wrong callbacks
	were associated to menu entries when the menu was splitted in
	multiple ULs.
	(popupSubmenu): fixed the position so it stays beside the menu
	entry when the main menu is splitted in multiple ULs. The submenu
	will no longer be displayed outside the window viewport.

2011-06-02  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/generic.js (hideMenu): now fires a custom
	event (contextmenu:hide) to properly define a callback function
	when a contextual menu is hidden.

	* UI/WebServerResources/MailerUI.js (onFolderMenuClick):
	registered the function onFolderMenuHide on the new event
	"contextmenu:hide". This function was never called since it was
	relying on an event never triggered ("hideMenu").

	* UI/WebServerResources/ContactsUI.js (onContactContextMenu): idem.

	* UI/WebServerResources/UIxPreferences.js (_setupEvents): reload
	main page when enabling or disabling mail threads.

2011-06-01  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/SOGo/SOGoUserDefaults.m (-setMailSortByThreads)
	(-mailSortByThreads): new accessors for the "SOGoMailSortByThreads"
	user defaults.

	* UI/PreferencesUI/UIxPreferences.m (-setSortByThreads)
	(sortByThreads): idem.

	* SoObjects/Mailer/SOGoMailFolder.m
	(-fetchUIDsMatchingQualifier:sortOrdering:threaded:): new method
	to fetch a threaded-view of the folder.

	* SoObjects/SOGo/NSArray+Utilities.m (-flattenedArray): added
	recurrence to flatten interleaved arrays.

	* SoObjects/Mailer/SOGoMailAccount.m (-updateFilters): write
	multiple 'redirect' directives when forwarding to multiple email
	addresses.

	* UI/MailerUI/UIxMailListActions.m (-threadedUIDs): new method
	that returns a flatten representation of messages threads.

	* UI/MailerUI/UIxMailMainFrame.m (-columnsMetaData): added CSS
	classnames for the thread column.
	(-columnsDisplayOrder): add or remove the thread column depending
	on the user's defaults.

	* UI/MailerUI/UIxMailListActions.m (-getUIDsAndHeadersInFolder)
	(-getSortedUIDsAction): added support for threads.

	* UI/WebServerResources/ContactsUI.js (onContactContextMenu):
	select row at pointer position when not already selected.

	* UI/WebServerResources/MailerUI.js: added support for the
	threaded view.
	(onMessageContextMenu): select row at pointer position when not
	already selected.

	* UI/WebServerResources/SOGoMailDataSource.js: added support for
	the threaded view.

2011-05-31  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/SchedulerUI.js (initCalendarSelector): use
	events delegation in the calendars list.

	* UI/WebServerResources/HTMLElement.js (selectElement): if element
	has no ID, keep track of it anyway. This fixes an issue when
	deleting attachments in the mail composition window.

	* UI/WebServerResources/UIxMailEditor.js (initMailEditor): use
	events delegation in the attachments list.

	* UI/Scheduler/NSArray+Scheduler.m (-compareTasksAscending): sort
	the tasks by their name if they are from the same calendar.

2011-05-31  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreTypes.m (NSObjectFromMAPISPropValue)
	(NSObjectFromSPropValue): handle PT_I8 properties.

	* OpenChange/NSObject+MAPIStore.m
	(-getMAPIValue:forTag:inMemCtx:): added case to handle PT_I8
	properties via the new method below.

	* OpenChange/NSValue+MAPIStore.m (-asI8InMemCtx:): new method that
	extracts an uint64_t from an NSNumber.

	* OpenChange/MAPIStoreFallbackContext.[hm]: new class module for
	the "fallback" context, used by the OpenChange core to create
	contexts that are not specifically handled.

	* OpenChange/MAPIStoreSOGo.m (sogo_create_context): a new struct
	mapistore_connection_info * is now passed as parameter, which
	contains useful data about the current connection.

	* OpenChange/MAPIStoreTable.m: (-deactivate): removed obsolete
	method, which was part of a hack anyway.

	* OpenChange/MAPIStoreObject.m: (-addActiveTable:)
	(-removeActiveTable:) removed obsolete methods.

	* OpenChange/MAPIStoreFolder.m: (-init) removed obsolete ivars
	"activeMessageTables", "activeFAIMessageTables" and "activeFolderTables".
	(-activeMessageTables, -activeFAIMessageTables)
	(-activeFolderTables, _cleanupTableCaches): make use of the new
	MAPIStoreActiveTables class.

	* OpenChange/MAPIStoreActiveTables.[hm]: new class module that
	provides a facility for keeping track of all the instantiated
	tables.

2011-05-30  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/code-MAPIStorePropertySelectors.m
	(MAPIStorePropertyGettersForClass): insert the newly created table
	in the hash in order to avoid a leak... and to enable it to be
	found during the next search.

	* SoObjects/SOGo/SOGoContentObject.m (-version, -createDate)
	(-lastModified): new accessors that return the value of the
	corresponding ivar.

	* SoObjects/SOGo/SOGoGCSFolder.m (-davCollectionTag): base the
	return value on the new -[GCSFolder lastModificationDate] method.
	(_isValidSyncToken): same as above.

	* OpenChange/NSDate+MAPIStore.[hm]: renamed from
	NSCalendarDate+MAPIStore.[hm]. Provides the same methods as
	before but on NSDate rather than NSCalendarDate.

	* OpenChange/gen-property-selectors.py (ParseExchangeHDefinition):
	Fixed exclusion of records ending with "Error" and "Unicode".
	Also, we now exclude PidTag properties with a value > 0x80000000
	since they may overlap with named properties.
	(__main__): replace multi-string with multi-unicode identifiers
	too.
	(__main__): we output getter indexes as 16 bit hex values, for
	consistency.

2011-05-30  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/ContactsUI.js (contactsListCallback):
	restored activation of drag'n'drop.
	(configureAddressBooks, onFolderSelectionChange)
	(appendAddressBook): delegated rows events to the table.
	(setEventsOnAddressBook): this function removed following the new event
	delegation model.

2011-05-27  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/PreferencesUI/UIxPreferences.m (-forwardAddress)
	(-setForwardAddress): allow to define multiple forwarding addresses.

	* UI/WebServerResources/UIxPreferences.js (savePreferences): test
	each specified forwarding address.

2011-05-17  Ludovic Marcotte  <lmarcotte@inverse.ca>

        * We now remove the /inverse.ca/20101018_1/ identifier
	from all NGCards' timezone files.

2011-05-16  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* UI/MailPartViewers/UIxMailPartHTMLViewer.m: Added a
	workaround for a libxml's issue where the charset
	specified in meta tags have precedence over the one
	we "force" when creating the parser. This "bug" has
	just been fixed in libxml but it'll take years before
	all distributions get that fix. For now, we strip
	that tag, unconditionnaly.

2011-05-10  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* NSDictionary+Utilities.m (userRecordAsLDIFEntry):
	Fix to avoid a crash when backing up resources' LDIF entries

2011-05-06  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/UIxPreferences.js
	(displayAccountSignature): fixed an issue with an HTML signature
	that start with a paragraph tag.

2011-05-05  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* UI/MailerUI/UIxMailAccountActions.m - fixed an issue
	with namespace handling in Dovecot. We do not try
	to swap the mailbox name, which can correspond to an
	username if we are dealing with the top-level mailbox.

2011-05-03  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/UIxMailEditor.js (createAttachment): show
	the attachment name as the list entry's title.

	* UI/WebServerResources/generic.js (onRowClick): in some cases
	under ID,	the event is trigger on the dragging identifier
	and must be ignored.

	* UI/WebServerResources/MailerUI.js (deleteSelectedMessages): we no
	longer wait for the callback before invalidating the caches.
	(mailListToggleMessagesRead): idem.

2011-04-28  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* SoObjects/SOGo/SQLSource.{h,m}: Added resources support,
	just like for LDAP-based sources.
	* SoObjects/SOGo/SOGoParentFolder.m (_createPersonalFolder):
	We now also autocreate database tables if the "user"
	is a resource.

2011-04-25  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/SchedulerUI.js (onFolderUnsubscribeCB):
	select the personal calendar to avoid trying creating an event or
	a task in the calendar to which the user has just unsubscribed.

2011-04-25  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* Added the concept of "resources" in SOGo in order
	to avoid double-bookings (if not more) and also, handle
	auto-accepts. This works for the web interface and
	over DAV - generating 403 errors in case of a conflict.

2011-04-21  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* Added the possibility of translating IMAP namespaces
	and we now extract the full name the mailbox owner under
	the "Other Users" namespace.

2011-04-21  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/SchedulerUI.js (deleteEvent): we now show
	in the confirmation dialog box which events will be deleted.

	* UI/WebServerResources/generic.js (createDialog): the legend
	argument can now be a string or an element.
	(isWebKit): was isSafari; now consider all WebKit-based browsers together.

	* UI/WebServerResources/UIxMailToSelection.js: various
	improvements to behave like in Thunderbird.

	* UI/WebServerResources/SOGoAutoCompletion.js: idem.

	* UI/WebServerResources/UIxMailEditor.js (initAddresses): was
	initTabIndex. We were not handling the tab indexes properly which
	was causing incorrect behavior in IE.

2011-04-19  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreMailAttachment.m (-): binary properties are
	represented by a struct Binary_r.

	* OpenChange/NSObject+MAPIStore.m
	(-getMAPIValue:forTag:inMemCtx:): binary properties are
	represented by a struct Binary_r.

	* OpenChange/MAPIStoreTypes.m (NSObjectFromMAPISPropValue)
	(NSObjectFromSPropValue): we now support PT_SVREID and handle it
	exactly as PT_BINARY.

	* OpenChange/MAPIStoreMessage.m (-attachmentTable): as all the
	subclasses were using the same MAPIStoreAttachmentTable
	implementation, this method now performs the same operation and
	thereby no longer requires subclasssing.

	* OpenChange/MAPIStoreObject.m (-getProperty:withTag:): compute
	the method selector and pass it as argument to the IMP of the
	property getter, as would be with any regular method invocation.

	* OpenChange/MAPIStoreMailMessage.m (-getPrBody:): no longer check
	the size of the returned content, as streams are now handled
	internally by OpenChange.
	(-getPrHtml): same as above.

	* OpenChange/MAPIStoreTypes.m (NSObjectFromStreamData): removed
	helper function as it's no longer used.

	* OpenChange/MAPIStoreSOGo.m (sogo_op_set_property_from_fd)
	(sogo_op_get_property_into_fd): those backend methods are no
	longer used, as OpenChange handles the property streams internally
	now.

	* OpenChange/gen-property-selectors.py: added code to generate
	MAPIStoreSupportedProperties as the array of properties that are
	handled by OpenChange and MAPIStoreSupportedPropertiesCount as the
	count of those properties.

	* OpenChange/MAPIStoreObject.m (+getAvailableProperties): ObjC
	corollary of the "sogo_pocop_get_available_properties" backend
	method.
	(-getAvailableProperties): proxy to the class method of the same
	name.

	* OpenChange/MAPIStoreTable.m (+childObjectClass): new mandatory
	method that returns the Class of the objects represented in the
	rows of the table.
	(-getAvailableProperties:): ObjC corollary of the
	"sogo_pocop_get_available_table_properties" backend method.

	* OpenChange/MAPIStoreSOGo.m
	(sogo_pocop_get_available_table_properties): new backend getter
	that returns the list of properties that can be queried on the
	table rows.
	(sogo_pocop_get_available_properties): new backend getter
	that returns the list of properties that can be queried on the
	discrete object passed as parameter.

	* OpenChange/code-MAPIStorePropertySelectors.m
	(MAPIStorePropertyGettersForClass): use the
	"MAPIStoreProeprtyGetter" type rather than IMP as result type.

	* OpenChange/MAPIStoreFolderTable.m (-restrictedChildKeys): no
	longer a mandatory method, returns [self childKeys] when not
	overriden and issue an error message.

	* OpenChange/MAPIStoreFolder.m (-createMessage): no longer a
	mandatory method. Returns nil when not overriden.

2011-04-19  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/Appointments/SOGoAppointmentFolder.m
	(-_flattenCycleRecord:forRange:intoArray:): fixed the
	verification of the event's timezone.

2011-04-15  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/Appointments/iCalEvent+SOGo.m (-firstOccurenceRange):
	we now compute the end date by looking at the occurrence
	interval. This way, we support events with an end date or a duration.

	* SoObjects/Appointments/SOGoAppointmentFolder.m
	(-_flattenCycleRecord:forRange:intoArray:): also compute the end
	date by looking at the occurrence interval.
	(-importCalendar:): added a duration to events with no end date nor duration.

	* SoObjects/Appointments/SOGoAppointmentObject.m
	(-_adjustEventsInRequest:): new method to verify the vCalendar for
	any inconsistency or missing attributes. Currently, it only adds a
	duration if no end date nor duration is found.

	* UI/WebServerResources/ckeditor/config.js: Changed the default
	enter mode to use BR instead of P. This matches the behavior of Thunderbird.

2011-04-14  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/UIxContactEditor.js
	(validateContactEditor): now uses the regexp defined in generic.js
	 (emailRE) to validate the email addresses. This fixes an issue
	with valid addresses starting with an underscore (bug #1246).

	* UI/MailerUI/UIxMailAccountActions.m (-composeAction): properly decode
	submitted recipients and subjects (URL-encoded).

	* SoObjects/SOGo/SOGoUserManager.m (-getImapLoginForUID:): we now
	consider the source parameter IMAPLoginFieldName. We continue to support
	SOGoForceIMAPLoginWithEmail at the domain/system level.

	* SoObjects/SOGo/LDAPSource.m: we can now define a new parameter
	named IMAPLoginFieldName to specify which field to use for IMAP
	authentication. By default, we use the value of the UIDFieldName.

	* SoObjects/SOGo/SQLSource.m
	(-checkLogin:password:perr:expire:grace:): if the defaults parameter
	authenticationFilter is defined, we add it to the SQL where clause.
	(_lookupContactEntry:considerEmail:): we add a new key
	 (canAuthenticate) to the returned dictionary that specifies if the
	user can authenticate or not. We also add c_imaplogin when the
	user must authenticate with a different username to the IMAP server.

	* SoObjects/SOGo/SOGoUser.m (-canAuthenticate): new method that
	returns true if the user can authenticate, based on the
	authentication filter associated to the source.

	* SoObjects/SOGo/SOGoGCSFolder.m (-ocsFolder): don't automatically
	create the folder if the user can't authenticate.

	* UI/Contacts/UIxContactsListActions.m: was
	UIxContactsListView.m. The new method contactsListAction now
	returns a JSON representation of the addressbook.

	* UI/Contacts/UIxContactFoldersView.m (-personalContactInfos): new
	method used to populate the wox template with the personal
	addressbook. The addressbook module is now pre-loaded with it,
	eliminating an Ajax query.

	* UI/WebServerResources/ContactsUI.js (initContacts): delegate
	all events to the table instead of each row.
	(contactsListCallback): we now receive a JSON representation of
	the contacts and reuse the existing table rows instead of
	overwriting the table.

2011-04-13  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreObject.m: make use of the IMP cache methods
	available in MAPIStorePropertySelectors to query object
	properties.
	* OpenChange/*{Message,Folder}.m: replaced the implementations of
	-getProperty:withTag: with equivalent property getter methods.

	* OpenChange/MAPIStoreContext.m (-url): new method that returns
	the context url.

	* OpenChange/gen-property-selectors.py: new generator script that
	outputs MAPIStorePropertySelectors.[hm], which is a helper
	module that provides methods for handling of cached
	property method IMPs.

2011-04-12  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/Mailer/SOGoDraftObject.m
	(-bodyPartForAttachmentWithName:): don't choose "quoted-printable"
	if the mimetype is anything else than "text/plain" or "text/html",
	to avoid issues with filenames attached with a wrong mime type.

2011-04-12  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/Appointments/SOGoAppointmentFolder.m
	(-importCalendar:): we now associate the proper vtimezone to each
	event found in the calendar.

2011-04-11  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/UIxMailToSelection.js
	(addressFieldLostFocus): split content separated by commas
	or semi-colons.

2011-04-08  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* Tests/Unit/TestNSString+URLEscaping.m: new test module.
	(-test_stringByEscapingURL): new test method for -[NSString
	stringByEscapingURL].

	* Tests/Unit/sogo-tests.m (main): added volatile user defaults for
	utf8 url encoding.

2011-04-07  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/MailerUI.js (onMenuRenameFolderConfirm):
	encode the folder name in the URL.

2011-04-06  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreMailMessageTable.m
	(-evaluateExistRestriction:intoQualifier:): declare that
	PR_CLIENT_SUBMIT_TIME always exists on messages, which prevents
	Outlook from looping on a search request that always returns the
	same unexpected result...

2011-04-05  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreCalendarMessage.m (-getProperty:withTag):
	restored/implemented PR_START_DATE, PidLidAppointmentStartWhole,
	PidLidCommonStart and their "end" equivalent.

	* OpenChange/MAPIStoreMailFolder.m (-createFolder:): implemented
	method by adapting old code that was still commented out.
	(-folderKeys): implemented method.
	(-lookupChild:): overriden method to return a folder object when
	the child key is contained in the folder keys.

	* OpenChange/MAPIStoreContext.m (_tableForFID:andTableType:): make
	use of lookupFolder: to retrieve the right folder based on the FID.
	(-setPropertiesWithFMID:ofTableType:inRow:): silently discard by
	log the settings of properties on folders.

2011-04-04  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* UI/Scheduler/UIxCalListingActions.m
	(-_fillBlocks:withEvent:withNumber:): fixed type confusion between
	char * and NSString * that could cause a crash under certain
	circumstances.

2011-04-01  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/Appointments/SOGoAppointmentObject.m (-PUTAction:):
	when adding a new occurrence, instantiate an occurrence from the
	previous calendar in order to perform a proper changes comparison.

2011-04-01  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* Tests/Unit/TestSBJsonParser.m (-test_parseJSONString): input and
	expected result are embedded in an array since SBJsonParser needs
	a "container" class.
	(-test_parseJSONNumber): same as above.

	* Tests/Integration/all.py: (from Jean Raby) make use of the
	"SOGoLanguage" defaults key rather than the old "Language" one.

	* Tests/Integration/sogoLogin.py: (from Jean Raby) new
	authentication module, required by the new session-based code.

	* Tests/Integration/preferences.py: (from Jean Raby) derive
	authentication cookie from the new sogoLogin module.

	* UI/WebServerResources/SchedulerUI.js (initCalendars): initialize
	"showCompletedTaskls" to 0 when the ShowCompletedTasks settings
	variable is not available.

	* SoObjects/Appointments/SOGoCalendarComponent.m
	(-contentAsString): strip alarms from component if the alarms are
	disabled on the containing calendar.

	* SoObjects/SOGo/SOGoObject.m (-davComplianceClassesInContext:):
	added "calendar-auto-schedule", "calendar-proxy" and "calenderserver-principal-property

	* Main/SOGo+DAV.m (-davComplianceClassesInContext:): overwritten
	with same code as in SOGoObject.
	(-davPrincipalCollectionSet): added dav property.

2011-03-31  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreCalendarMessage.m
	(_setupRecurrenceInCalendar:withMasterEvent:fromData:): moved the
	code pertaining to the handling of struct RecurrencePattern into
	the new module below, in the -[iCalCalendar setupRecurrenceWithMasterEntity:
        fromRecurrencePattern:) category method.
	(_fillAppointmentRecurrencePattern): moved the
	code pertaining to the handling of struct RecurrencePattern into
	the new module below, in the -[iCalRecurrenceRule
	fillRecurrencePattern:withStartDate:andEndDate:] category method.
	(-createAttachment): instantiate a MAPIStoreCalendarAttachment
	object.

	* OpenChange/MAPIStoreSOGo.m: added new
	"sogo_pocop_open_embedded_message" backend method.

	* OpenChange/MAPIStoreCalendarAttachment.[hm]: new class module
	for handling event attachments or "exceptions".

	* OpenChange/MAPIStoreMessage.m (-getProperty:withTag:):
	handles PR_HASATTACH, previously found in MAPIStoreMailMessage.

	* OpenChange/MAPIStoreAttachment.m (-nameInContainer): overriden
	method to return "aid" in the form of a NSString.
	(-mimeAttachTag): new helper method derived from old code in
	getProperty:withTag: for subclasses.
	(-getProperty:withTag:): handles PR_MID, PR_ATTACH_NUM and
	PR_RENDERING_POSITION, previously found in
	MAPIStoreMailAttachment.
	(-openEmbeddedMessage:withMID:withMAPIStoreMsg:andFlags:): new
	backend method.
	(-openEmbeddedMessage, -createEmbeddedMessage): new overridable
	methods.

	* OpenChange/MAPIStoreEmbeddedMessage.[hm]: new class module for
	attachment embedded messages.

	* OpenChange/MAPIStoreObject.m (-url): make use of
	-[MAPIStoreObject nameInContainer] rather than the equivalent on
	SOGoObject to make that code reusable for objects that are not
	based on SOGoObject instances.

	* OpenChange/MAPIStoreRecurrenceUtils.m: new module implementing
	methods useful for handling recurrences in events and tasks.

2011-03-31  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/MailerUI.js (messageListCallback): put an
	non-breaking space in empty cells, not only for IE.

	* UI/Contacts/UIxContactView.m (_cardStringWithLabel:value:):
	remove useless carriage returns to avoid JavaScript errors in IE7.

2011-03-30  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* UI/MailerUI/UIxMailFolderActions.m (-copyMessagesAction)
	(-expungeAction, -emptyTrashAction): use "-mailAccountFolder" in
	order to retrieve the account folder as the clientObject may
	actually be a nested folder...

	* UI/WebServerResources/UIxTaskEditor.js (initializeStatusLine):
	bind onStatusListChange as callback to "change" rather than
	"mouseup" as it otherwise fails to be invoked on Chrome.

	* SoObjects/SOGo/SOGoBuild.m: export new SOGoVersion NSString.

	* Main/SOGo.m (+initialize): moved most initialization code from
	-init and -run here since this method is invoked before forking
	and data memory is in "copy-on-write" mode, slightly reducing
	memory usage of combined SOGo processes.
	(+applicationWillStart): new method replacing +initialize.

2011-03-30  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/Appointments/SOGoAppointmentFolder.m
	(-fetchFreeBusyInfosFrom:to:): we must fetch the c_content in
	order to flatten cyclic events.

	* SoObjects/SOGo/SOGoSystemDefaults.m (-pageTitle): new method to
	retrieve the Web page title from the new system defaults "SOGoPageTitle".

	* UI/Common/UIxPageFrame.m (-title): consider the new system
	default attribute "SOGoPageTitle".

2011-03-29  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/Appointments/iCalEvent+SOGo.m
	(-updateRecurrenceRulesUntilDate:): shifts the "until dates" of
	the recurrence rules of the event with respect to the previous end
	date of the event.

	* SoObjects/Appointments/SOGoCalendarComponent.m
	(-updateComponent: ): splitted method "saveComponent:" to avoid
	saving the component multiple times during the same session.

	* SoObjects/Appointments/SOGoAppointmentObject.m (-saveComponent):
	make use of the new "updateComponent" method mentioned above.

	* SoObjects/Appointments/SOGoAppointmentFolder.m
	(-_flattenCycleRecord:forRange:intoArray:): when the event has a
	timezone, the "until dates" of recurrence rules must be adjusted.

	* UI/Scheduler/UIxAppointmentActions.m (-adjustAction): when
	modifying an event, also modify the "until dates" of recurrence rules.

	* UI/Scheduler/UIxAppointmentEditor.m (-_adjustRecurrentRules):
	the "until date" of finite recurrence rules must be based on the
	event end date, not the start date.

2011-03-28  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* Tools/SOGoToolRemoveDoubles.m
	(-detectDoublesFromRecords:withQuickField:): added a quick field
	parameter to enable the use of other fields than just c_mail.

2011-03-24  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* UI/Contacts/UIxContactsListView.m (-currentContactClasses): new
	method that returns the classes associated to the current contact.
	For now, only the c_component.

2011-03-24  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/MailerUI/UIxMailListActions.m (-imap4SortOrdering): verify
	that the sort is defined when rollbacking to the user's settings.

	* SoObjects/SOGo/SQLSource.m (_encryptPassword:): new method to
	encrypt a user's password according to the configured algorithm.
	(-changePasswordForLogin:oldPassword:newPassword:perr:):
	now implemented (thanks to Martin Rabl).

2011-03-23  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* SoObjects/Appointments/SOGoAppointmentObject.m (-PUTAction:):
	Fix for bug #1092. We were incorrectly looking up
	the organizer of an exception to a recurrence and
	we were also incorrectly always updating the master
	event with the part-state.

2011-03-23  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/PreferencesUI/UIxPreferences.m (-timeZonesList): we make use
	of the new method [iCalTimeZone knownTimeZoneNames] instead of
	[NSTimeZone knownTimeZoneNames] to avoid listing tons of useless timezones.

	* UI/PreferencesUI/UIxPreferences.m (-userTimeZone): since we now
	offer a limited number of timezones, the user timezone could be
	unrecognized. In this case, try to find a timezone with the same
	GMT offset.

2011-03-22  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreCalendarMessage.m (-init): new method to
	initialize the attachment ivars.
	(-ownerTimeZone): new method with common code.
	(-getProperty:withTag): (PR_ICON_INDEX) return a more precise icon depending on
	the recurring nature of the event as well on its number of
	attendees. (PidLidAppointmentStartWhole,
	PidLidAppointmentEndWhole) removed properties. (PidLidRecurring,
	PidLidIsRecurring), returns YES when recurring.
	(PidLidAppointmentRecur) property handles property, by using
	-_computeAppointmentRecur and other submethods.

	* OpenChange/NSCalendarDate+MAPIStore.m (-asMinutesSince1601):
	corollary to +dateFromMinutesSince1601.

2011-03-21  Francis Lachapelle  <flachapelle@inverse.ca>

	* Tools/SOGoToolBackup.m (-fetchUserIDs:): when choosing to backup
	all users, fetch the users list from the folder info table instead
	of the configured sources. This fixes an issue when trying to
	retrieve the users from LDAP sources that limit the number
	of results.

	* SoObjects/SOGo/LDAPSource.m (:_qualifierForFilter): avoid
	duplicated filters on the CN attribute.

	* UI/WebServerResources/UIxPreferences.js
	(displayAccountSignature): strips the tags and unescape the HTML
	to improve readability.

	* UI/WebServerResources/MailerUI.js (updateWindowTitle): new
	function used to update the window title with respect to the
	currently selected mailbox.

	* UI/WebServerResources/MailerUI.js (openMailbox): exchanged sort
	arrows to match Thunderbird's GUI.

	* UI/MailerUI/UIxMailListActions.m (-imap4SortOrdering): when the
	sort is not specified in the request, retrieve the user's previous sort.

2011-03-20  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreCalendarMessage.m
	(-_setupRecurrenceInCalendar:withMasterEvent:fromData:): new
	method for setting recurrence info from "PidLidAppointmentRecur"
	(no exdate, exrule or modified occurrence for now).

	* OpenChange/NSCalendarDate+MAPIStore.m
	(+dateFromMinutesSince1601): new constructor, helpful for MAPI
	recurrence structures.

	* OpenChange/MAPIStoreCalendarMessageTable.m,
	OpenChange/MAPIStoreTasksMessageTable.m,
	OpenChange/MAPIStoreContactsMessageTable.m,
	OpenChange/MAPIStoreMailMessageTable.m,
	OpenChange/MAPIStoreTasksMessage.m, OpenChange/MAPIStoreMessage.m,
	OpenChange/MAPIStoreMailMessage.m,
	OpenChange/MAPIStoreContactsMessage.m: cast property tags to
	uint32_t in switch statements to avoid fatal warnings about
	uncovered cases.

	* UI/Scheduler/UIxComponentEditor.m
	(-takeValuesFromRequest:inContext:): added some sanity checks to
	avoid crashes when alarm data is not properly entered.

2011-03-18  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/SchedulerUI.js (initCalendars): we must
	set "showCompletedTasks" earlier in order to properly fetch the
	tasks upon the first refresh.

	* UI/Scheduler/UIxAppointmentEditor.m
	(-takeValuesFromRequest:inContext:): we no longer associate a
	vTimeZone to start/end dates of an all-day vEvent.

	* UI/Scheduler/UIxCalListingActions.m
	(-_fetchFields:forComponentOfType:): we don't add components
	outside the covered period. This could happen with all-day events,
	since their dates are always GMT.

	* SoObjects/Appointments/iCalEvent+SOGo.m (-quickRecord): an all-day
	event usually doesn't have a timezone. However, if it does, we must
	convert its dates to GMT. All-day events are "floating", in the
	sense that they are timezone-independant.

2011-03-17  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/MailerUI/UIxMailAccountActions.m (-listMailboxesAction):
	moved code that fetches the inbox quota to [SOGoMailAccount getInboxQuota].

	* SoObjects/Mailer/SOGoMailAccount.m (-getInboxQuota): new method
	created partially from the method [UIxMailAccountActions listMailboxesAction].

	* UI/MailerUI/UIxMailFolderActions.m (-deleteAction)
	(-copyMessagesAction, -expungeAction, -emptyTrashAction): we now
	return a JSON representation of the inbox quota when these actions
	succeeds.
	(-quotasAction): removed this method which was no longer used.

	* UI/WebServerResources/MailerUI.js (updateQuotas): new function
	extracted from updateMailboxTreeInPage. It is called when a folder
	operation returns the inbox quota.

2011-03-15  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/MailerUI/UIxMailListActions.m (-getMailAction): removed this
	method that is no longer used since live-loading.
	(-getSortedUIDsAction): restored the call to
	expungeLastMarkedFolder so that the last visited folder is
	expunged when switching folder.

2011-03-11  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/Contacts/SOGoContactFolders.m
	(-setDavContactsCategories:): we need to handle the case where the
	"category" element has more than one subnode, in particular when
	xml entities are used.

2011-03-11  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/HTMLElement.js (onContextMenu): hide the
	menu on a mousedown, not a click. This fixes a problem on Webkit browsers.

	* UI/WebServerResources/generic.js: cleanup some event observers
	related to contextual menus.

	* UI/WebServerResources/UIxMailEditor.js (initMailEditor): added
	the SpellChecker button in the HTML editor toolbar, and disabled
	the "check while typing" option (scayt).

	* UI/WebServerResources/ContactsUI.js (initContacts): don't define
	the categories contextual menu if the contacts list doesn't
	exist. This fixes a problem when adding categories to a contact
	using IE7.

2011-03-10  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/Appointments/SOGoAppointmentFolder.m (-fixupRecord):
	the time of all-day events must be adjusted for the user's timezone.

	* UI/WebServerResources/UIxContactEditor.js (initEditorForm):
	the input category field doesn't appear if the card is
	read-only. Adjusted the code accordingly.

	* UI/WebServerResources/ContactsUI.js
	(onCategoriesMenuItemCallback): new callback that refreshes the
	displayed card when a category is added or removed.

2011-03-10  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* UI/WebServerResources/ContactsUI.js (onCategoriesMenuItemClick):
	makes use of "encodeURIComponent" rather than "escape" to encode
	URL parameters, because for some reason the former takes the
	encoding into account and not the latter.

2011-03-08  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreCalendarMessage.m (-save): accept entries
	with an "x500dn" record since they are now properly converted.

	* OpenChange/MAPIStoreContext.m (_convertRecipientFromRow:):
	properly find out the coordinates of internal users.

2011-03-07  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreFSFolder.m (-createMessage): fixed typo that
	was making contents messages saved in the FAI folder.

	* OpenChange/MAPIStoreContext.m (_prepareContextClass): now takes
	the context fid as argument.

	* OpenChange/MAPIStore*Context.m (+registerFixedMappings): removed
	method, made obsolete by the fact that we now receive the context
	fid during initialization.

	* OpenChange/MAPIStoreFAIMessageTable.[hm]: restored class module
	in order to reenable proper class testing during notifications.

	* OpenChange/MAPIStoreTypes.h (MAPIPropertyKey): we now make use
	of the full property tag again since the modified properties need
	to be reported during notifications.

	* OpenChange/MAPIStoreSOGo.m (sogo_pocop_open_table)
	(sogo_pocop_set_table_restrictions)
	(sogo_pocop_set_table_sort_order): new poc methods.
	(sogo_pocop_release): invoke -deactivate on the released object if
	it responds to it.

	* OpenChange/MAPIStoreContext.m (-setRestrictions:withFID:andTableType:getTableStatus:):
	(-setSortOrder:withFID:andTableType:getTableStatus:):
	(-getTableProperty:withTag:atPosition:withTableType:andQueryType:inFID:):
	adversise methods as obsolete in the log for debugging purposes.
	(_saveOrSubmitChangesInMessageWithMID:andFlags:save:): added code
	to push the relevant folder, message and table notifications.
	(-deleteMessageWithMID:inFID:withFlags:): same as above.
	(-getTable:andRowCount:withFID:tableType:andHandleId:): new pocop
	helper method to instantiate tables.

	* OpenChange/MAPIStoreTable.m (-notifyChangesForChild:): new
	method that pushes an appropriate table notification with regards
	to the child passed as parameters.
	(-deactivate): new helper method that enables the table to
	unregister itself from its container prior to be released.
	(-setHandleId): new helper accessor enabling reporting the table
	handle during notifications.

	* OpenChange/MAPIStoreObject.m (-addActiveTable:)
	(-removeActiveTable:): new methods to add or remove tables from
	the active table arrays, used later for notifications.
	(-resetNewProperties): new method to empty the "newProperties"
	dictionary once a "save changes" or a "submit" happened.

	* OpenChange/MAPIStore*Folder.m (-messageTable, -messageFAITable,
	-folderTable)
	* OpenChange/MAPIStore*Message.m (-attachmentTable): no longer
	cache the resulting table.

	* SoObjects/SOGo/SOGoCache.m
	(-unregisterObjectWithName:inContainer:): same as below.

	* SoObjects/SOGo/SOGoGCSFolder.m (-removeChildRecordWithName:):
	new method to ensure a child records is removed from the cache
	when modified or deleted.

2011-03-04  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* SoObjects/Appointments/SOGoAppointmentFolder.h/m:
	-importCalendar: we now also import the timezone definition
	when present
	* SoObjects/SOGo/SQLSource.m
	We now consider the domain belonging to the SQLSource instance

2011-02-25  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreMailContext.[hm]: renamed from
	MAPIStoreMailBaseContext and merged in all subclass modules due to
	their small size.

2011-02-24  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreTypes.m (NSObjectFromStreamData): convert
	read PT_UNICODE stream data as UTF-16.

	* OpenChange/MAPIStoreContext.m
	(-setProperty:withFMID:ofTableType:fromFile:): considering the
	cached message as a MAPIStoreMessage instance instead of NSDictionary.

	* OpenChange/MAPIStoreMailMessage.m
	(_fetchAttachmentPartsInBodyInfo:withPrefix:): detect attachment
	parts based on the existence of the "filename" info parameter.

	* OpenChange/MAPIStoreTable.m: refactored class to be used as an
	accessor on MAPIStoreFolder or other MAPIStoreObject derivatives
	based on a defined set of methods. Now strictly handle the sorting
	and filtering of folder entries, the getting of properties having
	been moved to the MAPIStoreMessage classes.

	* OpenChange/SOGoMAPIFSMessage.m (-appendProperties:): new name
	for "setMAPIProperties:"
	(-save): new name for "MAPISave", since those were methods
	ususally found in the obsolete category modules.

	* OpenChange/MAPIStoreSOGo.m:
	(sogo_pocop_get_attachment_table, sogo_pocop_get_attachment)
	(sogo_pocop_create_attachment, sogo_pocop_set_table_columns)
	(sogo_pocop_get_table_row, sogo_pocop_get_properties)
	(sogo_pocop_set_properties, sogo_pocop_release): new backend
	methods (with counterparts in SOGoContext) that are used as part
	of the new proof-of-concept API, where objects are accessed
	directly from memory instead of needed to be resolved via their
	fid, mid or aid identifiers.

	* OpenChange/MAPIStoreAttachment.m: new super class, derived from
	MAPIStoreObject and used for MAPI attachment objects.

	* OpenChange/MAPIStoreFolder.m: new super class used as wrapper
	around SOGoFolder objects, by decoupling the code previously found
	in the SOGo*Context classes and which implement basic and uniform
	content key facilities.

	* OpenChange/MAPIStoreMessage.m: new super class used for
	wrapper objects replacing the category modules on the SOGoObject.

	* OpenChange/MAPIStoreObject.m: new super class used as base the
	MAPI objects counterparts (MAPIStoreMessage, MAPIStoreFolder and
	MAPIStoreAttachment).

	* SoObjects/Contacts/SOGoContactGCSEntry.m
	(-saveContentString:baseVersion:): release the "card" ivar to
	avoid caching issues.

	* SoObjects/Appointments/SOGoTaskObject.m
	(-saveContentString:baseVersion:): same as below.

	* SoObjects/Appointments/SOGoAppointmentObject.m
	(-saveComponent:): release fullCalendar, safeCalendar and
	originalCalendar after modification to avoid caching issues.

	* SoObjects/SOGo/SOGoContentObject.m (-davContentLength): return 0
	when "content" is nil to avoid a value of "(nil)".
	(-setMAPIContent:, -MAPIContent): removed obsolete methods (fixed
	hack).

	* SoObjects/Mailer/SOGoMailObject.m (_hasFlag:): put the flags in
	a cache to avoid multiple queries.

2011-02-24  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/Appointments/SOGoAppointmentFolder.m
	(-_flattenCycleRecord:forRange:intoArray:): fixed the condition
	that checks if the event lasts all-day.

2011-02-23  Ludovic Marcotte  <lmarcotte@inverse.ca>

        * We now strip the bcc header in SOGoDraftObject instead
	of doing it in SOPE. Prior to stripping the bcc header,
	we keep a copy of the message for proper saving in the
	Sent IMAP folder.

	* Improved the Installation and Configuration Guide regarding
	the SQL-based authentication sources (required database columns)
	and also the "id" uniqueness of authentication sources in general

	* UI/WebServerResources/UIxPreferences.js:
	Added many checks in case the Mail module is disabled for
	proper behavior of the Preferences panel.

2011-02-23  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/Mailer/SOGoMailObject.m (-lookupInfoForBodyPart:): we
	now compare the path with a string only if it is a string (and not
	an array).

	* SoObjects/Appointments/SOGoAppointmentFolder.m
	(-fixupCycleRecord:cycleRange:firstInstanceCalendarDateRange:withEventTimeZone:):
	avoid fixing the timezone if no event timezone is defined.

	* SoObjects/Appointments/SOGoCalendarComponent.m
	(-newOccurenceWithID): set the occurrence timezone to the user's
	timezone. This fixes an issue when accessing occurrences of a
	recurrent event.

2011-02-22  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/Scheduler/UIxCalListingActions.m (
	-_fillBlocks:withEvent:withNumber:): don't compute the block if
	the end date is before the start date. This fixes a rare segfault that
	occurs with recurrent event with multiple exceptions.

2011-02-17  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/Contacts/SOGoFolder+CardDAV.m (-parseContactFilter:):
	we now consider all DOM elements from the text-match element. This
	fixes problems when the query contains one or more HTML entities.

2011-02-17  Ludovic Marcotte  <lmarcotte@inverse.ca>

        * Modified all tools to NOT check for SOGoUserSources
	as it'll break if we are in multi-domain with no
	master sources defined.
	* Modified SOGoAuthenticator: -imapPasswordInContext: ...
	to pass the server URL and not the host particle in order
	to determine if we are using SSL or not.

2011-02-16  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/UIxPreferences.js (-appendSieveFilterRow):
	fixed a bug with IE8 that would not set the "checked" attribute
	properly on a checkbox.

2011-02-15  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* SoObjects/Appointments/SOGoCalendarComponent.m
	We add extra verifications before trying to instantiate
	SOGoEMailAlarmsManager in order to make sure
	SOGoEnableEMailAlarms was set to YES prior doing this.
	This fixes bug #1079.

2011-02-14  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/Scheduler/UIxDatePicker.m
	(-takeValuesFromRequest:inContext:): we now consider the timezone
	offset with respect to the current date, ie we properly consider daylight
	saving time offset.

2011-02-14  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreFSMessageTable.m
	(-getChildProperty:forKey:withTag:): move type conversion code
	into NSObject+MAPIStore.

	* OpenChange/NSObject+MAPIStore.[hm]: new category module that
	provides type methods common to all NSObject descendants.

	* OpenChange/MAPIStoreContext.m
	(-createMessagePropertiesWithMID:inFID:isAssociated:): create a
	fake PR_SEARCH_KEY on new message to make Outlook happy when
	composing invitations.
	(-getProperties:ofTableType:inRow:withMID:): perform property
	searches on "live messages" (unsaved ones) as well.

	* OpenChange/MAPIStoreMailMessageTable.m (-restrictedChildKeys):
	no longer excluded messages marked with "\Deleted".
	(-getChildProperty:forKey:withTag:): display the right icon for
	replied, forwarded, read/unread and deleted messages.

	* OpenChange/MAPIStoreMailFolderTable.m
	(-getChildProperty:forKey:withTag:): compute propre response for
	PR_CONTENT_UNREAD, even though this will work only for subfolders
	and mapistore v2, neither of which is supported right now...

	* SoObjects/Mailer/SOGoMailObject.m (-isNewMail, -replied)
	(-forwarded, -deleted): new accessors for the \Recent, \Answered,
	$Forwarded and \Deleted IMAP flags.

2011-02-13  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* UI/MailPartViewers/UIxMailPartViewer.m (-decodedFlatContent):
	finally make use of the -bodyDataFromEncoding: category method
	from NSData+Mail (Mailer module).
	(-flatContentAsString): moved charset-decoding code into a new
	category method named "-bodyStringFromCharset:" in NSData+Mail
	(Mailer module).

	* SoObjects/Mailer/SOGoMailObject.m (-lookupInfoForBodyPart:):
	accept "text" as path parameter and return the main bodyStructure
	in that case.

	* OpenChange/MAPIStoreMailMessageTable.m
	(-getChildProperty:forKey:withTag:): enhanced treatment of
	PR_BODY_UNICODE to accept text/plain parts when more than one is
	available, by selecting the first one only. This requires the
	prior detection of text/html parts in order to exclude the
	property or not.
	Make use of the category methods offered in NSData+Mail to
	properly decode the body data for PR_BODY_UNICODE and PR_HTML.

2011-02-11  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreContext.m
	(-getProperties:ofTableType:inRow:withMID:): small code size
	optimization.
	(-getProperty:withFMID:ofTableType:intoFile:): added support for
	NSString values.

	* OpenChange/MAPIStoreMailMessageTable.m
	(-getChildProperty:forKey:withTag:): return
	MAPI_E_NOT_ENOUGH_MEMORY for values of PR_HTML or PR_BODY_UNICODE
	that are larged than 16Kib (arbitrary limit).

	* OpenChange/MAPIStoreCalendarMessageTable.m
	(-sortIdentifierForProperty): added support for
	PidLidAppointmentEndWhole and PidLidRecurring.

	* OpenChange/MAPIStoreTable.m
	(-warnUnhandledProperty:inFunction:): renamed and made method public.

	* OpenChange/MAPIStoreGCSMessageTable.m
	(-evaluatePropertyRestriction:intoQualifier:)
	took version of method from MAPIStoreTable and modified it to
	handle all string comparisons with the "UPPER" operator.
	(-_fixedDatePropertyRestriction:): renamed version of
	evaluateDatePropertyRestriction:intoQualifier: which now returns a
	new restriction instead of repassing it to evaluatePropert...

	* OpenChange/NSAutoreleasePool+MAPIStore.m: new utility module
	that enables the reparenting of a talloc pointer to the current
	NSAutoreleasePool.

	* OpenChange/MAPIStoreContactsMessageTable.m
	(-sortIdentifierForProperty:): implemented basic table for
	supporting the sorting implied by the use of the addressbook label
	buttons.

	* OpenChange/MAPIStoreTasksMessageTable.m
	(-sortIdentifierForProperty:): implemented basic table for
	supporting common header sorts from the OL interface.

	* OpenChange/MAPIStoreCalendarMessageTable.m
	(-sortIdentifierForProperty:): implemented basic table.

	* OpenChange/MAPIStoreGCSMessageTable.m (-setSordOrder:):
	implemented overriden method, making use of the new
	"sortIdentifierForProperty:" subclass method for the mapping of
	sort fields and SQL fields.

2011-02-10  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreContactsMessageTable.m
	(-getChildProperty:forKey:withTag:): added support for the
	following props: PR_SEND_INTERNET_ENCODING, PidLidFileUnderId,
	PidLidEmail1DisplayName, PidLidEmail1EmailAddress,
	PidLidEmail2EmailAddress, PR_ACCOUNT_UNICODE,
	PR_CONTACT_EMAIL_ADDRESSES_UNICODE,
	PR_EMS_AB_TARGET_ADDRESS_UNICODE, PR_SEARCH_KEY,
	PR_MAIL_PERMISSION

	* OpenChange/MAPIStoreMessageTable.m
	(-getChildProperty:forKey:withTag:): returns a default value for
	PR_ORIG_MESSAGE_CLASS_UNICODE based of PR_MESSAGE_CLASS_UNICODE.

	* OpenChange/NSArray+MAPIStore.m (-asArrayOfUnicodeStringsInCtx:):
	new method for returning array of "PT_UNICODE" values.

2011-02-09  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreMessageTable.m
	(-getChildProperty:forKey:withTag:): removed PR_MESSAGE_CODEPAGE
	and PR_INTERNET_CPID.

	* OpenChange/MAPIStoreMailMessageTable.m
	(-getChildProperty:forKey:withTag:): removed non-unicode string
	proptags. Added support for case
	PR_RCVD_REPRESENTING_ADDRTYPE_UNICODE,
	PR_RECEIVED_BY_ADDRTYPE_UNICODE, PR_SENDER_ADDRTYPE_UNICODE,
	PR_ORIGINAL_AUTHOR_NAME_UNICODE, PR_SENDER_NAME_UNICODE,
	PR_SENDER_EMAIL_ADDRESS_UNICODE,
	PR_RECEIVED_BY_EMAIL_ADDRESS_UNICODE and
	PR_RCVD_REPRESENTING_EMAIL_ADDRESS_UNICODE.
	Removed code returning MAPI_E_NOT_ENOUGH_MEMORY when content
	values where larger than 3999 bytes.
	(_sortIdentifierForProperty:): enabled sorting on
	PR_CLIENT_SUBMIT_TIME.
	Added support for PR_INTERNET_CPID, currently returning "utf-8"
	only (65001).

2011-02-07  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreNotesMessageTable.m
	(-getChildProperty:forKey:withTag:): make PR_SUBJECT_UNICODE an
	alias to PR_NORMALIZED_SUBJECT_UNICODE.

	* OpenChange/MAPIStoreMailMessageTable.m
	(-getChildProperty:forKey:withTag:): return a proper value for
	PR_SUBJECT_PREFIX_UNICODE and PR_NORMALIZED_SUBJECT_UNICODE.

	* OpenChange/MAPIStoreMessageTable.m
	(-getChildProperty:forKey:withTag:): now return standard values
	(checked against doc) for PR_ORIGINAL_SUBJECT_UNICODE,
	PR_CONVERSATION_TOPIC_UNICODE, PR_SUBJECT_PREFIX_UNICODE and
	PR_NORMALIZED_SUBJECT_UNICODE, the two latter being common to all
	modules except MAPIStoreMailMessageTable.

	* OpenChange/MAPIStoreContext.m (-openMessage:forKey:inTable:):
	only return PR_SUBJECT_PREFIX_UNICODE,
	PR_NORMALIZED_SUBJECT_UNICODE as those are the only fields
	required by the doc.

	* OpenChange/MAPIStoreMailMessageTable.m
	(-getChildProperty:forKey:withTag:): handle PR_FLAG_STATUS and
	PR_FOLLOWUP_ICON based on the "Flagged" message flag.

	* OpenChange/SOGoMailObject+MAPIStore.m: new category module for
	handling IMAP metadata on messages.

	* OpenChange/MAPIStoreDraftsContext.m
	(-createMessageOfClass:inFolderAtURL:): implemented method to
	avoid a crash when "saving" drafts messages in Outlook.

2011-02-07  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* OpenChange/MAPIStoreDeletedItemsContext.m: now a subclass of
	MAPIStoreMailContext and make use of the trash folder as module
	folder.

	* OpenChange/MAPIStoreDraftsContext.m: now a subclass of
	MAPIStoreMailContext and make use of the drafts folder as module
	folder.

2011-02-06  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreMailMessageTable.m (-setSordOrder):
	overriden method with proper mapping of IMAP sort fields, still
	lack handling of categories.

	* OpenChange/MAPIStoreMessageTable.m (-setSortOrder:): implemented
	stub method.

	* OpenChange/MAPIStoreContext.m
	(-setSortOrder:withFID:andTableType:getTableStatus:): implemented
	backend method for sorting messages.

	* OpenChange/SOGoMAPIFSMessage.m (-MAPISave): restored old way of
	decoding the property dictionary from the property list as the
	"new method" was working around that was solved elsewhere and was
	causing trouble with value typing.

2011-02-04  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/SOGoMAPIFSMessage.m (-properties): initialize
	properties to an empty dictionary if the initialization from file
	failed.

	* OpenChange/MAPIStoreMailMessageTable.m (-childKeys)
	(-restrictedChildKeys): now only return non-deleted elements.

	* OpenChange/SOGoMAPIFSMessage.m (-MAPISave): use an alternative
	way of producing the property list file as, for some reason,
	invoking -writeToFile:atomically: can fail on NSDictionary.

	* OpenChange/MAPIStoreContext.m
	(-deleteMessageWithMID:inFID:withFlags:): we need to invoke
	-cleanupCaches on the related table to avoid listing deleted
	elements after this operation.

2011-02-03  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* OpenChange/SOGoAppointmentObject+MAPIStore.m
	(-setMAPIProperties:): added code to handle attendees. Make use of
	the new MAPIContent ivar (temp hack).

	* SoObjects/SOGo/SOGoContentObject.m (-MAPIContent)
	(-setMAPIContent:): new accessors for querying/modifying the new
	"MAPIContent" ivar, as part of a hack to enable events to be
	modified multiple times as one.

	* OpenChange/MAPIStoreCalendarContext.m
	(-openMessage:forKey:inTable:): overriden method to return
	attendees as recipients.

	* OpenChange/SOGoMAPIFSMessage.m (-delete): implemented method.
	(-setMAPIProperties:): append the new properties to the existing
	ones instead of replacing them.

	* OpenChange/MAPIStoreTable.m (-setRestrictions:): log the old
	restriction when unset.

	* OpenChange/MAPIStoreMapping.m (-unregisterURLWithID:): new
	method for removing entries from the mapping dictionaries.

	* OpenChange/MAPIStoreContext.m
	(-deleteMessageWithMID:inFID:withFlags:): implemented backend method.

2011-02-03  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreContext.m
	(_saveOrSubmitChangesInMessageWithMID:andFlags:save:): silently
	ignore "IPM.Schedule.Meeting.Request" messages from Outlook
	and return a success code.

	* SoObjects/SOGo/WOResourceManager+SOGo.m: new category module
	defining methods useful to the vanilla and OpenChange frontends.
	(-localeForLanguageNamed:): method moved from SOGo.m.

2011-02-01  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* SoObjects/SOGo/NSString+Utilities.h,m: Fixed
	the salt for crypt-based encoding

2011-02-01  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/scriptaculous/dragdrop.js (-updateDrag:):
	fixed JavaScript error with Offset object. This object is now
	casted as an array.

	* UI/WebServerResources/MailerUI.js (-startDragging): improved
	behavior of drag and drop.

2011-01-28  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/MailerUI.js (-onDocumentKeydown): set
	the global variables lastClickedRow and lastClickedRowId to fix
	the behavior of subsequent selections of multiple messages.
	(-configureMessageListEvents): set the table listener on mouseup
	instead of mousedown to improve the drag'n'drop experience.

2011-01-27  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/SOGo/LDAPSource.m
	(-checkLogin:password:perr:expire:grace:): the caching of the DN
	is now performed only if the DN was found.

	* SoObjects/Mailer/SOGoDraftObject.m (-save): we no longer use the
	relative URL of the draft folder when it must be created. This
	fixes an issue when using a subfolder as the drafts folder.

2011-01-26  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/Scheduler/UIxComponentEditor.m (-setComponent:): retrieve the
	organizer from the master component when not present in the
	current component.

2011-01-24  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/SOGo/LDAPSource.m (_qualifierForFilter:): added
	support for the parameter "SearchFieldNames" that can be added to
	the source defaults to specify which LDAP attributes to use when
	filtering contacts. It defaults to the previous values, ie sn,
	displayname, and telephonenumber.

2011-01-21  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/Appointments/iCalRepeatableEntityObject+SOGo.m
	(-doesOccurOnDate:): we set the timezone of floating all-day
	events to the one of the date passed as argument.

	* UI/Scheduler/UIxAppointmentEditor.m (-defaultAction): when
	dealing with "floating" start dates (no timezone), we convert it to
	the user's timezone.

	* SoObjects/Appointments/SOGoAppointmentFolder.m
	(:_flattenCycleRecord:forRange:intoArray:): we must set the
	timezone of floating all-day events to the user's timezone.
	(_flattenCycleRecords:fetchRange:): Adjust the range so it ends at
	midnight. This is necessary when calculating recurrences of all-day events.

2011-01-17  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/Appointments/SOGoEMailAlarmsManager.m
	(-_lookupEntityMatchingRecord:inCalendar:): We check if
	recurrenceId is nil prior calling -timeIntervalSince1970.

2011-01-14  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/Appointments/iCalRepeatableEntityObject+SOGo.m
	(-doesOccurOnDate:): exception rules be adjusted to the event's
	timezone since the recurrence calculation is also based on the
	event's timezone.

	* SoObjects/Appointments/SOGoAppointmentFolder.m
	(-_flattenCycleRecord:forRange:intoArray:): idem.

2011-01-14  Ludovic Marcotte  <lmarcotte@inverse.ca>

        * Work on the OpenChange backend: added more property
	support such as priority for tasks, events and mails,
	secondary email address support for contacts, nickname
	and birthday support for contacts and a few more or
	some fixes there and there.
	* OpenChange/SOGoMAPIFSMessage.m: -MAPISave added a hack
	to AVOID saving informations on the fs when dealing
	with the "inbox" folder - as it'll crash Outlook upon
	next restarts
	* Added OpenChange/MAPIStoreNotesMessageTable.{h,m} to
	later extend and improve Notes support.

2011-01-13  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/Appointments/iCalRepeatableEntityObject+SOGo.m
	(-doesOccurOnDate:): the date to verify must be adjusted to the
	event's timezone before performing the calculation of the
	recurrence rule.

	* SoObjects/Appointments/iCalEvent+SOGo.m (-firstOccurenceRange):
	extract the original start and end dates from the event, based on
	the event's timezone.

	* SoObjects/Appointments/SOGoAppointmentFolder.m
	(-fixupCycleRecord:cycleRange:firstInstanceCalendarDateRange:withEventTimeZone:):
	the event dates must be first be adjusted to the event's timezone
	before being adjusted to the user's timezone.
	(-_flattenCycleRecord:forRange:intoArray:): the calculation of the
	occurrences must be performed with respect to the event's
	timezone, not the user's timezone.

	* SoObjects/Appointments/SOGoAppointmentObject.m
	(-newOccurenceWithID:): new occurrences are now independant of the
	user's timezone.

2011-01-11  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* OpenChange/MAPIStoreContactsMessageTable.m
	Added more properties: home/work URL, nickname
	and department.

2011-01-11  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/SOGoTaskObject+MAPIStore.m (-setMAPIProperties):
	release fullCalendar and safeCalendar to force a rebuild of
	the root object when next requested.

	* OpenChange/SOGoAppointmentObject+MAPIStore.m (-setMAPIProperties):
	idem.

	* OpenChange/MAPIStoreContext.m
	(-createMessagePropertiesWithMID:inFID:isAssociated:): added a
	retain count handling.
	(-releaseRecordWithFMID:ofTableType:): same as above.
	(-_saveOrSubmitChangesInMessageWithMID:andFlags:save:): cleanup
	table caches even for modifications.

	* OpenChange/MAPIStoreMessageTable.m
	(-getChildProperty:forKey:withTag:): fixed PR_ACCESS and
	PR_ACCESS_LEVEL to avoid displaying the "read-only" status.

	* OpenChange/MAPIStoreTable.m (-cleanupCaches): remove lastChild
	from cache too.

	* OpenChange/MAPIStoreTasksMessageTable.m
	(-getChildProperty:forKey:withTag:): fixed typo affecting
	PidLidTaskStatus.

	* OpenChange/MAPIStoreContext.m (-openMessage:withMID:inFID:):
	create a message dictionary in the message cache in order to
	enable modifications.

	* OpenChange/MAPIStoreContactsMessageTable.m
	(-_element:ofType:excluding:inCard:): new version of the previous
	-_phoneOfType:excluding:inCard: method, which now returns the
	requested element rather than it's first value and which enables
	the specification of the tag.
	(-getChildProperty:forKey:withTag:): added support for
	PidLidPostalAddressId, PR_POSTAL_ADDRESS_UNICODE,
	PR_POST_OFFICE_BOX_UNICODE, PR_STREET_ADDRESS_UNICODE,
	PR_LOCALITY_UNICODE, PR_STATE_OR_PROVINCE_UNICODE,
	PR_POSTAL_CODE_UNICODE, PR_COUNTRY_UNICODE, PidLidWorkAddress,
	PidLidWorkAddressPostOfficeBox, PidLidWorkAddressStreet,
	PidLidWorkAddressCity, PidLidWorkAddressState,
	PidLidWorkAddressPostalCode and PidLidWorkAddressCountry.

	* OpenChange/MAPIStoreContext.m (-openMessage:forKey:inTable:):
	avoid taking NULL values into account when returning the basic
	properties.

	* OpenChange/SOGoContactGCSEntry+MAPIStore.m
	(-setMAPIProperties:): added support for work address and its
	corresponding addresse label. Preliminary support for
	"PidLidPostalAddressId" which enables us to set a certain address
	as preferred.
	Carefully replace existing handled fields to avoid removing them
	during modification.

2011-01-10  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreContext.m (-typeLessTag:): removed method as
	types are now determined from openchange core.

2011-01-07  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreContext.m (_typeLessTag:): new method
	designed to return a known value type for typeless tags that were
	requested via getprops. This abstract the missing type from the
	call to getChildProperty:...

	* OpenChange/MAPIStoreMessageTable.m
	(-getChildProperty:forKey:withTag:): added generic values for some
	standard props.

	* OpenChange/SOGoAppointmentObject+MAPIStore.m: same as below.

	* OpenChange/SOGoTaskObject+MAPIStore.m (-setMAPIProperties:): set
	a value for CREATED and DTSTAMP

2011-01-05  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreTasksMessageTable.m
	(-getChildProperty:forKey:withTag:): silently returns
	MAPI_E_NOT_FOUND when the completion date is not available. Added
	stubs for PidLidTaskMode, PidLidTaskFRecurring,
	PidLidTaskActualEffort and PidLidTaskEstimatedEffort.

	* OpenChange/MAPIStoreFolderTable.m
	(-backendIdentifierForProperty:): new overriden method to avoid an
	exception under certain circumstances.

	* OpenChange/SOGoMAPIFSMessage.m (-MAPISave): make use of
	"ensureDirectory" on the container folder to avoid errors with
	NSDictionary failing to save itself to the filesystem.

	* OpenChange/SOGoMAPIFSFolder.m (-ensureDirectory): method made
	public and which ensures that the directory pointed to by the
	instances of this class does exist.

	* OpenChange/SOGoContactGCSEntry+MAPIStore.m (-setMAPIProperties):
	take  "PidLidEmail1EmailAddress" id as key for the contact email
	address.

2011-01-05  Ludovic Marcotte  <lmarcotte@inverse.ca>

        * SoObjects/SOGo/SQLSource.m - we now honor the "mail" column
	and we also support "MailFieldNames" in the SQL source - which
	is essentially and array of column names holding additonnal email
	addresses of users (beside the "mail" column). Also updated
	the documentation to reflect this change.

2011-01-05  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/SOGoAutoCompletion.js (onKeydown): added
	support for the delete key (confirmed value was not reset and
	therefore used as the field value when loosing focus).

	* UI/WebServerResources/generic.js (showConfirmDialog): buttons
	callbacks must be updated when retrieving dialog box from cache.

2011-01-03  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreContactsMessageTable.m
	(-getChildProperty:forKey:withTag:): result the same value for
	"PR_SUBJECT" as for "PR_DISPLAY_NAME_UNICODE" instead of a stub
	string.

2010-12-30  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreMailMessageTable.m
	(-getChildProperty:forKey:withTag:): return "NO" for
	PR_REPLY_REQUESTED and PR_RESPONSE_REQUESTED. Commented out
	responses for "PidLidHeaderItem" and "PidLidRemoteTransferSize".
	Return "PR_ORIGINAL_DISPLAY_TO/CC/BCC_UNICODE" based on their
	non-"ORIGINAL" counterpart and return an empty string when
	missing.
	Modified the return code of "PR_RTF_COMPRESSED" to
	"MAPI_E_NOT_FOUND".

	* OpenChange/MAPIStoreTypes.m (NSObjectFromSPropValue)
	(NSObjectFromMAPISPropValue): force booleans to be int to avoid
	creating EOQualifier values where the strings "YES" or "NO" appear
	as a result to "stringValue".

	* OpenChange/SOGoTaskObject+MAPIStore.m
	(-setMAPIProperties:): same as below.

	* OpenChange/SOGoAppointmentObject+MAPIStore.m
	(-setMAPIProperties:): make use of proper named properties macro
	symbols rather than their values, now that they are handled better
	in the openchange core.

	* OpenChange/SOGoMAPIFSFolder.m (-initWithURL:andTableType:):
	accepts a new "tableType" parameter to store messages in a
	different place of the fs folder hierarchy.

	* OpenChange/NSValue+MAPIStore.m (-asDoubleInMemCtx): really
	returns a double rather than an uint64_t.

	* OpenChange/MAPIStoreTypes.m (MAPIDoubleValue): new wrapper
	methods for generating data of "double" type.
	(NSObjectFromMAPISPropValue, NSObjectFromSPropValue): now handle
	the PT_CLSID mapi type.
	(
	(MAPIStoreDumpMessageProperties): enhanced logging of property
	keys.

	* OpenChange/NSData+MAPIStore.m (+dataWithFlatUID)
	(-asFlatUIDInMemCtx:, +dataWithGUID:, asGUIDInMemCtx:): new
	methods for handling the two GUID mapistore types.

	* OpenChange/MAPIStoreContext.m
	(-createMessageOfClass:inFolderAtURL:): renamed from
	"-createMessageInFolder:", taking an additional message class
	parameter that enables the subclasses to accept or deny a message
	creation.

	* OpenChange/EOQualifier+MAPIFS.m (-evaluateMAPIFSMessage:): added
	logging for easier debugging.

	* OpenChange/MAPIStoreSentItemsContext.[hm]: class is now derived
	from MAPIStoreMailContext and set up its module folder to the
	user-configured sentFolder of his/her default account.

	* OpenChange/MAPIStoreMailFolderTable.[hm]: new class module
	subclassed from MAPIStoreFolderTable, that provides the interface
	for folders in MAPIStoreMailContext.

	* OpenChange/MAPIStoreMailContext.m: Old table methods (see
	below) split into the new "MAPIStoreMailMessageTable" class.
	(+registerFixedMappings:): changed handled uri to
	@"sogo://openchange:openchange@inbox/".

	* OpenChange/MAPIStoreGCSBaseContext.m: Old table methods (see
	below) split into the new "MAPIStoreGCSMessageTable" class.

	* OpenChange/MAPIStoreContactsContext.m: Old table methods (see
	below) split into the new "MAPIStoreContactsMessageTable" class.
	(+registerFixedMappings:): changed handled uri to
	@"sogo://openchange:openchange@contacts/".

	* OpenChange/MAPIStoreTasksContext.m: Old table methods (see
	below) split into the new "MAPIStoreTasksMessageTable" class.
	(+registerFixedMappings:): changed handled uri to
	@"sogo://openchange:openchange@tasks/".

	* OpenChange/MAPIStoreCalendarContext.m: Old table methods (see
	below) split into the new "MAPIStoreCalendarMessageTable" class.
	(+registerFixedMappings:): changed handled uri to
	@"sogo://openchange:openchange@calendar/" as we now consider that
	the "host" part of the uri names the context that handles it.

	* OpenChange/MAPIStoreFAIMessageTable.[hm]: new class module,
	subclassed from MAPIStoreFSMessageTable, that provides the
	interface for FAI messages in MAPIStoreContext.

	* OpenChange/MAPIStoreFSBaseContext.[hm]: renamed from
	MAPIStoreFileSystemBaseContext. Old table methods (see below)
	split into the new "MAPIStoreFSMessageTable" class.

	* OpenChange/MAPIStoreSOGo.m (sogo_op_openmessage): added some
	debugging.
	(sogo_op_createmessage): takes a new "associated" flag parameter.

	* OpenChange/MAPIStoreContext.m: refactored to extract the table
	handling code into a separate class. This enables the introduction
	of real classes for contents tables, folder tables and FAI tables,
	as well as any other type that could be handled later. Changes:
	- new messageTableClass and folderTableClass methods for
	determining the class that is appropriate to the current datatype.
	- new messageTable, folderTable ivars.
	- new faiTable ivar, always an instance of
	MAPIStoreFAIMessageTable.
	- created MAPIStoreTable, subclassed into MAPIStoreMessageTable
	and MAPIStoreFolderTable from which appropriate subclasses are
	derived for handling mails, tasks or calendar items.
	- renamed
	"getMessageTableChildproperty:atURL:withTag:inFolder:withFID:" and
	"getFolderTableChildproperty:atURL:withTag:inFolder:withFID:" to
	the simpler "getChildProperty:forKey:withTag:" form and moved them
	to the MAPIStoreTable class.
	- moved "-setRestrictions:" to MAPIStoreTable.
	- renamed "getFolderMessageKeys:matchingQualifier:" to
	"cachedChildKeys" and "cachedRestrictedChildKeys" and moved them
	to MAPIStoreTable.
	- moved all the "evaluateRestriction:intoQualifier:" methods to
	MAPIStoreTable.
	(-createMessagePropertiesWithMID:inFID:isAssociated:): now takes a
	"isAssociated" parameter to determine whether the message is part
	of the contents table or the fai table.

	* OpenChange/EOBitmaskQualifier.m (-description): new method.

2010-12-29  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* Moved the string encryption code from SoObjects/SOGo/SQLSource.m
	to SoObjects/SOGo/NSString+Utilites.m
	* SoObjects/SOGo/SOGoUserManager.m: We now store the passwords
	in memcached as a SHA1 encrypted string.

2010-12-28  Ludovic Marcotte  <lmarcotte@inverse.ca>

        * Implemented secured sessions. We no longer store in the
	browser's cookie the base64 encoded version of username:password
	You MUST now set OCSSessionsFolderURL to a value like:
	postgresql://sogo:sogo@127.0.0.1:5432/sogo/sogo_sessions_folder
	and the database table will be created automatically upon
	next SOGo's startup.

2010-12-23  Ludovic Marcotte  <lmarcotte@inverse.ca>

        * Added the /SOGo/so/<user>/Calendar/reloadWebCalendarsAndRedirect
	action which is particularly useful for WebAuth users

2010-12-17  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStore*Context.m: added handling of a few more
	filters and a few more properties, in particular "named
	properties".

2010-12-14  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreContext.m
	(-evaluateBitmaskRestriction:intoQualifier:): implemented method.
	(-releaseRecordWithFMID:ofTableType:): return MAPI_E_SUCCESS even
	when the message passed as parameter was not found.

	* OpenChange/MAPIStoreMailContext.m
	(-evaluateContentRestriction:intoQualifier:): new overriden method
	handling tests on the PR_MESSAGE_CLASS_UNICODE property.

	* OpenChange/EOQualifier+MAPIFS.m (-[EOBitmaskQualifier
	_evaluateMAPIFSMessageProperties:]): new method adapted to the new
	class below.

	* OpenChange/EOBitmaskQualifier.[hm]: new class module
	implementing a new EOQualifier subclass that's adapted to the MAPI
	bitmask restrictions.

2010-12-14  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* Implemented the "bindAsCurrentUser" feature (when
	set to the LDAP SOGoUserSources, to YES) which forces
	SOGo to use the DN of the currently "requesting" user
	to perform all LDAP-related operations

2010-12-13  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/EOQualifier+MAPIFS.[hm]: new category module for
	evaluating qualifiers with regards to SOGoMAPIFSMessage objects.

	* OpenChange/MAPIStoreGCSBaseContext.[hm]: new class module
	containing all the code common to SOGoGCSFolder-based context
	classes, in particular with regards to restriction handling.

	* OpenChange/MAPIStoreContext.m (-init): added new
	"restrictedMessageCache" dictionary to retain the ids matching the
	active restriction filter and "parentFoldersBag" array to retain
	folder objects that are parents of the module folder.

	(-getCommonTableChildproperty:atURL:withTag:inFolder:withFID:):
	added handling for PR_SEARCH_KEY.
	(-evaluateContentRestriction:intoQualifier:)
	(-evaluateExistRestriction:intoQualifier:) implemented fallback
	code.
	(-getTableProperty:withTag:atPosition:withTableType:andQueryType:inFID:):
	added the new 'query_type' parameter, as required by the upstream
	changes. Adapted the code to check if the active row matches the
	filter (live filtering) or to return a pre-filtered set of rows
	altogether.
	(-releaseRecordWithFMID:ofTableType:) implementation of
	op_release_record.

	* OpenChange/MAPIStoreMapping.m (MAPIStoreMappingInitDictionary):
	new function used during the instance initialization to fetch
	pre-existing ids from tdb index.

	* OpenChange/MAPIStoreTypes.h (MAPIPropertyKey): renamed from
	MAPIPropertyNumber, changed behaviour to only take the 2 msb into
	account to generate a value key.

	* OpenChange/NSData+MAPIStore.m (-asShortBinaryInMemCtx:): new
	corrolary method to +dataWithShortBinary:.

	* OpenChange/MAPIStoreFileSystemBaseContext.[hm]: new base
	MAPIStoreContext class that handles requests for objects based on
	the SOGoMAPIFSFolder and SOGoMAPIFSMessage classes.

	* MAPIStoreCommonViewsContext.[hm],
	MAPIStoreDeferredActionsContext.[hm],
	MAPIStoreDeletedItemsContext.[hm], MAPIStoreDraftsContext.[hm],
	MAPIStoreFreebusyContext.[hm], MAPIStoreJournalContext.[hm],
	MAPIStoreNotesContext.[hm], MAPIStoreRemindersContext.[hm],
	MAPIStoreScheduleContext.[hm], MAPIStoreSearchContext.[hm],
	MAPIStoreSentItemsContext.[hm], MAPIStoreShortcutsContext.[hm],
	MAPIStoreViewsContext.[hm]:
	new subclasses of MAPIStoreFileSystemBaseContext.

	* OpenChange/NSValue+MAPIStore.[hm]: new category module for
	returning native MAPI types.

	* OpenChange/SOGoMAPIFSFolder.[hm]: new class module that
	implements a SOGoFolder subclass that stores and retrives data
	to/and from the file system in the form of a plist.

	* OpenChange/SOGoMAPIFSMessage.[hm]: new class module that
	implements a SOGoObject subclass that stores and retrives data
	to/and from the file system in the form of a plist.

2010-12-09  Ludovic Marcotte  <lmarcotte@inverse.ca>

        * SoObject/SOGo/SQLSource.m - added SHA password
	hash support for SQL authentication sources.
	* Added patch from bug #1048
	* SoObjects/Mailer/SOGoDraftObject.m:
	-mimeHeaderMapWithHeaders:excluding: axed the "replyTo"
	code as it was always 'empty', leading to Reply-To being
	always set to the From: address, which is rather stupid.

2010-12-08  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/MailerUI.js (onMenuEmptyTrashCallback):
	refresh the folders tree if there're folders in the trash.

2010-12-03  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreContext.m
	(-setRestrictions:withFMID:andTableType:getTableStatus:): new
	backend method that accepts a struct mapi_SRestriction * in order
	to filter the table rows.
	(-evaluateRestriction:intoQualifier:)
	(-evaluateNotRestriction:intoQualifier:)
	(-evaluateAndRestriction:intoQualifier:)
	(-evaluateOrRestriction:intoQualifier:): new low-level restriction
	handlers for converting MAPI restrictions into EOQualifier
	equivalents.
	(-evaluateContentRestriction:intoQualifier:)
	(-evaluatePropertyRestriction:intoQualifier:)
	(-evaluateBitmaskRestriction:intoQualifier:)
	(-evaluateExistRestriction:intoQualifier:) new overridable
	restriction handlers.
	(-backendIdentifierForProperty:): new overridable restriction
	helper for converting restriction attributes into database or IMAP
	fields, depending on the module in use. Used by the topmost
	version of -evaluatePropertyRestriction:intoQualifier: for
	handling "needs eval" restriction types.
	(-saveOrSubmitChangesInMessageWithMID:andFlags:save:) prevent any
	creation or modification of messages with a type attribute of
	"IPM.Microsoft.FolderDesign.NamedView", at least for now, because
	no module is able to handle those view-related messages.

	* OpenChange/MAPIStoreSpoolerContext.m: new experimental subclass
	of MAPIStoreOutboxContext.

	* OpenChange/MAPIStoreTypes.m (NSObjectFromMAPISPropValue): new
	helper function, similar in semantics to NSObjectFromSPropValue
	but taking a struct mapi_SPropValue * as parameter.

	* OpenChange/NSData+MAPIStore.m: (+dataWithShortBinary:): new
	constructor for returning an NSData instance from a struct
	SBinary_short.

2010-12-03  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/MailerUI.js
	(deleteSelectedMessagesCallback): must set the value of
	lastClickedRow and lastClickedRowId when selecting the next row.

	* UI/WebServerResources/HTMLElement.js (refreshSelectionByIds):
	log invalid references to element IDs.

2010-12-02  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* Main/SOGo+DAV.m - we avoid assuming a range is found
	and check for it, returning no location if necessary

2010-12-01  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreContext.m: prevent leaks by adding an
	additional mutable array that retains the required parent folders
	until deallocation of the context.
	(-getCommonTableChildproperty:atURL:withTag:inFolder:withFID:):
	log the name of the missing properties for easier diagnostics.

2010-11-30  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreMailContext.m
	(-getMessageTableChildproperty:atURL:withTag:inFolder:withFID:):
	when the property is larger than 4000 bytes, register it in a
	"message" dictionary and return MAPI_E_NOT_ENOUGH_MEMORY so that
	it can be fetched later via the streaming mechanism.

	* OpenChange/MAPIStoreTypes.h (MAPIPropertyNumber): changed the
	prototype to use an enum MAPITAGS instead of an int32_t.

	* OpenChange/MAPIStoreContext.m
	(-getFolderTableChildproperty:atURL:withTag:inFolder:withFID:)
	(-getMessageTableChildproperty:atURL:withTag:inFolder:withFID:)
	(-getCommonTableChildproperty:atURL:withTag:inFolder:withFID:):
	now return an "enum MAPISTATUS" for making debugging easier.
	(_createMessageWithMID:inFID:): display an error when the returned
	message is nil.
	(-getMessageProperties:inRow:atURL:): when an error code is
	returned from the getXXXChildProperty.. methods, the tag is set to
	its corresponding error tag and the error code is returned as a
	long value.
	(-getProperty:withFMID:ofTableType:intoFile:): implemented
	"op_get_property_into_fd" backend method.

2010-11-26  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreTypes.m (NSObjectFromStreamData): new
	function for returning an NSObject from a property tag and a data
	pointer.

	* OpenChange/MAPIStoreContext.m
	(-setProperty:withFMID:ofTableType:fromFile:): new method
	implementing the "set_property_from_fd" backend operation.

2010-11-24  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/SOGoDraftObject+MAPIStore.m: new category module.
	(-setMAPIProperties,-MAPISubmit,-MAPISave): implemented the MAPI
	methods for sending messages.

	* OpenChange/MAPIStoreSOGo.m: (sogo_op_modifyrecipients): new
	backend operation.

	* OpenChange/MAPIStoreContext.m:
	(-modifyRecipientsWithMID:inRows:withCount:): new method
	implementing the new "modifyrecipients" operation.

	* OpenChange/MAPIStoreOutboxContext.m: new class module
	implementing the "outbox" folder type, as a subclass of
	MAPIStoreMailContext.
	(-createMessageInFolder:): new method that returns an instance of
	SOGoDraftObject.

2010-11-23  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/SchedulerUI.js (deletePersonalCalendar):
	argument is now the list node instead of simply the node id. The
	confirmation callback (deletePersonalCalendarConfirm) is binded to
	this object.
	(deletePersonalCalendarConfirm): unselect and hide the calendar
	node in the list until the Ajax call returns.
	(deletePersonalCalendarCallback): remove the hidden calendar node
	on success and show it when the Ajax call failed.
	(drawNowLine): fixed the selection of the target cells.

2010-11-23  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreTypes.m (NSObjectFromSPropValue): added
	support for "PT_BINARY".

	* OpenChange/NSData+MAPIStore.m (+dataWithBinary:): new
	constructor for generating an NSData instance from a struct
	Binary_r *.

	* SoObjects/Mailer/SOGoDraftObject.m (-setIsHTML, -isHTML): new
	accessors, which enables the setting of html mode from the caller
	rather than from the user defaults.
	(-mimeMessageForContentWithHeaderMap:, -bodyPartForText): make use
	of "isHTML".

	* UI/MailerUI/UIxMailEditor.m (-setIsHTML, -isHTML): new
	accessors. The former sets the "isHTML" ivar based on a previous
	request on the latter, which actually returns the value stored in
	the user defaults. This enables the user to change composition
	type while editing a message without altering the proper logic
	underneat.
	(-_saveFormInfo): forward the value of "isHTML" to the co.

2010-11-22  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreContext.m
	(_prepareContextClass): new static function for clearing up
	+contextFromURI:inMemCtx:.
	(+registerFixedMappings:): new subclassable method.
	(_prepareContextClass): the static mappings are now initialized
	from the context class themselves, via the use of an unique
	invocation of +registerFixedMappings: when the class is
	instantiated first.
	(+MAPIModuleName): new method that returns the corresponding
	module name for parsing or constructing MAPI urls.
	(+initialize): wander the list of subclasses and construct a
	static dictionary with the help of the new method above for
	further user from +contextFromURI:inMemCtx:. This replaces the
	static code therein with a more dynamic approach.
	(-submitMessageWithMID:andFlags:): implemented method via a
	private method derived from
	-saveChangesInMessageWithMID:andFlags:, invoking -MAPISubmit on
	the resulting object.
	(-saveChangesInMessageWithMID:andFlags:) make use of the same
	private method as above, invoking -MAPISave on the resulting
	object.

	* OpenChange/SOGoTaskObject+MAPIStore.m (-setMAPIProperties:): the
	start date must be taken from the 0x811e0040 property rather than
	"PR_START_DATE" (contrary to the event properties), we now handle
	the due date (0x811f0040) as well as the task "body", set as
	comment.

2010-11-19  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreTasksContext.m (-createMessageInFolder:):
	implemented method.

	* OpenChange/SOGoTaskObject+MAPIStore.[hm]: new category
	module.
	(setMAPIProperties:): partially implemented, in order to be able
	to create basic tasks.

	* OpenChange/MAPIStoreFreebusyContext.[hm]: new class module for
	the "SCHEDULE+ FREE BUSY" public folder (0x70001).

	* OpenChange/MAPIStoreContext.m
	(-setPropertiesWithFMID:type:inRow:): renamed to
	-setPropertiesWithFMID:ofTableType:inRow:.
	(-getProperties:inRow:withMID:type:): renamed to
	-getProperties:ofTableType:inRow:withMID:.

	* OpenChange/MAPIStoreContactsContext.m (-createMessageInFolder:):
	mark new entry as new.

	* OpenChange/MAPIStoreCalendarContext.m (-createMessageInFolder:):
	implemented method.

	* OpenChange/SOGoAppointmentObject+MAPIStore.[hm]: new category
	module for SOGoAppointmentObject.
	(setMAPIProperties:): partially implemented, in order to be able
	to create basic events.

	* OpenChange/MAPIStoreTypes.m: new helper module designed to
	handle type conversion between MAPI types and NS types.

	* OpenChange/NSDate+MAPIStore: renamed back to
	NSCalendarDate+MAPIStore.

2010-11-18  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreContactsContext.m (-createMessageInFolder:):
	implemented method and returns an instance of SOGoContactGCSEntry.

	* OpenChange/SOGoContactGCSEntry+MAPIStore.m: new category module.
	(setMAPIProperties:) new method that resets the properties on the
	current object and update the corresponding record in the database.

	* OpenChange/MAPIStoreContext.m
	(-setPropertiesOfMessage:fromRow:): check the size of the integers
	on the build platform to invoke the right constructor of NSNumber.
	(-saveChangesInMessageWithMID:andFlags:): implemented method by
	looking up the requested object and creating one via "[self
	createMessageInFolder:]" if not exist. Afterwards, the MAPI props
	previously passed via setProperties.... are commited into the
	created/updated SOGo object.

	* OpenChange/MAPIStoreMailContext.m
	(-getMessageProperties:inRow:atURL:): moved method into
	MAPIStoreContext.m since it's generic enough to apply to all the
	stores.

	* OpenChange/MAPIStoreSOGo.m (sogo_create_context): we now make
	sure that the MAPIStoreContext class has been loaded. Otherwise we
	return MAPISTORE_ERROR.

	* OpenChange/MAPIApplication.m (-init): most of the setup code has
	been moved into MAPIStoreSOGo.m.

	* OpenChange/GNUmakefile: the MAPIStoreSOGo library is now just a
	wrapper that loads the new "SOGoBackend" bundle from
	SoProductRegistry.

	* SoObjects/SOGo/SOGoContentObject.m (-outlookMessageClass):
	removed useless method.

2010-11-17  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* Tests/Integration/test-davacl.py (DAVPublicAccessTest.setUp):
	renamed "init" method to "setUp" to force reinitialization of the
	client objects before each test.

2010-11-16  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* UI/WebServerResources/generic.js: (onCASRecoverIFrameLoaded):
	the ajax recovery request is now performed from a timeout attached
	to the window, to make sure it does not reference the iframe
	itself. The iframe is removed from a similar timeout, to avoid
	reference errors and a continuous spinning wheel after a recovery
	request.

2010-11-15  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/MailerUI.js (refreshMailbox): now calls
	refreshUnseenCounts so the unseen count is updated when the user
	clicks on the "Get Mail" button.

2010-11-15  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* UI/Scheduler/UIxAppointmentEditor.m (-saveAction): check the
	equality of componentCalendar and previousCalendar by comparing
	their ocsPath, since the objects themselves might be different
	instances when the current user has logged in with a different
	identifier than his/her uid.

2010-11-12  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/MailerUI.js (messageFlagCallback): now
	remove the message headers from the cache.

	* SoObjects/SOGo/SOGoGCSFolder.m
	(-folderPropertyValueInCategory:forUser:): new method that allows
	to specify the user from which to fetch the settings.

	* SoObjects/Appointments/SOGoAppointmentFolder.m
	(-includeInFreeBusy): the verification is now performed on the
	calendar owner's settings instead of the activer user's settings.

2010-11-11  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/MailerUI.js (deleteSelectedMessages):
	don't try to delete message(s) when the selected mailbox is not a
	folder.
	(deleteSelectedMessagesCallback): when automatically selecting the
	next message after deletion, invalidate this message header if it
	was unread.
	(refreshCurrentFolder): don't refresh the selected mailbox if it's
	not a folder.

	* UI/WebServerResources/SOGoDataTable.js (_emptyTable): now removes
	references to previously selected rows.

2010-11-10  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/MailerUI/UIxMailEditor.m (-sendAction): the error message (if
	any) is now translated in the HTTP response.

	* SoObjects/SOGo/SOGoMailer.m
	(:_smtpSendData:toRecipients:sender:): added exception handling
	when the smtp server is not accessible.

	* UI/WebServerResources/MailerUI.js (openMailbox): improved
	behavior when reloading the mailbox.
	(onMenuEmptyTrashCallback): new callback exclusive to the "empty
	trash" menu option; it deletes the cached data source and refresh
	the current folder instead of jumping to the inbox.

2010-11-08  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* SOPE/GDLContentStore/GCSAlarmsFolder.m
	We now check for non-nil values before calling
	-timeInterval...
	* SoObjects/Mailer/SOGoMailAccount.m
	We try to fallback to the imap server prior falling
	back to localhost

2010-11-08  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/SOGoDragHandles.js (adjust): for vertical
	drag handles, prioritize the top limit rather than the bottom one.

	* UI/WebServerResources/UIxContactEditor.js (onComboButtonClick):
	return false so the form is not submitted when the button is clicked.

	* UI/WebServerResources/ContactsUI.js
	(onCategoriesMenuPrepareVisibility): don't verify the selection if
	the list doesn't exist (happens in the contact editor).

2010-11-05  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreSOGo.m: added debugging witnesses call to
	each method.

	* OpenChange/MAPIStoreContext.m: added a private category to NSObject.
	(+[NSObject objectFromSPropValue:]) new generic constructor for
	converting mapi types to NS* types.
	(-init): added a new "messages" NSMutableDictionary ivar for
	storing messages in constructions.
	(-createMessageWithMID:inFID:): implemented method by registering
	a new message object in "messages".
	(-setPropertiesWithFMID:type:inRow:): implemented the message part
	of the method by resolving the message passed as parameter and
	passing it to the new setPropertiesOfMessage:fromRow: method.
	(-setPropertiesOfMessage:fromRow:): new method that wanders in the
	property array of the aRow parameter, converts each member via
	+[NSObject objectFromSPropValue:] and stores the result in the
	message passed as parameter.

	* OpenChange/NSDate+MAPIStore.[hm]: this module now implements a
	category for NSDate rather than NSCalendarDate.
	(+dateFromFileTime): new method that returns an NSDate from a
	struct FILETIME

	* SoObjects/Appointments/SOGoAptMailReceipt.m (-getSubject)
	(-getBody): invoked setupValues if values is nil to ensure that
	the timezone has been set properly.

2010-11-05  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/MailerUI/UIxMailListActions.m (-getSortedUIDsAction): now
	accepts the form parameter "no_headers" so only the UIDs are
	returned, without the prefetched headers.

	* UI/WebServerResources/SOGoMailDataSource.js (init): made the
	headers argument optional.
	(_loadCallback): handled the case when the server doesn't send the
	prefetched headers.

	* UI/WebServerResources/SOGoDataTable.js (_refresh): new method to
	force the refresh of the data table with the data of the data source.
	(remove): don't update the internal variables (index and count) if
	the UID was not found in the data source.

	* UI/WebServerResources/MailerUI.js (openMailbox): when reloading
	a mailbox, only fetch the messages UIDs (without the headers).
	(loadMessageCallback): only reload the headers if the seen state
	has changed.

2010-11-04  Ludovic Marcotte  <lmarcotte@inverse.ca>

	SoObjects/SOGo/SOGoMailer.m
	We stop when we see an invalid recipient and we inform the
	client back with what are the invalid recipients

2010-11-04  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* Tools/SOGoSockDOperation.m (_getFolderWithId:forUser:): invoke
	-[SOGoParentFolder lookupPersonalFolder:ignoringRights:] directly,
	in order to avoid a useless permission check.

2010-11-03  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/SOGoDataTable.js (remove): we must
	decrement the value of renderedIndex when the row removed is
	before the first rendered row. We also call deselect in order to
	update the internal array of selected rows IDs.
	(refresh): new method to force the recomputation of the top and
	bottom padding rows of the table.

2010-11-03  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* Tests/Integration/teststrings.sh: new utility script to test the
	parsability of the localization strings file.

	* UI/WebServerResources/generic.js: (onCASRecoverIFrameLoaded):
	go back to the user's page instead of the logoff page.

2010-11-02  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* Implemented http://sogo.nu/bugs/view.php?id=821

2010-11-02  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/SOGo/NSDictionary+BSJSONAdditions.[hm]:
	SoObjects/SOGo/NSScanner+BSJSONAdditions.[hm]: removed classes,
	obsoleted by the use of the SBJson library.

2010-11-01  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/MailerUI.js (mailListToggleMessagesRead):
	we now accepts an element as argument to directly set a message as
	read or unread. Also fix the bug of marking multiple messages.
	(mailListToggleMessagesFlagged): idem.
	(messageListCallback): no more observers are registered on the
	rows and cells. All events are delegated to the table.
	(onMessageSelectionChange): implemented event delegation on the
	table.
	(configureMessageListEvents): idem.

	* UI/WebServerResources/generic.js (onRowClick): we now accepts an
	element as argument, bypassing the event's target element and the
	event listener.

	* UI/MailerUI/UIxMailListActions.m (-messageSubject): we now
	escape HTML tags in the returned string.

2010-11-01  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/Appointments/SOGoAptMailUpdate.m (-setupValues): avoid
	setting values that are already set in SOGoAptMailNotification.

	* SoObjects/Appointments/SOGoAptMailDeletion.m (-getBody): added
	the same details as for the meeting invitations.

	* SoObjects/Appointments/SOGoAptMailNotification.m (-setupValues):
	merged setup code from SOGoAptMailInvitation.m.

	* UI/WebServerResources/ContactsUI.js: (resetCategoriesMenu)
	(onCategoriesMenuPrepareVisibility, onCategoriesMenuItemClick)
	(setCategoryOnNode, unsetCategoryOnNode): new methods designed to
	handle the handling of categories directly from the contacts list.

	* SoObjects/Contacts/SOGoContactGCSFolder.m (+initialize): we now
	return the "c_categories" field too.

	* UI/Contacts/UIxContactActions.m: new class module implementing
	actions on contacts.
	(-setCategoryAction, -unsetCategoryAction): new actions.

	* UI/WebServerResources/generic.js (triggerAjaxRequest): invoke
	the request callback only when set on the http object.

	* SoObjects/Mailer/SOGoMailBaseObject.m (-_createIMAP4Connection):
	we need to initialize newConnection to nil when the return
	password is nil.

2010-10-28  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/Mailer/SOGoDraftObject.m
	(-mimeHeaderMapWithHeaders:excluding:): added the X-Forward header
	with the user's IP address, if available and not equal to 'localhost'.

2010-10-28  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/Appointments/SOGoAppointmentFolders.m
	(-_migrateWebCalendarsSettings): fixed a bug where the active
	user's login name would be used as comparison prefix, leading to a
	corrupted and very long calendar key. Added code to migrate those
	previously corrupted keys to their proper form.

2010-10-27  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* UI/Contacts/UIxContactView.m (-categories): new accessor for
	displaying card categories.

	* UI/WebServerResources/UIxContactEditor.js: (onComboButtonClick):
	take the container's scrollTop into account when displaying the
	combobox menu.

2010-10-26  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/Contacts/SOGoContactSourceFolder.m
	(-lookupContactsWithFilter:onCriteria:sortBy:ordering:): added the
	handling of the new "criteria" parameter, returning an empty set
	if no known one has been passed.

	* SoObjects/Contacts/SOGoContactGCSFolder.m
	(-lookupContactsWithFilter:onCriteria:sortBy:ordering:): added the
	handling of the new "criteria" parameter, returning an empty set
	if no known one has been passed.

	* OGoContentStore/OCSContactFieldExtractor.m
	(-extractQuickFieldsFromVCard:): we now extract the list of
	categories from the vcard.

	* UI/WebServerResources/UIxPreferences.js: added code to handle
	the new "Contacts Options" tab, in particular the contacts
	categories.

	* UI/PreferencesUI/UIxPreferences.m (-languageCategories): renamed
	to "_languageCalendarCategories" as it is a private method. The
	dictionary key has also been renamed to
	"calendar_category_labels" since we now handle contact categories
	too.
	(-calendarCategoriesValue, -setCalendarCategoriesValue:): renamed
	from "categories" method.
	(-contactsCategoryList, -contactsCategoriesValue)
	(-setContactsCategoriesValue:): new methods for handling contacts
	categories in the preferences. Transfers are in JSON.

	* UI/WebServerResources/UIxContactEditor.js: (saveCategories)
	(appendCategoryInput, onComboButtonClick, onCategoryInputChange)
	(onCategoryInputFocus, regenerateCategoriesMenu)
	(onCategoryMenuEntryClick, onEmptyCategoryClick) new methods added
	for handling the contact categories.

	* UI/Contacts/UIxContactEditor.m (-dealloc): release
	addressBookItem, item, componentAddressBook and contactCategories
	ivars.
	(-setContactCategories, -contactCategories): new accessors for
	getting/setting the contact vcard categories. Transfers are made
	in JSON.
	(-contactCategoriesList): new accessor to return the list of
	categories defined in the preferences, combined with the list of
	those found int the contact.

	* SoObjects/SOGo/NSArray+Utilities.m (-mergedArrayWithArray:): new
	method that returns the contact of the current array merged with
	a unique copy of the objects of the array passed as parameter.

	* SoObjects/SOGo/SOGoUserDefaults.m (-{set}ContactsCategories):
	renamed version of the "contactCategories" accessors.

	* SoObjects/SOGo/NSString+Utilities.m (-objectFromJSONString): new
	method replacing the one below in a more generic way. I.e. the
	method will accept any JSON object as input and not only
	dictionaries.

	* SoObjects/SOGo/NSDictionary+BSJSONAdditions.m
	(+dictionaryWithJSONString:): removed method, replaced with
	the more generic -[NSString objectFromJSONString] in
	NSString+Utilities.

2010-10-25  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/SOGo/SOGoUserDefaults.m (-setContactCategories)
	(-contactCategories): new accessors for the
	"SOGoContactCategories" user default. Accept/return an array of
	strings.

	* SoObjects/Contacts/SOGoContactFolders.m
	(-setDavContactCategories, -davContactCategories): new accessors
	for the new
	"{urn:ietf:params:xml:ns:inverse-dav}contact-categories" custom
	property. Make use of the new methods above.

2010-10-25  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/Contacts/UIxContactFolderActions.m (-importLdifData:): use
	lowercase keys for the contact dictionary.

2010-10-21  Ludovic Marcotte  <lmarcotte@inverse.ca>

        * Changes required for http://sogo.nu/bugs/view.php?id=795

2010-10-19  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/SOGo/SOGoContentObject.m (-davContentLength): fixed a
	potential crash (see http://www.sogo.nu/bugs/view.php?id=915) by
	evaluating the length differently.

2010-10-15  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* UI/Scheduler/UIxCalListingActions.m (_fixDates:): restored
	deleted code, see explanation in the code.

2010-10-15  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* SoObjects/SOGo/SOGoGCSFolder.m - remove the ACL cache
	and moved it to SOGoCache with memcached support. Also
	modified _setDisplayNameFromRow: to NOT use SOGoUser
	instances and it is _very costly_ to do so.
	* SoObjects/SOGo/SOGoCache.{h,m} - added support for
	caching ACLs locally and in memcached

2010-10-15  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreContext.m (-getPath:ofFMID:withTableType:):
	returns a found path IIF the fmid matches the current context.
	Print an error message when the cause of mismatch is the lack of
	sync with the indexing file.
	(-getFoldersList:withFMDI:): returns a list IIF the FMID matches
	the current context.

	* OpenChange/MAPIStoreMapping.m (+sharedMapping): singleton
	constructor.

2010-10-14  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* UI/WebServerResources/generic.js: (triggerAjaxRequest): save the
	content in the request object in the case a retry is needed.
	(onCASRecoverIFrameLoaded): on the first retry, the content
	parameter is passed back to "triggerAjaxRequest".

	* OpenChange/MAPIStoreMailContext.m
	(-getMessageProperties:inRow:atURL:): new method.
	(-getMessageTableChildproperty:atURL:withTag:inFolder:withFID:):
	added responses for PR_BODY, PR_HTML and fake responses for
	PR_RTF_COMPRESSED, PR_RTF_IN_SYNC.

	* OpenChange/NSData+MAPIStore.m: new category module.
	(-asBinaryInMemCtx:): new method returning a struct Binary_r.

	* OpenChange/MAPIStoreMailContext.m (-openMessage:atURL:): basic
	implementation returning the "to" recipients only and a few
	unchecked tags.

	* OpenChange/MAPIStoreContext.m (-openMessage:withMID:inFID:):
	implemented method by resolving the url corresponding to the MID
	and transferring the call to the new subclassable
	"openMessage:atURL:" method.
	(-openMessage:atURL:): new subclassable method.
	(-createMessageWithMID:inFID:)
	(-saveChangesInMessageWithMID:andFlags:):
	(-submitMessageWithMID:andFlags:):
	(-getProperties:inRow:withMID:type:):
	(-getFID:byName:inParentFID:)
	(-setPropertiesWithMID:type:inRow:)
	(-deleteMessageWithMID:withFlags:): return MAPISTORE_ERROR for
	those unimplemented methods.
	(-getMessageProperties:inRow:atURL:): new subclassable method.

2010-10-14  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/MailerUI.js (updateUnseenCount): used the
	method charAt to read a string character instead of accessing it
	as an array (was not supported by IE).
	(saveAs): fixed a selection bug where only the first message would
	be saved.

	* UI/WebServerResources/UIxAttendeesEditor.js
	(performSearchCallback): improved autocompletion when changing
	field before completion has returned.

	* UI/WebServerResources/UIxMailToSelection.js (fancyAddRow): when
	using IE, the input element is now removed and created when cloning
	a row. Also convert the onFocus and onBlur attributes to
	JavaScript calls.

2010-10-13  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreMapping.m (-registerURL:): commented method out.
	(-_setupFixedMapping): new method that registers well-known ids
	with well-known urls.

	* OpenChange/MAPIStoreContext.m (+contextFromURI:): no longer
	register the URI mapping since the basic ones are always
	registered.
	(-setURI:andMemCtx:): new method,
	replacing setMemCtx, which also stores the context uri in the new
	"uri" ivar.
	(-getMessageTableChildproperty:atURL:withTag:inFolder:withFID:)
	added assertions for context id searches. Make the context id
	search without the "sogo://" prefix.
	Added missing "break" statement, leading PR_FID to get the value
	of PR_MID.
	(-parentFID): simply returns fid...
	(-getPath:ofFMID:withTableType:): implemented.
	(-getFoldersList:withFMID:): new temporary store method,
	implemented.

	* OpenChange/NSArray+MAPIStore.m: new category module.
	(-asFoldersListInCtx:): new method returning a properly populated
	"struct struct indexing_folders_list *" from an array of fids.

	* SoObjects/Mailer/SOGoMailNamespace.m (-toOneRelationshipKeys):
	removed method since it seems that certain servers allow messages
	to be put in certain "namespace folders" (like Courier IMAP).

	* SoObjects/Mailer/SOGoMailBaseObject.m (-imap4Connection): split
	initialization of the connection is the new
	"_createIMAP4Connection" method, make use of the cache below.

	* SoObjects/SOGo/SOGoCache.m (-registerIMAP4Connection:forKey:)
	(-imap4ConnectionForKey:): new accessors that enabling the
	per-request caching of IMAP4 connections, in a valid state or not.

2010-10-13  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/SOGo/LDAPSource.m (_qualifierForUIDFilter:): removed
	duplicated constraints in the filter when using bind fields.

	* UI/WebServerResources/HTMLElement.js (deselectAll): fixed a bug
	where the properties where not removed from the proper element
	(table instead of the tbody).

	* UI/Scheduler/NSArray+Scheduler.h: added index constants for
	events fields.
	(compareEventsCalendarNameAscending): new method to sort by
	calendar name.

	* UI/Scheduler/UIxCalListingActions.m: now uses the above
	mentioned constants.
	(+initialize): added calendar name to events fields.
	(eventsListAction): added sort by calendar name.

	* UI/WebServerResources/SchedulerUI.js (eventsListCallback): added
	calendar name column.
	(onCalendarSelectEvent): improved list selection.

2010-10-12  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreContext.m (-setMemCtx): argument is now of
	type "struct mapistore_context *". The new ldbCtx ivar is
	iinitialized from here.
	(-getMessageTableChildproperty:atURL:withTag:inFolder:withFID:):
	added support for PR_MESSAGE_CODEPAGE, PR_MESSAGE_LOCALE_ID,
	PR_MESSAGE_FLAGS, PR_MESSAGE_SIZE, PR_MSG_STATUS,
	PR_SUBJECT_PREFIX_UNICODE, PR_IMPORTANCE, PR_PRIORITY,
	PR_SENSITIVITY.
	Add registration of unregistered MID to ldb.
	(-getFolderTableChildproperty:atURL:withTag:inFolder:withFID:):
	Add registration of unregistered FID to ldb.

	* OpenChange/MAPIStoreCalendarContext.m: added support for case
	PR_CREATION_TIME.

	* Scripts/cas-proxy-validate.py: new script that resolve
	reentrancy issues occurring when using SOGo in CAS mode, when SOGo
	requests a PGT from the CAS server.

2010-10-11  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* UI/WebServerResources/UIxAttendeesEditor.js:
	(performSearchCallback): same as below.

	* UI/WebServerResources/SOGoAutoCompletion.js:
	(SOGoAutoCompletionInterface.performSearchCallback): when the
	match string is not found in "completeEmail" (due to a match with a
	non-displayed attribute), don't put emphasize anything
	graphically.

	* UI/WebServerResources/ContactsUI.js:
	(onToolbarWriteToSelectedContacts): display an error message when
	no contact is selected rather than composing a new message. Fixed
	the method to only have one return point.

	* UI/WebServerResources/generic.js: (triggerAjaxRequest): added an
	optional "attempt" argument that enables counting the number of
	invocations for an ajax request.
	(onCASRecoveryIFrameLoaded): don't repeat a failed request more
	than once.

	* UI/WebServerResources/HTMLElement.js:
	(Element.getSelectedNodesId): if the element has not
	"selectedIds", set "selArray" to an empty array before checking
	the "selectedElements" attribute. This enables the caller to not
	check for a "null" return value.

2010-10-08  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/generic.js (showConfirmDialog)
	(showPromptDialog): keys for cached dialogs are now build from a
	combination of the dialog title and label to avoid collisions.

	* UI/WebServerResources/SchedulerUI.js
	(deleteEventFromViewCancel): new function loaded if the user
	cancel the deletion of an event. It clears the array of events to
	delete.
	(onCalendarSelectEvent): don't clear the selection if the
	contextual menu is going to appear.

	* UI/WebServerResources/ContactsUI.js (onDocumentKeydown):
	improved character key identification to fix a bug with some
	browsers.

	* UI/WebServerResources/MailerUI.js (onDocumentKeydown): idem.

	* UI/WebServerResources/SchedulerUI.js (onDocumentKeydown): idem.

2010-10-08  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* UI/Scheduler/UIxCalDateSelector.m (-viewTimeZone): restored
	accessor, required for the proper display of the minimonth.

	* SoObjects/Appointments/SOGoAppointmentFolder.m
	(-removeFolderSettings:withReference:): new method which removes
	the settings for keys "FreeBusyExclusions", "FolderColors",
	"FolderShowAlarms", "FolderShowTasks", "InactiveFolders",
	"FolderSyncTags" and "FolderSynchronize". Code taken from
	-[SOGoGCSFolder subscribeUser:reallyDo:].

	* SoObjects/SOGo/SOGoGCSFolder.m
	(-removeFolderSettings:withReference:): new overridable method
	which enables the removal of user settings pertaining to a folder
	and its type when deleting the folder or unsubscribing from it.
	This implementation removes the folder reference from the
	"FolderDisplayNames" key.
	(-delete): make use of the new method above.

	* UI/WebServerResources/ContactsUI.js: (setEventsOnAddressBook)
	enable the "dblclick" event on non-owned addressbooks, except the
	public ones (owned by "nobody")
	(onAddressBookModify): enable the renaming of non-owned
	addressbooks, except the public ones

2010-10-06  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/SOGo/SOGoUser.m (-_appendSystemMailAccount): check
	that -[url scheme] and -[url query] are not null before the
	comparison, since nil == 0 == NSOrderedSame....

	* OpenChange/MAPIStoreContext.m:
	(-getMessageTableChildproperty:atURL:withTag:inFolder:withFID:)
	added response for PR_ROW_TYPE (always 1) and PR_DEPTH (always 0).
	(MAPIBoolValue, MAPILongValue, MAPILongLongValue): new helpers for
	talloc'd C values.

2010-10-05  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreTasksContext.m
	(-getMessageTableChildproperty:atURL:withTag:inFolder:withFID:)
	implemented the following properties: PR_SUBJECT_UNICODE,
	PR_NORMALIZED_SUBJECT_UNICODE, PR_CONVERSATION_TOPIC_UNICODE,
	0x8124000b, 0x81250040, PR_CREATION_TIME,
	PR_MESSAGE_DELIVERY_TIME, PR_CLIENT_SUBMIT_TIME,
	PR_LOCAL_COMMIT_TIME, PR_LAST_MODIFICATION_TIME, 0x81200003 as
	well as stubs for 0x68340003, 0x683a0003, 0x68410003.

2010-10-01  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* OpenChange/MAPIStoreTasksContext.[hm]: new mapi context class
	for tasks.

	* OpenChange/SOGoGCSFolder+MAPIStore.m (-componentKeysWithType:):
	new method that return the keys of components corresponding to the
	type passed as parameter.

	* OpenChange/SOGoGCSFolder+MAPIStore.[hm]: new category module.

	* OpenChange/MAPIStoreContext.m (-lookupObject): return nil when
	the parsed URL is nil.
	(-getFolderMessageKeys:): new subclass method designed to return
	the appropriate "message" keys depending on the folder type.

	* SoObjects/SOGo/SOGoObject.m (-displayName): new accessor.

2010-09-30  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* UI/WebServerResources/UIxContactsUserFolders.js:
	(onConfirmFolderSelection): fixed the regexp used when sanitizing
	a username containing a user info field.

	* SoObjects/Mailer/SOGoMailAccount.m (-identities): the account
	identities are now kept in an ivar until the account object is
	released. Moreoever, we invoke the new
	"_appendDelegatorIdentities" method when the account
	nameInContainer is "0".
	(-_appendDelegatorIdentities): new method that appends the mail
	values of all delegators for the owner user.

	* UI/WebServerResources/MailerUI.js: (onMenuAccountDelegation):
	new menu action for showing the new dialog below.
	(onAccountIconMenuPrepareVisibility): new setup function.

	* UI/MailerUI/UIxMailAccountActions.m (-addDelegateAction)
	(-removeDelegation): new action methods.

	* SoObjects/Mailer/SOGoUser+Mailer.m: new category module.
	(mailDelegators, addMailDelegator, removeMailDelegator): new
	accessors.

	* UI/MailerUI/UIxMailUserDelegationEditor.m: new window for
	choosing account delegates

	* UI/WebServerResources/UIxMailUserDelegationEditor.js: new page
	file, derived from UIxAclEditor.js.

	* SoObjects/SOGo/NSDictionary+BSJSONAdditions.m
	(+[NSMutableDictionary dictionaryWithJSONString:]): return nil
	directly if the json string is empty.

2010-09-28  Wolfgang Sourdeau  <wsourdeau@inverse.ca>

	* SoObjects/SOGo/SOGoUser.m (-_appendSystemMailAccount): cleaned
	up method by using NSNumber as class for port and removing useless
	tests on nil values.

	* UI/MailerUI/UIxMailFolderActions.m (-createFolderAction):
	modified to make use of -[SOGoMailFolder create].

	* SoObjects/Mailer/SOGoMailObject.m (-displayName): new accessor.

	* SoObjects/Mailer/SOGoMailFolder.m (-displayName): fixed accessor
	to return the real folder name rather than the nameInContainer,
	which is escaped and prefixed with "folder".
	(-create): new method intented to align the operations on this
	class to the ones in SOGoGCSFolder.

	* SoObjects/Contacts/SOGoContactGCSEntry.m (-displayName): new
	accessor.

2010-09-24  Ludovic Marcotte  <lmarcotte@inverse.ca>

        * Added caching support for LDAP-based groups
	* SoObjects/SOGo/LDAPSource.m
	Improved SafeLDAPCriteria() to properly escape '%'
	* Dropped lots of unnecessary and worthless files

2010-09-22  Francis Lachapelle  <flachapelle@inverse.ca>

	* UI/WebServerResources/ContactsUI.js
	(onToolbarDeleteSelectedContacts): delete the selected addressbook
	if no contact is selected. Also checked if rows is defined
	otherwise it would cause an error with Safari.

2010-09-20  Ludovic Marcotte  <lmarcotte@inverse.ca>

	* SoObjects/SOGo/SOGoGCSFolder.m
	(+folderWithSubscriptionReference:inContainer:)
	We now consider the localIsSubscription when
	building the folderName

2010-09-20  Francis Lachapelle  <flachapelle@inverse.ca>

	* SoObjects/SOGo/SOGoContentObject.m (-davContentLength): use UTF8
	encoding instead of latin1.

	* UI/WebServerResources/MailerUI.js (deleteWithoutTrash): new
	function used when the messages can't be copied to the trash
